##############################################################################
# Definitions for the FM33A0XXEV	
##############################################################################


#-----------------------------------------------------------------------------
# Compilation flags
#-----------------------------------------------------------------------------

#MCU compilation flags
MCU_FLAGS ?= -mcpu=cortex-m0 -mthumb -mfloat-abi=soft

BOARD_LDSCRIPT = user_app/mcu_drivers/FMSH/FM33A0xxEV/Core/gcc/fm33a06xev_flash.ld

#-----------------------------------------------------------------------------
# Hardware-specific sources
#-----------------------------------------------------------------------------
BOARD_C_SOURCES = \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_adc.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_aes.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_bstim.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_bt.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_cdif.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_cmu.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_comp.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_crc.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_dbg.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_dma.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_et.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_flash.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_gpio.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_hash.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_i2c.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_iwdt.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_lcd.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_lptim.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_lpuart.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_pae.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_pmu.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_qspi.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_rmu.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_rng.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_rtc.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_spi.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_svd.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_u7816.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_uart.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_vrtc.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Src/fm33a0xxev_wwdt.c \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Core/system_FM33A0XXEV.c \
	user_app/smtc_modem_hal/smtc_modem_hal.c\
	user_app/smtc_hal_A0/smtc_hal_adc.c\
	user_app/smtc_hal_A0/smtc_hal_bs_timer.c\
	user_app/smtc_hal_A0/smtc_hal_flash.c\
	user_app/smtc_hal_A0/smtc_hal_gpio.c\
	user_app/smtc_hal_A0/smtc_hal_lp_timer.c\
	user_app/smtc_hal_A0/smtc_hal_mcu.c\
	user_app/smtc_hal_A0/smtc_hal_rng.c\
	user_app/smtc_hal_A0/smtc_hal_spi.c\
	user_app/smtc_hal_A0/smtc_hal_trace.c\
	user_app/smtc_hal_A0/smtc_hal_uart.c\
	user_app/smtc_hal_A0/smtc_hal_watchdog.c


BOARD_ASM_SOURCES =  \
	user_app/mcu_drivers/FMSH/FM33A0xxEV/Core/gcc/startup_fm33a0xxev.s

BOARD_C_INCLUDES =  \
	-Iuser_app/mcu_drivers/FMSH/FM33A0xxEV/Core/Include \
	-Iuser_app/mcu_drivers/FMSH/FM33A0xxEV/Device/Include \
	-Iuser_app/mcu_drivers/FMSH/FM33A0xxEV/Drivers/Inc\
	-Iuser_app\
	-Iuser_app/smtc_modem_hal\
	-Iuser_app/smtc_hal_A0\
	-Iuser_app/main_examples

