/**
  ******************************************************************************
  * @file    fm33a0xxev_adc.h
  * @author  FM33A0XXEV Application Team
  * @version V1.0.0
  * @date    16-April-2020
  * @brief   This file contains all the functions prototypes for the ADC firmware library.  
  ******************************************************************************
  */
  
/* Define to prevent recursive inclusion -------------------------------------*/
 
#ifndef __FM33A0XXEV_ADC_H
#define __FM33A0XXEV_ADC_H


#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/

#include "FM33A0XXEV.h" 
   
#define	ADC_CR_ADC_IE_Pos	7	/* ADCڲۼģʽжʹ */
#define	ADC_CR_ADC_IE_Msk	(0x1U << ADC_CR_ADC_IE_Pos)

#define	ADC_CR_ACC_IE_Pos	6	/* ADCⲿۼģʽжʹ */
#define	ADC_CR_ACC_IE_Msk	(0x1U << ADC_CR_ACC_IE_Pos)

#define	ADC_CR_HPEN_Pos	3	/* ADCģʽ
0͹ģʽʱ1MHz
1߹ģʽʱ2MHz */
#define	ADC_CR_HPEN_Msk	(0x1U << ADC_CR_HPEN_Pos)
#define	ADC_CR_HPEN_1MHZ	(0x0U << ADC_CR_HPEN_Pos)	/* ͹ģʽʱ1MHz */
#define	ADC_CR_HPEN_2MHZ	(0x1U << ADC_CR_HPEN_Pos)	/* ߹ģʽʱ2MHz */

#define	ADC_CR_MODE_Pos	2	/* ADCģʽ
0ڲۼģʽ
1ⲿۼCICģʽ */
#define	ADC_CR_MODE_Msk	(0x1U << ADC_CR_MODE_Pos)
#define	ADC_CR_MODE_INNER	(0x0U << ADC_CR_MODE_Pos)	/* ڲۼģʽ */
#define	ADC_CR_MODE_EXTERNAL	(0x1U << ADC_CR_MODE_Pos)	/* ⲿۼCICģʽ */

#define	ADC_CR_RSTCTRL_EN_Pos	1	/* λʹܣMODE=1ʹⲿۼʱλ±뱣Ϊ0
0ֹⲿλ
1ⲿλ */
#define	ADC_CR_RSTCTRL_EN_Msk	(0x1U << ADC_CR_RSTCTRL_EN_Pos)
	/* ֹⲿλ */
	/* ⲿλ */

#define	ADC_CR_EN_Pos	0	/* ADCʹź
0ADCʹ
1ADCʹ

ע⣺RTCִԶ²ʱӲԶʹADC */
#define	ADC_CR_EN_Msk	(0x1U << ADC_CR_EN_Pos)
	/* ADCʹ */
	/* ADCʹ */
	/* RTCִԶ²ʱӲԶʹADC */

#define	ADC_TRIM_ADC_TRIM_Pos	0	/* ADC TRIMֵڲۼģʽ
ڲۼۼڣPeriod = TRIM*2*TADC_CLK
ۼھλTRIM=0x7FFֵʱʵۼΪ4095 cycleADCЧλ12bit */
#define	ADC_TRIM_ADC_TRIM_Msk	(0x7ffU << ADC_TRIM_ADC_TRIM_Pos)

#define	ADC_DR_ADC_DATA_Pos	0	/* ADCݣΪۼӽδ˲
MODE=0ʱΪADCڲۼӽ12bitλADC_TRIM
MODE=1ʱλADCⲿۼӽ14bitλACC_PERIOD */
#define	ADC_DR_ADC_DATA_Msk	(0xffffU << ADC_DR_ADC_DATA_Pos)

#define	ADC_ISR_INIT_RDY_Pos	9	/* ADCʼɱ־MODE=1ʱЧжϣ
0ADCδɳʼ
1ADCɳʼ

עMODE=1ADC_ENλ󣬵ȴMODE_CTRL_DELAYʱ֮󣬴˱־λʾADCڲɡMODE=0ʱʱADCڲпƣ˱־Ч */
#define	ADC_ISR_INIT_RDY_Msk	(0x1U << ADC_ISR_INIT_RDY_Pos)

#define	ADC_ISR_ACC_IF_Pos	8	/* ۼжϱ־Ӳλд1㣬д0Ч */
#define	ADC_ISR_ACC_IF_Msk	(0x1U << ADC_ISR_ACC_IF_Pos)

#define	ADC_ISR_ADC_DONE_Pos	1	/* ADCתֻжϣ
תɺźűΪߵƽֻйرADCŻ0 */
#define	ADC_ISR_ADC_DONE_Msk	(0x1U << ADC_ISR_ADC_DONE_Pos)

#define	ADC_ISR_ADC_IF_Pos	0	/* ADCתжϱ־Ӳλд1㣬д0Ч */
#define	ADC_ISR_ADC_IF_Msk	(0x1U << ADC_ISR_ADC_IF_Pos)

#define	ADC_CFGR_ACC_PERIOD_Pos	16	/* ⲿۼۼãλADC_CLK
0001023Ӧ10bit
0012047Ӧ11bit
0104095Ӧ12bit
0118191Ӧ13bit
10016383Ӧ14bit
Others4095 */
#define	ADC_CFGR_ACC_PERIOD_Msk	(0x7U << ADC_CFGR_ACC_PERIOD_Pos)
#define	ADC_CFGR_ACC_PERIOD_10BITS	(0x0U << ADC_CFGR_ACC_PERIOD_Pos)	/* 1023Ӧ10bit */
#define	ADC_CFGR_ACC_PERIOD_11BITS	(0x1U << ADC_CFGR_ACC_PERIOD_Pos)	/* 2047Ӧ11bit */
#define	ADC_CFGR_ACC_PERIOD_12BITS	(0x2U << ADC_CFGR_ACC_PERIOD_Pos)	/* 4095Ӧ12bit */
#define	ADC_CFGR_ACC_PERIOD_13BITS	(0x3U << ADC_CFGR_ACC_PERIOD_Pos)	/* 8191Ӧ13bit */
#define	ADC_CFGR_ACC_PERIOD_14BITS	(0x4U << ADC_CFGR_ACC_PERIOD_Pos)	/* 16383Ӧ14bit */

#define	ADC_CFGR_RST_CTRL_DELAY_Pos	8	/* SDADCʹܺmode_ctrlӳٳãλADC_CLK
0x00ӳ
0xFFӳ255ADC_CLK

ע⣺λֵΪ16ʱڣ޸ΪС16ֵ */
#define	ADC_CFGR_RST_CTRL_DELAY_Msk	(0xffU << ADC_CFGR_RST_CTRL_DELAY_Pos)

#define	ADC_CFGR_BUFEN_Pos	5	/* ADCͨBufferʹ */
#define	ADC_CFGR_BUFEN_Msk	(0x1U << ADC_CFGR_BUFEN_Pos)

#define	ADC_CFGR_BUFSEL_Pos	0	/* ADCͨѡ
0000ADC_IN0
0001ADC_IN1
0010ADC_IN2
0011ADC_IN3
0100ADC_IN4
0101ADC_IN5
0110ADC_IN6
0111ADC_IN7
1000ADC_IN8
1001ADC_IN9
1010ADC_IN10
1011ADC_IN11
1100ADC_IN12
1101ADC_IN13
1110VBAT
1111TS */
#define	ADC_CFGR_BUFSEL_Msk	(0xfU << ADC_CFGR_BUFSEL_Pos)
#define	ADC_CFGR_BUFSEL_ADC_IN1	(0x1U << ADC_CFGR_BUFSEL_Pos)	/* ADC_IN1 */
#define	ADC_CFGR_BUFSEL_ADC_IN2	(0x2U << ADC_CFGR_BUFSEL_Pos)	/* ADC_IN2 */
#define	ADC_CFGR_BUFSEL_ADC_IN3	(0x3U << ADC_CFGR_BUFSEL_Pos)	/* ADC_IN3 */
#define	ADC_CFGR_BUFSEL_ADC_IN4	(0x4U << ADC_CFGR_BUFSEL_Pos)	/* ADC_IN4 */
#define	ADC_CFGR_BUFSEL_ADC_IN5	(0x5U << ADC_CFGR_BUFSEL_Pos)	/* ADC_IN5 */
#define	ADC_CFGR_BUFSEL_ADC_IN6	(0x6U << ADC_CFGR_BUFSEL_Pos)	/* ADC_IN6 */
#define	ADC_CFGR_BUFSEL_ADC_IN7	(0x7U << ADC_CFGR_BUFSEL_Pos)	/* ADC_IN7 */
#define	ADC_CFGR_BUFSEL_ADC_IN8	(0x8U << ADC_CFGR_BUFSEL_Pos)	/* ADC_IN8 */
#define	ADC_CFGR_BUFSEL_ADC_IN9	(0x9U << ADC_CFGR_BUFSEL_Pos)	/* ADC_IN9 */
#define	ADC_CFGR_BUFSEL_ADC_IN10	(0xaU << ADC_CFGR_BUFSEL_Pos)	/* ADC_IN10 */
#define	ADC_CFGR_BUFSEL_ADC_IN11	(0xbU << ADC_CFGR_BUFSEL_Pos)	/* ADC_IN11 */
#define	ADC_CFGR_BUFSEL_ADC_IN12	(0xcU << ADC_CFGR_BUFSEL_Pos)	/* ADC_IN12 */
#define	ADC_CFGR_BUFSEL_VBAT	(0xeU << ADC_CFGR_BUFSEL_Pos)	/* VBAT */
#define	ADC_CFGR_BUFSEL_TS	(0xfU << ADC_CFGR_BUFSEL_Pos)	/* TS */

#define	CIC_DR_ADC_CIC_DATA_Pos	0	/* CIC˲ݣƵADCʱӺOSRͬעзʽΪƲ롣 */
#define	CIC_DR_ADC_CIC_DATA_Msk	(0xffffffU << CIC_DR_ADC_CIC_DATA_Pos)

#define	CIC_OS_ADC_CIC_OS_Pos	0	/* CIC˲offsetĴдoffsetֵӲADC_CIC_DROSԵõ޷Ž */
#define	CIC_OS_ADC_CIC_OS_Msk	(0xffffffU << CIC_OS_ADC_CIC_OS_Pos)

#define	CIC_USDR_ADC_CIC_USDR_Pos	0	/* ADC_CIC_DR + ADC_CIC_OSõ޷ */
#define	CIC_USDR_ADC_CIC_USDR_Msk	(0xffffffU << CIC_USDR_ADC_CIC_USDR_Pos)

#define	CIC_CR_CIC_EN_Pos	31	/* CIC˲ʹ (CIC enable)
0رCIC
1ʹCIC */
#define	CIC_CR_CIC_EN_Msk	(0x1U << CIC_CR_CIC_EN_Pos)
	/* رCIC */
	/* ʹCIC */

#define	CIC_CR_NS_DISC_Pos	8	/* CICʹܺ (Number of Samples to be Discarded)
ԶADCʹܺͷ0~255
Ĭֵ0x4ǰ4תӵ5ʼCIC_IF */
#define	CIC_CR_NS_DISC_Msk	(0xffU << CIC_CR_NS_DISC_Pos)

#define	CIC_CR_OVR_IE_Pos	7	/* CIC Overrun Interrupt enable
0ֹCICж
1CICж */
#define	CIC_CR_OVR_IE_Msk	(0x1U << CIC_CR_OVR_IE_Pos)
	/* ֹCICж */
	/* CICж */

#define	CIC_CR_CIC_IE_Pos	6	/* CICжʹ (CIC interrupt enable)
0ֹCICж
1CICжϣCIC_IFλʱж¼ */
#define	CIC_CR_CIC_IE_Msk	(0x1U << CIC_CR_CIC_IE_Pos)
	/* ֹCICж */
	/* CICжϣCIC_IFλʱж¼ */

#define	CIC_CR_TRUNC_Pos	3	/* ݽȡ (Truncate)սжλλ
TRUNC=0x4ս4bitADC_CIC_DATAĴ */
#define	CIC_CR_TRUNC_Msk	(0x7U << CIC_CR_TRUNC_Pos)

#define	CIC_CR_OSR_Pos	0	/*  (Over Sampling Rate)
000x8
001x16
010x32
011x64
100x128
101x256
110x512
111x1024 */
#define CIC_CR_OSR_Msk	(0x7U << CIC_CR_OSR_Pos)
#define	CIC_CR_OSR_X8	(0x0U << CIC_CR_OSR_Pos)	/* x8 */
#define	CIC_CR_OSR_X16	(0x1U << CIC_CR_OSR_Pos)	/* x16 */
#define	CIC_CR_OSR_X32	(0x2U << CIC_CR_OSR_Pos)	/* x32 */
#define	CIC_CR_OSR_X64	(0x3U << CIC_CR_OSR_Pos)	/* x64 */
#define	CIC_CR_OSR_X128	(0x4U << CIC_CR_OSR_Pos)	/* x128 */
#define	CIC_CR_OSR_X256	(0x5U << CIC_CR_OSR_Pos)	/* x256 */
#define	CIC_CR_OSR_X512	(0x6U << CIC_CR_OSR_Pos)	/* x512 */
#define	CIC_CR_OSR_X1024	(0x7U << CIC_CR_OSR_Pos)	/* x1024 */

#define	CIC_ISR_CIC_OVR_Pos	1
#define	CIC_ISR_CIC_OVR_Msk	(0x1U << CIC_ISR_CIC_OVR_Pos)

#define	CIC_ISR_CIC_IF_Pos	0
#define	CIC_ISR_CIC_IF_Msk	(0x1U << CIC_ISR_CIC_IF_Pos)
//Macro_End

/* Exported functions --------------------------------------------------------*/ 
extern void ADC_Deinit(void);

/* ADCڲۼģʽжʹ غ */
extern void ADC_CR_ADC_IE_Setable(FunState NewState);
extern FunState ADC_CR_ADC_IE_Getable(void);

/* ADCⲿۼģʽжʹ غ */
extern void ADC_CR_ACC_IE_Setable(FunState NewState);
extern FunState ADC_CR_ACC_IE_Getable(void);

/* ADCģʽ
0͹ģʽʱ1MHz
1߹ģʽʱ2MHz غ */
extern void ADC_CR_HPEN_Set(uint32_t SetValue);
extern uint32_t ADC_CR_HPEN_Get(void);

/* ADCģʽ
0ڲۼģʽ
1ⲿۼCICģʽ غ */
extern void ADC_CR_MODE_Set(uint32_t SetValue);
extern uint32_t ADC_CR_MODE_Get(void);

/* λʹܣMODE=1ʹⲿۼʱλ±뱣Ϊ0
0ֹⲿλ
1ⲿλ غ */
extern void ADC_CR_RSTCTRL_EN_Setable(FunState NewState);
extern FunState ADC_CR_RSTCTRL_EN_Getable(void);

/* ADCʹź
0ADCʹ
1ADCʹ

ע⣺RTCִԶ²ʱӲԶʹADC غ */
extern void ADC_CR_EN_Setable(FunState NewState);
extern FunState ADC_CR_EN_Getable(void);

/* ADC TRIMֵڲۼģʽ
ڲۼۼڣPeriod = TRIM*2*TADC_CLK
ۼھλTRIM=0x7FFֵʱʵۼΪ4095 cycleADCЧλ12bit غ */
extern void ADC_TRIM_Write(uint32_t SetValue);
extern uint32_t ADC_TRIM_Read(void);

/* ADCݣΪۼӽδ˲
MODE=0ʱΪADCڲۼӽ12bitλADC_TRIM
MODE=1ʱλADCⲿۼӽ14bitλACC_PERIOD غ */
extern uint32_t ADC_DR_Read(void);

/* ADCʼɱ־MODE=1ʱЧжϣ
0ADCδɳʼ
1ADCɳʼ

עMODE=1ADC_ENλ󣬵ȴMODE_CTRL_DELAYʱ֮󣬴˱־λʾADCڲɡMODE=0ʱʱADCڲпƣ˱־Ч غ */
extern FlagStatus ADC_ISR_INIT_RDY_Chk(void);

/* ۼжϱ־Ӳλд1㣬д0Ч غ */
extern void ADC_ISR_ACC_IF_Clr(void);
extern FlagStatus ADC_ISR_ACC_IF_Chk(void);

/* ADCתֻжϣ
תɺźűΪߵƽֻйرADCŻ0 غ */
extern FlagStatus ADC_ISR_ADC_DONE_Chk(void);

/* ADCתжϱ־Ӳλд1㣬д0Ч غ */
extern void ADC_ISR_ADC_IF_Clr(void);
extern FlagStatus ADC_ISR_ADC_IF_Chk(void);

/* ⲿۼۼãλADC_CLK
0001023Ӧ10bit
0012047Ӧ11bit
0104095Ӧ12bit
0118191Ӧ13bit
10016383Ӧ14bit
Others4095 غ */
extern void ADC_CFGR_ACC_PERIOD_Set(uint32_t SetValue);
extern uint32_t ADC_CFGR_ACC_PERIOD_Get(void);

/* SDADCʹܺmode_ctrlӳٳãλADC_CLK
0x00ӳ
0xFFӳ255ADC_CLK

ע⣺λֵΪ16ʱڣ޸ΪС16ֵ غ */
extern void ADC_CFGR_RST_CTRL_DELAY_Set(uint32_t SetValue);
extern uint32_t ADC_CFGR_RST_CTRL_DELAY_Get(void);

/* ADCͨBufferʹ غ */
extern void ADC_CFGR_BUFEN_Setable(FunState NewState);
extern FunState ADC_CFGR_BUFEN_Getable(void);

/* ADCͨѡ
0000ADC_IN0
0001ADC_IN1
0010ADC_IN2
0011ADC_IN3
0100ADC_IN4
0101ADC_IN5
0110ADC_IN6
0111ADC_IN7
1000ADC_IN8
1001ADC_IN9
1010ADC_IN10
1011ADC_IN11
1100ADC_IN12
1101ADC_IN13
1110VBAT
1111TS غ */
extern void ADC_CFGR_BUFSEL_Set(uint32_t SetValue);
extern uint32_t ADC_CFGR_BUFSEL_Get(void);

/* CIC˲ݣƵADCʱӺOSRͬעзʽΪƲ롣 غ */
extern uint32_t CIC_DR_Read(void);

/* CIC˲offsetĴдoffsetֵӲADC_CIC_DROSԵõ޷Ž غ */
extern void ACIC_OS_Write(uint32_t SetValue);
extern uint32_t CIC_OS_Read(void);

/* ADC_CIC_DR + ADC_CIC_OSõ޷ غ */
extern uint32_t CIC_USDR_Read(void);

/* CIC˲ʹ (CIC enable)
0رCIC
1ʹCIC غ */
extern void CIC_CR_CIC_EN_Setable(FunState NewState);
extern FunState CIC_CR_CIC_EN_Getable(void);

/* CICʹܺ (Number of Samples to be Discarded)
ԶADCʹܺͷ0~255
Ĭֵ0x4ǰ4תӵ5ʼCIC_IF غ */
extern void ACIC_CR_NS_DISC_Set(uint32_t SetValue);
extern uint32_t CIC_CR_NS_DISC_Get(void);

/* CIC Overrun Interrupt enable
0ֹCICж
1CICж غ */
extern void CIC_CR_OVR_IE_Setable(FunState NewState);
extern FunState CIC_CR_OVR_IE_Getable(void);

/* CICжʹ (CIC interrupt enable)
0ֹCICж
1CICжϣCIC_IFλʱж¼ غ */
extern void CIC_CR_CIC_IE_Setable(FunState NewState);
extern FunState IC_CR_CIC_IE_Getable(void);

/* ݽȡ (Truncate)սжλλ
TRUNC=0x4ս4bitADC_CIC_DATAĴ غ */
extern void CIC_CR_TRUNC_Set(uint32_t SetValue);
extern uint32_t CIC_CR_TRUNC_Get(void);

/*  (Over Sampling Rate)
000x8
001x16
010x32
011x64
100x128
101x256
110x512
111x1024 غ */
extern void CIC_CR_OSR_Set(uint32_t SetValue);
extern uint32_t CIC_CR_OSR_Get(void);
extern void CIC_ISR_CIC_OVR_Clr(void);
extern FlagStatus CIC_ISR_CIC_OVR_Chk(void);
extern void CIC_ISR_CIC_IF_Clr(void);
extern FlagStatus CIC_ISR_CIC_IF_Chk(void);

#ifdef __cplusplus
}
#endif

#endif /* __FM33A0XXEV_ADC_H */
