/**
  ******************************************************************************
  * @file    fm33a0xxev_aes.h
  * @author  FM33A0XXEV Application Team
  * @version V1.0.0
  * @date    16-April-2020
  * @brief   This file contains all the functions prototypes for the AES firmware library.  
  ******************************************************************************
  */
  
/* Define to prevent recursive inclusion -------------------------------------*/

#ifndef __FM33A0XXEV_AES_H
#define __FM33A0XXEV_AES_H


#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/

#include "FM33A0XXEV.h" 

//------------------------------------------------------------------------------   
typedef struct
{
	uint32_t	KEYLEN;			//AESԿȣAESEN=1ʱ޸
	uint32_t	CHMOD;			//AESģʽAESEN=1ʱ޸
	uint32_t	MODE;			//AESģʽAESEN=1ʱ޸
	uint32_t	DATATYP;		//ѡͣAESEN=1ʱ޸ġ彻ɲοAES½	
	FunState	DMAOEN;			//DMAԶʹ
	FunState	DMAIEN;			//DMAԶдʹ
	FunState	WERRIE;			//־WRERRжʹ
	FunState	RERRIE;			//־RDERRжʹ
	FunState	CCFIE;			//CCF־жʹ
	FunState	AESEN;			//AESʹ 
	
}AES_InitTypeDef;
	 
#define	AES_CR_KEYLEN_Pos	13	/* AESԿȣAESEN=1ʱ޸ġ
(Key Length)
00128bit
01192bit
10256bit
11 */
#define	AES_CR_KEYLEN_Msk	(0x3U << AES_CR_KEYLEN_Pos)
#define	AES_CR_KEYLEN_128BIT	(0x0U << AES_CR_KEYLEN_Pos)	/* 128bit */
#define	AES_CR_KEYLEN_192BIT	(0x1U << AES_CR_KEYLEN_Pos)	/* 192bit */
#define	AES_CR_KEYLEN_256BIT	(0x2U << AES_CR_KEYLEN_Pos)	/* 256bit */
#define	AES_CR_KEYLEN_	(0x3U << AES_CR_KEYLEN_Pos)	/*  */

#define	AES_CR_DMAOEN_Pos	12	/* DMAԶʹ
(DMA output enable)
0
1
λλģʽ1ģʽ3ģʽ4AESģԶAES->RAMĴģʽ2² */
#define	AES_CR_DMAOEN_Msk	(0x1U << AES_CR_DMAOEN_Pos)


#define	AES_CR_DMAIEN_Pos	11	/* DMAԶдʹ
(DMA input enable)
0
1
λΪ1ģʽ1ģʽ3ģʽ4ԼMultHģʽAESģԶRAM->AESĴģʽ2² */
#define	AES_CR_DMAIEN_Msk	(0x1U << AES_CR_DMAIEN_Pos)


#define	AES_CR_CHMOD_Pos	5	/* AESģʽAESEN=1ʱ޸ġ
(Cipher Mode)
00ECB
01CBC
10CTR
11ʹMultHģ */
#define	AES_CR_CHMOD_Msk	(0x3U << AES_CR_CHMOD_Pos)
#define	AES_CR_CHMOD_ECB	(0x0U << AES_CR_CHMOD_Pos)	/* ECB */
#define	AES_CR_CHMOD_CBC	(0x1U << AES_CR_CHMOD_Pos)	/* CBC */
#define	AES_CR_CHMOD_CTR	(0x2U << AES_CR_CHMOD_Pos)	/* CTR */
#define	AES_CR_CHMOD_MULTH	(0x3U << AES_CR_CHMOD_Pos)	/* ʹMultHģ */

#define	AES_CR_MODE_Pos	3	/* AESģʽAESEN=1ʱ޸ġ
(operation MODE)
00ģʽ1
01ģʽ2Կչ
10ģʽ3
11ģʽ4Կչ+
CTRģʽóģʽ4ԶCTRĽģʽCHMOD=2b10ʱMODE=2b11AESMODE=2b10ִС */
#define	AES_CR_MODE_Msk	(0x3U << AES_CR_MODE_Pos)
#define	AES_CR_MODE_ENCRYPT	(0x0U << AES_CR_MODE_Pos)	/* ģʽ1 */
#define	AES_CR_MODE_KEYEXP	(0x1U << AES_CR_MODE_Pos)	/* ģʽ2 */
#define	AES_CR_MODE_DECRYPT	(0x2U << AES_CR_MODE_Pos)	/* ģʽ3 */
#define	AES_CR_MODE_KEYEXPDECRYPT	(0x3U << AES_CR_MODE_Pos)	/* ģʽ4 */

#define	AES_CR_DATATYP_Pos	1	/* ѡͣAESEN=1ʱ޸ġ彻ɲοAES½ڡ
(Data type)
0032bitݲ
0116bitݰֽ
108bitֽڽ
111bitݱؽ */
#define	AES_CR_DATATYP_Msk	(0x3U << AES_CR_DATATYP_Pos)
#define	AES_CR_DATATYP_32BITNOEX	(0x0U << AES_CR_DATATYP_Pos)	/* 32bitݲ */
#define	AES_CR_DATATYP_16BITEX	(0x1U << AES_CR_DATATYP_Pos)	/* 16bitݰֽ */
#define	AES_CR_DATATYP_8BITEX	(0x2U << AES_CR_DATATYP_Pos)	/* 8bitֽڽ */
#define	AES_CR_DATATYP_1BITEX	(0x3U << AES_CR_DATATYP_Pos)	/* 1bitݱؽ */

#define	AES_CR_EN_Pos	0	/* AESʹ (AES enable)
0ʹ
1ʹ
κʱAESENλܹλAESģ
ģʽ2¸λһμɺӲԶ0 */
#define	AES_CR_EN_Msk	(0x1U << AES_CR_EN_Pos)
	/* ʹ */
	/* ʹ */

#define	AES_IER_WRERR_IE_Pos	2	/* джʹܣ1Ч(Write Error interrupt enable) */
#define	AES_IER_WRERR_IE_Msk	(0x1U << AES_IER_WRERR_IE_Pos)

#define	AES_IER_RDERR_IE_Pos	1	/* жʹܣ1Ч(Read Error interrupt enable) */
#define	AES_IER_RDERR_IE_Msk	(0x1U << AES_IER_RDERR_IE_Pos)

#define	AES_IER_CCF_IE_Pos	0	/* AESжʹܣ1Ч(Cipher Complete Interrupt enable) */
#define	AES_IER_CCF_IE_Msk	(0x1U << AES_IER_CCF_IE_Pos)

#define	AES_DIR_DIN_Pos	0	/* ĴAESҪӽʱӦüĴд4Ρ(AES Data Input)
ģʽ1ܣĴMSBLSB4д롣
ģʽ2ԿչʹĴ
ģʽ3ģʽ4ܣĴMSBLSB4д롣
MultHģʽѳACMSBLSB4д롣 */
#define	AES_DIR_DIN_Msk	(0xffffffffU << AES_DIR_DIN_Pos)

#define	AES_DOR_DOUT_Pos	0	/* ĴAESɺ󣬿ԷĴζӽܵĽ(AES Data Output)
ģʽ1ܣĴMSBLSB4ζ
ģʽ2ԿչʹĴ
ģʽ3ģʽ4ܣĴMSBLSB4
MultHģʽ洢IVRĴУȡAES_DOUTRĴ */
#define	AES_DOR_DOUT_Msk	(0xffffffffU << AES_DOR_DOUT_Pos)

#define	AES_KEY0_KEYx_Pos	0	/* AESԿ256bitAESKEY0Կ32bitAESLKEY7Կ32bit(AES Key)
ע⣺˼Ĵֻдɶ˼ĴݲWWDTλӰ */
#define	AES_KEY0_KEYx_Msk	(0xffffffffU << AES_KEY0_KEYx_Pos)

#define	AES_KEY1_KEYx_Pos	0	/* AESԿ256bitAESKEY0Կ32bitAESLKEY7Կ32bit(AES Key)
ע⣺˼Ĵֻдɶ˼ĴݲWWDTλӰ */
#define	AES_KEY1_KEYx_Msk	(0xffffffffU << AES_KEY1_KEYx_Pos)

#define	AES_KEY2_KEYx_Pos	0	/* AESԿ256bitAESKEY0Կ32bitAESLKEY7Կ32bit(AES Key)
ע⣺˼Ĵֻдɶ˼ĴݲWWDTλӰ */
#define	AES_KEY2_KEYx_Msk	(0xffffffffU << AES_KEY2_KEYx_Pos)

#define	AES_KEY3_KEYx_Pos	0	/* AESԿ256bitAESKEY0Կ32bitAESLKEY7Կ32bit(AES Key)
ע⣺˼Ĵֻдɶ˼ĴݲWWDTλӰ */
#define	AES_KEY3_KEYx_Msk	(0xffffffffU << AES_KEY3_KEYx_Pos)

#define	AES_KEY4_KEYx_Pos	0	/* AESԿ256bitAESKEY0Կ32bitAESLKEY7Կ32bit(AES Key)
ע⣺˼Ĵֻдɶ˼ĴݲWWDTλӰ */
#define	AES_KEY4_KEYx_Msk	(0xffffffffU << AES_KEY4_KEYx_Pos)

#define	AES_KEY5_KEYx_Pos	0	/* AESԿ256bitAESKEY0Կ32bitAESLKEY7Կ32bit(AES Key)
ע⣺˼Ĵֻдɶ˼ĴݲWWDTλӰ */
#define	AES_KEY5_KEYx_Msk	(0xffffffffU << AES_KEY5_KEYx_Pos)

#define	AES_KEY6_KEYx_Pos	0	/* AESԿ256bitAESKEY0Կ32bitAESLKEY7Կ32bit(AES Key)
ע⣺˼Ĵֻдɶ˼ĴݲWWDTλӰ */
#define	AES_KEY6_KEYx_Msk	(0xffffffffU << AES_KEY6_KEYx_Pos)

#define	AES_KEY7_KEYx_Pos	0	/* AESԿ256bitAESKEY0Կ32bitAESLKEY7Կ32bit(AES Key)
ע⣺˼Ĵֻдɶ˼ĴݲWWDTλӰ */
#define	AES_KEY7_KEYx_Msk	(0xffffffffU << AES_KEY7_KEYx_Pos)

#define	AES_IVR0_IVRx_Pos	0	/* AES128bitʼMultHģʽ±
(AES Initial Vector Registers) */
#define	AES_IVR0_IVRx_Msk	(0xffffffffU << AES_IVR0_IVRx_Pos)

#define	AES_IVR1_IVRx_Pos	0	/* AES128bitʼMultHģʽ±
(AES Initial Vector Registers) */
#define	AES_IVR1_IVRx_Msk	(0xffffffffU << AES_IVR1_IVRx_Pos)

#define	AES_IVR2_IVRx_Pos	0	/* AES128bitʼMultHģʽ±
(AES Initial Vector Registers) */
#define	AES_IVR2_IVRx_Msk	(0xffffffffU << AES_IVR2_IVRx_Pos)

#define	AES_IVR3_IVRx_Pos	0	/* AES128bitʼMultHģʽ±
(AES Initial Vector Registers) */
#define	AES_IVR3_IVRx_Msk	(0xffffffffU << AES_IVR3_IVRx_Pos)

#define	AES_H0_Hx_Pos	0	/* MultH128bitH (H Parameter)
H0H[31:0]H3H[127:96] */
#define	AES_H0_Hx_Msk	(0xffffffffU << AES_H0_Hx_Pos)

#define	AES_H1_Hx_Pos	0	/* MultH128bitH (H Parameter)
H0H[31:0]H3H[127:96] */
#define	AES_H1_Hx_Msk	(0xffffffffU << AES_H1_Hx_Pos)

#define	AES_H2_Hx_Pos	0	/* MultH128bitH (H Parameter)
H0H[31:0]H3H[127:96] */
#define	AES_H2_Hx_Msk	(0xffffffffU << AES_H2_Hx_Pos)

#define	AES_H3_Hx_Pos	0	/* MultH128bitH (H Parameter)
H0H[31:0]H3H[127:96] */
#define	AES_H3_Hx_Msk	(0xffffffffU << AES_H3_Hx_Pos)

#define	AES_ISR_WRERR_Pos	2	/* д־ڼ׶ηдʱλд1 */
#define	AES_ISR_WRERR_Msk	(0x1U << AES_ISR_WRERR_Pos)

#define	AES_ISR_RDERR_Pos	1	/* ־ڼ׶ηʱλд1 */
#define	AES_ISR_RDERR_Msk	(0x1U << AES_ISR_RDERR_Pos)

#define	AES_ISR_CCF_Pos	0	/* AESɱ־д1
1
0û */
#define	AES_ISR_CCF_Msk	(0x1U << AES_ISR_CCF_Pos)
//Macro_End

/* Exported functions --------------------------------------------------------*/ 
extern void AES_Deinit(void);

/* AESԿȣAESEN=1ʱ޸ġ
(Key Length)
00128bit
01192bit
10256bit
11 غ */
extern void AES_CR_KEYLEN_Set(uint32_t SetValue);
extern uint32_t AES_CR_KEYLEN_Get(void);

/* DMAԶʹ
(DMA output enable)
0
1
λλģʽ1ģʽ3ģʽ4AESģԶAES->RAMĴģʽ2² غ */
extern void AES_CR_DMAOEN_Setable(FunState NewState);
extern FunState AES_CR_DMAOEN_Getable(void);


/* DMAԶдʹ
(DMA input enable)
0
1
λΪ1ģʽ1ģʽ3ģʽ4ԼMultHģʽAESģԶRAM->AESĴģʽ2² غ */
extern void AES_CR_DMAIEN_Setable(FunState NewState);
extern FunState FunStateAES_CR_DMAIEN_Getable(void);

/* AESģʽAESEN=1ʱ޸ġ
(Cipher Mode)
00ECB
01CBC
10CTR
11ʹMultHģ غ */
extern void AES_CR_CHMOD_Set(uint32_t SetValue);
extern uint32_t AES_CR_CHMOD_Get(void);

/* AESģʽAESEN=1ʱ޸ġ
(operation MODE)
00ģʽ1
01ģʽ2Կչ
10ģʽ3
11ģʽ4Կչ+
CTRģʽóģʽ4ԶCTRĽģʽCHMOD=2b10ʱMODE=2b11AESMODE=2b10ִС غ */
extern void AES_CR_MODE_Set(uint32_t SetValue);
extern uint32_t AES_CR_MODE_Get(void);

/* ѡͣAESEN=1ʱ޸ġ彻ɲοAES½ڡ
(Data type)
0032bitݲ
0116bitݰֽ
108bitֽڽ
111bitݱؽ غ */
extern void AES_CR_DATATYP_Set(uint32_t SetValue);
extern uint32_t AES_CR_DATATYP_Get(void);

/* AESʹ (AES enable)
0ʹ
1ʹ
κʱAESENλܹλAESģ
ģʽ2¸λһμɺӲԶ0 غ */
extern void AES_CR_EN_Setable(FunState NewState);
extern FunState AES_CR_EN_Getable(void);

/* джʹܣ1Ч(Write Error interrupt enable) غ */
extern void AES_IER_WRERR_IE_Setable(FunState NewState);
extern FunState AES_IER_WRERR_IE_Getable(void);

/* жʹܣ1Ч(Read Error interrupt enable) غ */
extern void AES_IER_RDERR_IE_Setable(FunState NewState);
extern FunState AES_IER_RDERR_IE_Getable(void);

/* AESжʹܣ1Ч(Cipher Complete Interrupt enable) غ */
extern void AES_IER_CCF_IE_Setable(FunState NewState);
extern FunState AES_IER_CCF_IE_Getable(void);

/* ĴAESҪӽʱӦüĴд4Ρ(AES Data Input)
ģʽ1ܣĴMSBLSB4д롣
ģʽ2ԿչʹĴ
ģʽ3ģʽ4ܣĴMSBLSB4д롣
MultHģʽѳACMSBLSB4д롣 غ */
extern void AES_DIR_Write(uint32_t SetValue);
extern uint32_t AES_DIR_Read(void);

/* ĴAESɺ󣬿ԷĴζӽܵĽ(AES Data Output)
ģʽ1ܣĴMSBLSB4ζ
ģʽ2ԿչʹĴ
ģʽ3ģʽ4ܣĴMSBLSB4
MultHģʽ洢IVRĴУȡAES_DOUTRĴ غ */
extern uint32_t AES_DOR_Read(void);

/* AESԿ256bitAESKEY0Կ32bitAESLKEY7Կ32bit(AES Key)
ע⣺˼Ĵֻдɶ˼ĴݲWWDTλӰ غ */
extern void AES_KEY0_Write(uint32_t SetValue);

/* AESԿ256bitAESKEY0Կ32bitAESLKEY7Կ32bit(AES Key)
ע⣺˼Ĵֻдɶ˼ĴݲWWDTλӰ غ */
extern void AES_KEY1_Write(uint32_t SetValue);

/* AESԿ256bitAESKEY0Կ32bitAESLKEY7Կ32bit(AES Key)
ע⣺˼Ĵֻдɶ˼ĴݲWWDTλӰ غ */
extern void AES_KEY2_Write(uint32_t SetValue);

/* AESԿ256bitAESKEY0Կ32bitAESLKEY7Կ32bit(AES Key)
ע⣺˼Ĵֻдɶ˼ĴݲWWDTλӰ غ */
extern void AES_KEY3_Write(uint32_t SetValue);

/* AESԿ256bitAESKEY0Կ32bitAESLKEY7Կ32bit(AES Key)
ע⣺˼Ĵֻдɶ˼ĴݲWWDTλӰ غ */
extern void AES_KEY4_Write(uint32_t SetValue);

/* AESԿ256bitAESKEY0Կ32bitAESLKEY7Կ32bit(AES Key)
ע⣺˼Ĵֻдɶ˼ĴݲWWDTλӰ غ */
extern void AES_KEY5_Write(uint32_t SetValue);

/* AESԿ256bitAESKEY0Կ32bitAESLKEY7Կ32bit(AES Key)
ע⣺˼Ĵֻдɶ˼ĴݲWWDTλӰ غ */
extern void AES_KEY6_Write(uint32_t SetValue);

/* AESԿ256bitAESKEY0Կ32bitAESLKEY7Կ32bit(AES Key)
ע⣺˼Ĵֻдɶ˼ĴݲWWDTλӰ غ */
extern void AES_KEY7_Write(uint32_t SetValue);

/* AES128bitʼMultHģʽ±
(AES Initial Vector Registers) غ */
extern void AES_IVR0_Write(uint32_t SetValue);
extern uint32_t AES_IVR0_Read(void);

/* AES128bitʼMultHģʽ±
(AES Initial Vector Registers) غ */
extern void AES_IVR1_Write(uint32_t SetValue);
extern uint32_t AES_IVR1_Read(void);

/* AES128bitʼMultHģʽ±
(AES Initial Vector Registers) غ */
extern void AES_IVR2_Write(uint32_t SetValue);
extern uint32_t AES_IVR2_Read(void);

/* AES128bitʼMultHģʽ±
(AES Initial Vector Registers) غ */
extern void AES_IVR3_Write(uint32_t SetValue);
extern uint32_t AES_IVR3_Read(void);

/* MultH128bitH (H Parameter)
H0H[31:0]H3H[127:96] غ */
extern void AES_H0_Write(uint32_t SetValue);
extern uint32_t AES_H0_Read(void);

/* MultH128bitH (H Parameter)
H0H[31:0]H3H[127:96] غ */
extern void AES_H1_Write(uint32_t SetValue);
extern uint32_t AES_H1_Read(void);

/* MultH128bitH (H Parameter)
H0H[31:0]H3H[127:96] غ */
extern void AES_H2_Write(uint32_t SetValue);
extern uint32_t AES_H2_Read(void);

/* MultH128bitH (H Parameter)
H0H[31:0]H3H[127:96] غ */
extern void AES_H3_Write(uint32_t SetValue);
extern uint32_t AES_H3_Read(void);

/* д־ڼ׶ηдʱλд1 غ */
extern void AES_ISR_WRERR_Clr(void);
extern FlagStatus AES_ISR_WRERR_Chk(void);

/* ־ڼ׶ηʱλд1 غ */
extern void AES_ISR_RDERR_Clr(void);
extern FlagStatus AES_ISR_RDERR_Chk(void);

/* AESɱ־д1
1
0û غ */
extern void AES_ISR_CCF_Clr(void);
extern FlagStatus AES_ISR_CCF_Chk(void);
//Announce_End


extern void AES_KEY_WriteEx(uint8_t *KeyIn, uint8_t Len);
extern void AES_KEY_ReadEx(uint8_t *KeyOut, uint8_t Len);
extern void AES_IVR_WriteEx(uint8_t *IVRIn);
extern void AES_IVR_ReadEx(uint8_t *IVROut);
extern void AES_DIN_GroupWrite_128BIT(uint8_t *DataIn);
extern void AES_DOUT_GroupRead_128BIT(uint8_t *DataOut);
extern uint8_t AES_GroupWriteAndRead_128BIT(uint8_t *DataIn, uint8_t *DataOut);
extern uint8_t AES_GroupWriteAndRead_128BIT_IVR(uint8_t *DataIn, uint8_t *DataOut);
extern void AES_Init(AES_InitTypeDef* para);
extern void AES_Hx_WriteEx(uint8_t *HxIn, uint8_t Len);

#ifdef __cplusplus
}
#endif

#endif /*__FM33A0XXEV_AES_H */
