/**
  ******************************************************************************
  * @file    fm33a0xxev_bstim.h
  * @author  FM33A0XXEV Application Team
  * @version V1.0.0
  * @date    16-April-2020
  * @brief   This file contains all the functions prototypes for the BSTIM firmware library.  
  ******************************************************************************
  */
  
/* Define to prevent recursive inclusion -------------------------------------*/

#ifndef __FM33A0XXEV_BSTIM_H
#define __FM33A0XXEV_BSTIM_H


#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/

#include "FM33A0XXEV.h" 
   
#define	BSTIM_CR1_ARPE_Pos	7	/* Auto-reloadԤװʹ (Auto-Reload Preload Enable)
0ARRĴʹpreload
1ARRĴʹpreload */
#define	BSTIM_CR1_ARPE_Msk	(0x1U << BSTIM_CR1_ARPE_Pos)
	/* ARRĴʹpreload */
	/* ARRĴʹpreload */

#define	BSTIM_CR1_OPM_Pos	3	/* ģʽ (One Pulse Mode)
0Update Eventʱֹͣ
1Update EventʱֹͣԶCEN */
#define	BSTIM_CR1_OPM_Msk	(0x1U << BSTIM_CR1_OPM_Pos)
#define	BSTIM_CR1_OPM_CONTINUE	(0x0U << BSTIM_CR1_OPM_Pos)	/* Update Eventʱֹͣ */
#define	BSTIM_CR1_OPM_STOP	    (0x1U << BSTIM_CR1_OPM_Pos)	/* Update EventʱֹͣԶCEN */

#define	BSTIM_CR1_URS_Pos	2	/* ѡ (Update Request Select)
0¼ܹupdateж

λUGĴ
ӻupdate
1updateжϻDMA */
#define	BSTIM_CR1_URS_Msk	(0x1U << BSTIM_CR1_URS_Pos)
#define	BSTIM_CR1_URS_ALL	(0x0U << BSTIM_CR1_URS_Pos)	/* ¼ܹupdateж */
#define	BSTIM_CR1_URS_COUNT	(0x1U << BSTIM_CR1_URS_Pos)	/* updateжϻDMA */

#define	BSTIM_CR1_UDIS_Pos	1	/* ֹupdate (Update Disable)
0ʹupdate¼¼ʱupdate¼

λUGĴ
ӻupdate
1ֹupdate¼shadowĴUGλӻյӲresetʱ³ʼԤƵ */
#define	BSTIM_CR1_UDIS_Msk	(0x1U << BSTIM_CR1_UDIS_Pos)
	/* ʹupdate¼¼ʱupdate¼ */
	/* ֹupdate¼shadowĴUGλӻյӲresetʱ³ʼԤƵ */

#define	BSTIM_CR1_CEN_Pos	0	/* ʹ (Counter Enable)
0ر
1ʹ
ע⣺ⲿģʽԶλCEN */
#define	BSTIM_CR1_CEN_Msk	(0x1U << BSTIM_CR1_CEN_Pos)
	/* ر */
	/* ʹ */
	/* ⲿģʽԶλCEN */

#define	BSTIM_CR2_MMS_Pos	4	/* ģʽѡģʽӻ͵ͬźţTRGOԴ (Master Mode Select)
000BSTIM_EGRUGĴTRGO
001ʹźCNT_ENTRGOͬʱʱ
010UEupdate eventźűTRGO
011/100/111RFU

ע⣺ӻʱADCʹܹʱӣܽʱ͵TRGO */
#define	BSTIM_CR2_MMS_Msk	(0x7U << BSTIM_CR2_MMS_Pos)

#define	BSTIM_IER_UIE_Pos	0	/* Update¼жʹ (Update event Interrupt Enable)
0ֹUpdate¼ж
1Update¼ж */
#define	BSTIM_IER_UIE_Msk	(0x1U << BSTIM_IER_UIE_Pos)
	/* ֹUpdate¼ж */
	/* Update¼ж */

#define	BSTIM_ISR_UIF_Pos	0	/* Update¼жϱ־Ӳλд1㡣(Update event Interrupt Flag,write 1 to flag)
¼ʱUIFλshadowĴ
-ظ=0UDIS=0£
-URS=0UDIS=0£λUGĴʼ
-URS=0UDIS=0£¼ʼ */
#define	BSTIM_ISR_UIF_Msk	(0x1U << BSTIM_ISR_UIF_Pos)

#define	BSTIM_EGR_UG_Pos	0	/* Update¼λ˼ĴUpdate¼ӲԶ (User Generate)
λUGʱ³ʼshadowĴԤƵ㡣 */
#define	BSTIM_EGR_UG_Msk	(0x1U << BSTIM_EGR_UG_Pos)

#define	BSTIM_CNTR_CNT_Pos	0	/* ֵ (Counter) */
#define	BSTIM_CNTR_CNT_Msk	(0xffffffffU << BSTIM_CNTR_CNT_Pos)

#define	BSTIM_PSCR_PSC_Pos	0	/* ʱӣCK_CNTԤƵֵ (Counter Clock Prescaler)
fCK_CNT=fCK_PSC/(PSC[15:0]+1)
һpreloadĴupdate¼ʱݱshadowĴ */
#define	BSTIM_PSCR_PSC_Msk	(0xffffffffU << BSTIM_PSCR_PSC_Pos)

#define	BSTIM_ARR_ARR_Pos	0	/* ʱԶֵ (Auto-Reload Register)
һpreloadĴupdate¼ʱݱshadowĴ */
#define	BSTIM_ARR_ARR_Msk	(0xffffffffU << BSTIM_ARR_ARR_Pos)
//Macro_End

/* Exported functions --------------------------------------------------------*/ 
extern void BSTIM_Deinit(void);

/* Auto-reloadԤװʹ (Auto-Reload Preload Enable)
0ARRĴʹpreload
1ARRĴʹpreload غ */
extern void BSTIM_CR1_ARPE_Setable(FunState NewState);
extern FunState BSTIM_CR1_ARPE_Getable(void);

/* ģʽ (One Pulse Mode)
0Update Eventʱֹͣ
1Update EventʱֹͣԶCEN غ */
extern void BSTIM_CR1_OPM_Set(uint32_t SetValue);
extern uint32_t BSTIM_CR1_OPM_Get(void);

/* ѡ (Update Request Select)
0¼ܹupdateж

λUGĴ
ӻupdate
1updateжϻDMA غ */
extern void BSTIM_CR1_URS_Set(uint32_t SetValue);
extern uint32_t BSTIM_CR1_URS_Get(void);

/* ֹupdate (Update Disable)
0ʹupdate¼¼ʱupdate¼

λUGĴ
ӻupdate
1ֹupdate¼shadowĴUGλӻյӲresetʱ³ʼԤƵ غ */
extern void BSTIM_CR1_UDIS_Setable(FunState NewState);
extern FunState BSTIM_CR1_UDIS_Getable(void);

/* ʹ (Counter Enable)
0ر
1ʹ
ע⣺ⲿģʽԶλCEN غ */
extern void BSTIM_CR1_CEN_Setable(FunState NewState);
extern FunState BSTIM_CR1_CEN_Getable(void);

/* ģʽѡģʽӻ͵ͬźţTRGOԴ (Master Mode Select)
000BSTIM_EGRUGĴTRGO
001ʹźCNT_ENTRGOͬʱʱ
010UEupdate eventźűTRGO
011/100/111RFU

ע⣺ӻʱADCʹܹʱӣܽʱ͵TRGO غ */
extern void BSTIM_CR2_Write(uint32_t SetValue);
extern uint32_t BSTIM_CR2_Read(void);

/* Update¼жʹ (Update event Interrupt Enable)
0ֹUpdate¼ж
1Update¼ж غ */
extern void BSTIM_IER_UIE_Setable(FunState NewState);
extern FunState BSTIM_IER_UIE_Getable(void);

/* Update¼жϱ־Ӳλд1㡣(Update event Interrupt Flag,write 1 to flag)
¼ʱUIFλshadowĴ
-ظ=0UDIS=0£
-URS=0UDIS=0£λUGĴʼ
-URS=0UDIS=0£¼ʼ غ */
extern void BSTIM_ISR_UIF_Clr(void);
extern FlagStatus BSTIM_ISR_UIF_Chk(void);

/* Update¼λ˼ĴUpdate¼ӲԶ (User Generate)
λUGʱ³ʼshadowĴԤƵ㡣 غ */
extern void BSTIM_EGR_UG_Setable(FunState NewState);

/* ֵ (Counter) غ */
extern void BSTIM_CNTR_Write(uint32_t SetValue);
extern uint32_t BSTIM_CNTR_Read(void);

/* ʱӣCK_CNTԤƵֵ (Counter Clock Prescaler)
fCK_CNT=fCK_PSC/(PSC[15:0]+1)
һpreloadĴupdate¼ʱݱshadowĴ غ */
extern void BSTIM_PSCR_Write(uint32_t SetValue);
extern uint32_t BSTIM_PSCR_Read(void);

/* ʱԶֵ (Auto-Reload Register)
һpreloadĴupdate¼ʱݱshadowĴ غ */
extern void BSTIM_ARR_Write(uint32_t SetValue);
extern uint32_t BSTIM_ARR_Read(void);
//Announce_End
#ifdef __cplusplus
}
#endif

#endif /* __FM33A0XXEV_BSTIM_H */
