/**
  ******************************************************************************
  * @file    fm33a0xxev_bt.h
  * @author  FM33A0XXEV Application Team
  * @version V1.0.0
  * @date    16-April-2020
  * @brief   This file contains all the functions prototypes for the BT firmware library.  
  ******************************************************************************
  */
  
/* Define to prevent recursive inclusion -------------------------------------*/

#ifndef __FM33A0XXEV_BT_H
#define __FM33A0XXEV_BT_H


#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/

#include "FM33A0XXEV.h" 
   
#define	BTx_CR1_CHEN_Pos	7	/* 8λBT1HBT2H  */
#define	BTx_CR1_CHEN_Msk	(0x1U << BTx_CR1_CHEN_Pos)

#define	BTx_CR1_CLEN_Pos	6	/* 8λBT1LBT2L
(Counter-Lowend enable)
18bitڼģʽʱԤֵͼֱֵͱȽϼĴ׽ģʽʱ㿪ʼɼ0xFFFFźȻ㿪ʼ¼׽ֻ16λģʽ16λĶʱ/Ͳ׽ģʽCHENΪƣCLENԶʧЧ
0ֹͣ8bit */
#define	BTx_CR1_CLEN_Msk	(0x1U << BTx_CR1_CLEN_Pos)
	/* 8bitڼģʽʱԤֵͼֱֵͱȽϼĴ׽ģʽʱ㿪ʼɼ0xFFFFźȻ㿪ʼ¼׽ֻ16λģʽ16λĶʱ/Ͳ׽ģʽCHENΪƣCLENԶʧЧ */
	/* ֹͣ8bit */

#define	BTx_CR1_MODE_Pos	5	/* ģʽѡ (work mode)
116λ׽ģʽ
08λʱ/ģʽλԴѡΪλźţʵ16λʱ/ģʽ */
#define	BTx_CR1_MODE_Msk	(0x1U << BTx_CR1_MODE_Pos)
#define	BTx_CR1_MODE_CAPTURE	(0x1U << BTx_CR1_MODE_Pos)	/* 16λ׽ģʽ */
#define	BTx_CR1_MODE_COUNTER	(0x0U << BTx_CR1_MODE_Pos)	/* 8λʱ/ģʽλԴѡΪλźţʵ16λʱ/ģʽ */

#define	BTx_CR1_EDGESEL_Pos	4	/* ģʽµļغڲ׽ʱĲ׽ѡλ (edge select)
1ģʽԴ½أڲ׽ģʽʱز׽
0ģʽԴأڲ׽ģʽʱز׽
ע֧ϵͳʱӵ½ؼ׽ԴͼԴΪϵͳʱʱѡ½ؽЧ */
#define	BTx_CR1_EDGESEL_Msk	(0x1U << BTx_CR1_EDGESEL_Pos)
#define	BTx_CR1_EDGESEL_FALLING	(0x1U << BTx_CR1_EDGESEL_Pos)	/* ģʽԴ½أڲ׽ģʽʱز׽ */
#define	BTx_CR1_EDGESEL_RISING	(0x0U << BTx_CR1_EDGESEL_Pos)	/* ģʽԴأڲ׽ģʽʱز׽ */

#define	BTx_CR1_CAPMOD_Pos	3	/* ׽ģʽƣֻڲ׽ģʽЧ(capture mode)
1Ȳ׽
0ڲ׽ */
#define	BTx_CR1_CAPMOD_Msk	(0x1U << BTx_CR1_CAPMOD_Pos)
#define	BTx_CR1_CAPMOD_PULSE	(0x1U << BTx_CR1_CAPMOD_Pos)	/* Ȳ׽ */
#define	BTx_CR1_CAPMOD_CYCLE	(0x0U << BTx_CR1_CAPMOD_Pos)	/* ڲ׽ */

#define	BTx_CR1_CAPCLR_Pos	2	/* 㲶׽ģʽ (capture clear)
1Ȼڲ׽£׽һغ󽫼жϣ׽ڶغ棨浽ߵλԤĴֵͬʱ
0׽㣬һֱɼ */
#define	BTx_CR1_CAPCLR_Msk	(0x1U << BTx_CR1_CAPCLR_Pos)
	/* Ȼڲ׽£׽һغ󽫼жϣ׽ڶغ棨浽ߵλԤĴֵͬʱ */
	/* ׽㣬һֱɼ */

#define	BTx_CR1_CAPONCE_Pos	1	/* β׽ (capture once)
1β׽Чڲ׽һȻںֹͣҪٴβ׽
0׽ */
#define	BTx_CR1_CAPONCE_Msk	(0x1U << BTx_CR1_CAPONCE_Pos)
#define	BTx_CR1_CAPONCE_SINGLE	(0x1U << BTx_CR1_CAPONCE_Pos)	/* β׽Чڲ׽һȻںֹͣҪٴβ׽ */
#define	BTx_CR1_CAPONCE_CONTINUE	(0x0U << BTx_CR1_CAPONCE_Pos)	/* ׽ */

#define	BTx_CR1_PWM_Pos	0	/* PWMģʽ (pulse width modulation)
1PWMʹ
0PWM ʹ */
#define	BTx_CR1_PWM_Msk	(0x1U << BTx_CR1_PWM_Pos)
	/* PWMʹ */
	/* PWM ʹ */

#define	BTx_CR2_SIG2SEL_Pos	7	/* ڲԴźѡ (signal group2 select)
1ڲԴźѡGroup2
0ڲԴźѡGroup1 */
#define	BTx_CR2_SIG2SEL_Msk	(0x1U << BTx_CR2_SIG2SEL_Pos)
#define	BTx_CR2_SIG2SEL_GROUP2	(0x1U << BTx_CR2_SIG2SEL_Pos)	/* ڲԴźѡGroup2 */
#define	BTx_CR2_SIG2SEL_GROUP1	(0x0U << BTx_CR2_SIG2SEL_Pos)	/* ڲԴźѡGroup1 */

#define	BTx_CR2_SIG1SEL_Pos	6	/* ڲ׽Դźѡ (signal group1 select)
1ڲ׽ԴźѡGroup1
0ڲ׽ԴźѡGroup2 */
#define	BTx_CR2_SIG1SEL_Msk	(0x1U << BTx_CR2_SIG1SEL_Pos)
#define	BTx_CR2_SIG1SEL_GROUP1	(0x1U << BTx_CR2_SIG1SEL_Pos)	/* ڲ׽ԴźѡGroup1 */
#define	BTx_CR2_SIG1SEL_GROUP2	(0x0U << BTx_CR2_SIG1SEL_Pos)	/* ڲ׽ԴźѡGroup2 */

#define	BTx_CR2_CNTHSEL_Pos	4	/* 8λԴѡ (Counter Highend source select)
00/11ѡET1ĵλźţλ16λ
01ѡڲ׽Դź
10ѡڲԴźŻⲿDIRź */
#define	BTx_CR2_CNTHSEL_Msk	(0x3U << BTx_CR2_CNTHSEL_Pos)
#define	BTx_CR2_CNTHSEL_COUNTER	(0x0U << BTx_CR2_CNTHSEL_Pos)	/* ѡET1ĵλźţλ16λ */
#define	BTx_CR2_CNTHSEL_CAPTURE	(0x1U << BTx_CR2_CNTHSEL_Pos)	/* ѡڲ׽Դź */
#define	BTx_CR2_CNTHSEL_INNER	(0x2U << BTx_CR2_CNTHSEL_Pos)	/* ѡڲԴźŻⲿDIRź */

#define	BTx_CR2_DIREN_Pos	3	/* ⲿDIRʹܡͨʱͬʱһɸߵ͵ƽָʾķźDIR·ͨDIRźŵƽĸߵֱͣƸλ͵λʹܣʵ򡢷ĸּ (direction bit enable)
1ⲿDIRźЧʱߵλǷⲿDIRźſơ
0ⲿDIRźЧʱߵλǷڲźſơ */
#define	BTx_CR2_DIREN_Msk	(0x1U << BTx_CR2_DIREN_Pos)
	/* ⲿDIRźЧʱߵλǷⲿDIRźſơ */
	/* ⲿDIRźЧʱߵλǷڲźſơ */

#define	BTx_CR2_STDIR_Pos	2	/* ڲDIRźţDIRENΪ0ⲿDIRЧʱɸźŴDIR룬ֱӿڲļҪⲿDIR룬DIRENΪ1ʱλӦΪ0 (set direction)
1ڲDIRźΪߵƽ8λ */
#define	BTx_CR2_STDIR_Msk	(0x1U << BTx_CR2_STDIR_Pos)
	/* ڲDIRźΪߵƽ8λ */

#define	BTx_CR2_SRCSEL_Pos	1	/* λʹܿѡź (source select)
1λʹܶѡʹܡʱλDIRƣɽһ
0λʹܶѡɼĴSTDIRⲿEX_SIG2ơ */
#define	BTx_CR2_SRCSEL_Msk	(0x1U << BTx_CR2_SRCSEL_Pos)
	/* λʹܶѡɼĴSTDIRⲿEX_SIG2ơ */

#define	BTx_CR2_DIRPO_Pos	0	/* ź2ѡ (direction polarity)
1ⲿDIRźEX_SIG2
0ⲿDIRźEX_SIG2 */
#define	BTx_CR2_DIRPO_Msk	(0x1U << BTx_CR2_DIRPO_Pos)
#define	BTx_CR2_DIRPO_REVERSE	(0x1U << BTx_CR2_DIRPO_Pos)	/* ⲿDIRźEX_SIG2 */
#define	BTx_CR2_DIRPO_NON	(0x0U << BTx_CR2_DIRPO_Pos)	/* ⲿDIRźEX_SIG2 */

#define	BTx_CFGR1_RTCSEL2_Pos	6	/* RTCOUT2źѡ2 (RTCOUT2 source select)
00 = 32768HzXTLFʱ
01 = RTCSecRTCģź
10 = RTCMinRTCģķź
11 = RFU */
#define	BTx_CFGR1_RTCSEL2_Msk	(0x3U << BTx_CFGR1_RTCSEL2_Pos)
#define	BTx_CFGR1_RTCSEL2_32768HZ	(0x0U << BTx_CFGR1_RTCSEL2_Pos)
#define	BTx_CFGR1_RTCSEL2_RTC_SEC	(0x1U << BTx_CFGR1_RTCSEL2_Pos)
#define	BTx_CFGR1_RTCSEL2_RTC_MIN	(0x2U << BTx_CFGR1_RTCSEL2_Pos)

#define	BTx_CFGR1_RTCSEL1_Pos	4	/* RTCOUT1źѡ1 (RTCOUT1 source select)
00 = 32768HzXTLFʱ
01 = RTCSecRTCģź
10 = RTCMinRTCģķź
11 = RFU */
#define	BTx_CFGR1_RTCSEL1_Msk	(0x3U << BTx_CFGR1_RTCSEL1_Pos)
#define	BTx_CFGR1_RTCSEL1_32768HZ	(0x0U << BTx_CFGR1_RTCSEL1_Pos)
#define	BTx_CFGR1_RTCSEL1_RTC_SEC	(0x1U << BTx_CFGR1_RTCSEL1_Pos)
#define	BTx_CFGR1_RTCSEL1_RTC_MIN	(0x2U << BTx_CFGR1_RTCSEL1_Pos)

#define	BTx_CFGR1_GRP2SEL_Pos	2	/* Group2źѡ (Group2 source select)
00 = APBCLK
01 = RTCOUT2
10 = IN_SIG2ڲź2
11 = EX_SIG2ⲿź2
ע֧APBCLK½ز׽ͼ׽ԴͼԴΪAPBCLKʱѡ½ؽЧ׽ͼ */
#define	BTx_CFGR1_GRP2SEL_Msk	(0x3U << BTx_CFGR1_GRP2SEL_Pos)
#define	BTx_CFGR1_GRP2SEL_APBCLK	(0x0U << BTx_CFGR1_GRP2SEL_Pos)	/* ֧APBCLK½ز׽ͼ׽ԴͼԴΪAPBCLKʱѡ½ؽЧ׽ͼ */
#define	BTx_CFGR1_GRP2SEL_RTCOUT2	(0x1U << BTx_CFGR1_GRP2SEL_Pos)
#define	BTx_CFGR1_GRP2SEL_IN_SIG2	(0x2U << BTx_CFGR1_GRP2SEL_Pos)
#define	BTx_CFGR1_GRP2SEL_EX_SIG2	(0x3U << BTx_CFGR1_GRP2SEL_Pos)

#define	BTx_CFGR1_GRP1SEL_Pos	0	/* Group1źѡƣΪ׽ģʽ²ʱѡͬʱΪźŲ׽Դ(Group1 source select)
00 = APBCLK
01 = RTCOUT1
10 = IN_SIG1ڲź1
11 = EX_SIG1ⲿź1
ע֧APBCLK½ز׽ͼ׽ԴͼԴΪAPBCLKʱѡ½ؽЧ׽ͼ */
#define	BTx_CFGR1_GRP1SEL_Msk	(0x3U << BTx_CFGR1_GRP1SEL_Pos)
#define	BTx_CFGR1_GRP1SEL_APBCLK	(0x0U << BTx_CFGR1_GRP1SEL_Pos)	/* ֧APBCLK½ز׽ͼ׽ԴͼԴΪAPBCLKʱѡ½ؽЧ׽ͼ */
#define	BTx_CFGR1_GRP1SEL_RTCOUT1	(0x1U << BTx_CFGR1_GRP1SEL_Pos)
#define	BTx_CFGR1_GRP1SEL_IN_SIG1	(0x2U << BTx_CFGR1_GRP1SEL_Pos)
#define	BTx_CFGR1_GRP1SEL_EX_SIG1	(0x3U << BTx_CFGR1_GRP1SEL_Pos)

#define	BTx_CFGR2_EXSEL2_Pos	6	/* ⲿźѡ2 (external source select2)
00 = BT1_IN0/BT2_IN0
01 = BT1_IN1/BT2_IN1
10 = BT1_IN2/BT2_IN2
11 = BT1_IN3/BT2_IN3 */
#define	BTx_CFGR2_EXSEL2_Msk	(0x3U << BTx_CFGR2_EXSEL2_Pos)
#define	BTx_CFGR2_EXSEL2_IN0	(0x0U << BTx_CFGR2_EXSEL2_Pos)
#define	BTx_CFGR2_EXSEL2_IN1	(0x1U << BTx_CFGR2_EXSEL2_Pos)
#define	BTx_CFGR2_EXSEL2_IN2	(0x2U << BTx_CFGR2_EXSEL2_Pos)
#define	BTx_CFGR2_EXSEL2_IN3	(0x3U << BTx_CFGR2_EXSEL2_Pos)

#define	BTx_CFGR2_EXSEL1_Pos	4	/* ⲿźѡ1 (external source select1)
00 = BT1_IN0/BT2_IN0
01 = BT1_IN1/BT2_IN1
10 = BT1_IN2/BT2_IN2
11 = BT1_IN3/BT2_IN3 */
#define	BTx_CFGR2_EXSEL1_Msk	(0x3U << BTx_CFGR2_EXSEL1_Pos)
#define	BTx_CFGR2_EXSEL1_IN0	(0x0U << BTx_CFGR2_EXSEL1_Pos)
#define	BTx_CFGR2_EXSEL1_IN1	(0x1U << BTx_CFGR2_EXSEL1_Pos)
#define	BTx_CFGR2_EXSEL1_IN2	(0x2U << BTx_CFGR2_EXSEL1_Pos)
#define	BTx_CFGR2_EXSEL1_IN3	(0x3U << BTx_CFGR2_EXSEL1_Pos)

#define	BTx_CFGR2_INSEL2_Pos	2	/* ڲźѡ2 (internal source select 2)
00 = UART_RX3/UART_RX3
01 = UART_RX4/UART_RX4
10 = UART_RX5/UART_RX5
11 = RCLP/BT1_OUT */
#define	BTx_CFGR2_INSEL2_Msk	(0x3U << BTx_CFGR2_INSEL2_Pos)
#define	BTx_CFGR2_INSEL2_RX3	(0x0U << BTx_CFGR2_INSEL2_Pos)
#define	BTx_CFGR2_INSEL2_RX4	(0x1U << BTx_CFGR2_INSEL2_Pos)
#define	BTx_CFGR2_INSEL2_RX5	(0x2U << BTx_CFGR2_INSEL2_Pos)
#define	BTx_CFGR2_INSEL2_RCLP	(0x3U << BTx_CFGR2_INSEL2_Pos)

#define	BTx_CFGR2_INSEL1_Pos	0	/* ڲźѡ1 (internal source select 1)
00 = UART_RX0/UART_RX0
01 = UART_RX1/UART_RX1
10 = UART_RX2/UART_RX2
11 = RCLP/RCLP */
#define	BTx_CFGR2_INSEL1_Msk	(0x3U << BTx_CFGR2_INSEL1_Pos)
#define	BTx_CFGR2_INSEL1_RX0	(0x0U << BTx_CFGR2_INSEL1_Pos)
#define	BTx_CFGR2_INSEL1_RX1	(0x1U << BTx_CFGR2_INSEL1_Pos)
#define	BTx_CFGR2_INSEL1_RX2	(0x2U << BTx_CFGR2_INSEL1_Pos)
#define	BTx_CFGR2_INSEL1_RCLP	(0x3U << BTx_CFGR2_INSEL1_Pos)

#define	BTx_PRES_PRESCALE_Pos	0	/* Group1ԤƵĴ (Group1 input signal prescaler)
Ƶ=X+100ʾ1ƵFFʾ256ƵԤƵźŶΪʽռձ1:X */
#define	BTx_PRES_PRESCALE_Msk	(0xffU << BTx_PRES_PRESCALE_Pos)

#define	BTx_LOADCR_LHEN_Pos	4	/* λؿ (Counter highend load enable)
д1ԤĴET1PRESETHͼؼĴET1LOADHֱصֵĴET1CNTHͱȽϼĴET1CMPHд0ЧλӲԶ016λĶʱ/LHENΪļؿƣLLENԶʧЧ */
#define	BTx_LOADCR_LHEN_Msk	(0x1U << BTx_LOADCR_LHEN_Pos)

#define	BTx_LOADCR_LLEN_Pos	0	/* λؿ (Counter lowend load enable)
д1ԤĴPRESETLͼؼĴLOADLֱصֵĴET1CNTLͱȽϼĴET1CMPLд0ЧλӲԶ016λĶʱ/LHENΪļؿƣLLENԶʧЧ */
#define	BTx_LOADCR_LLEN_Msk	(0x1U << BTx_LOADCR_LLEN_Pos)

#define	BTx_CNTL_CNTL_Pos	0	/* λֵĴ (counter lowend)
LLENЧʱԤüĴ */
#define	BTx_CNTL_CNTL_Msk	(0xffU << BTx_CNTL_CNTL_Pos)

#define	BTx_CNTH_CNTH_Pos	0	/* λֵĴ (counter highend)
LHENЧʱԤüĴ */
#define	BTx_CNTH_CNTH_Msk	(0xffU << BTx_CNTH_CNTH_Pos)

#define	BTx_PRESET_PRESETH_Pos	8	/* λԤĴ (preset highend)
ڱλֵ򱣴沶׽8bit */
#define	BTx_PRESET_PRESETH_Msk	(0xffU << BTx_PRESET_PRESETH_Pos)

#define	BTx_PRESET_PRESETL_Pos	0	/* λԤĴ (preset lowend)
ڱλֵ򱣴沶׽8bit */
#define	BTx_PRESET_PRESETL_Msk	(0xffU << BTx_PRESET_PRESETL_Pos)

#define	BTx_LOADL_LOADL_Pos	0	/* λؼĴ (load lowend counter)
ڼƥִмʱؼĴֵȽϹĴ */
#define	BTx_LOADL_LOADL_Msk	(0xffU << BTx_LOADL_LOADL_Pos)

#define	BTx_LOADH_LOADH_Pos	0	/* λؼĴ (load highend counter)
ڼƥִмʱؼĴֵȽϹĴ8λʱ/ģʽʱøλؼĴֵּ֧Ϊ0x00á */
#define	BTx_LOADH_LOADH_Msk	(0xffU << BTx_LOADH_LOADH_Pos)

#define	BTx_CMPL_CMPL_Pos	0	/* λȽϼĴ (compare lowend )
ؼĴֵغдüĴüĴȽϣֵڵڸüĴֵƥźģ飬Ӧжϡ */
#define	BTx_CMPL_CMPL_Msk	(0xffU << BTx_CMPL_CMPL_Pos)

#define	BTx_CMPH_CMPH_Pos	0	/* λȽϼĴ (compare highend)
ؼĴֵغдüĴüĴȽϣֵڵڸüĴֵƥźģ飬Ӧжϡ */
#define	BTx_CMPH_CMPH_Msk	(0xffU << BTx_CMPH_CMPH_Pos)

#define	BTx_OUTCNT_OUTCNT_Pos	0	/* ȼ (output pulse width counter)
üĴڵȡʱΪ32768HzӦȷΧΪ30.5uS~125mS=(OUTCNT+1)/32768 */
#define	BTx_OUTCNT_OUTCNT_Msk	(0xfffU << BTx_OUTCNT_OUTCNT_Pos)

#define	BTx_OCR_OUTCLR_Pos	5
#define	BTx_OCR_OUTCLR_Msk	(0x1U << BTx_OCR_OUTCLR_Pos)
#define	BTx_OCR_OUTCLR_INVALID	(0x0U << BTx_OCR_OUTCLR_Pos)
#define	BTx_OCR_OUTCLR_CLEAR	(0x1U << BTx_OCR_OUTCLR_Pos)

#define	BTx_OCR_OUTINV_Pos	4
#define	BTx_OCR_OUTINV_Msk	(0x1U << BTx_OCR_OUTINV_Pos)
#define	BTx_OCR_OUTINV_NORMAL	(0x0U << BTx_OCR_OUTINV_Pos)
#define	BTx_OCR_OUTINV_REVERSE	(0x1U << BTx_OCR_OUTINV_Pos)

#define	BTx_OCR_OUTMOD_Pos	3
#define	BTx_OCR_OUTMOD_Msk	(0x1U << BTx_OCR_OUTMOD_Pos)
#define	BTx_OCR_OUTMOD_PULSE_SHIFT	(0x0U << BTx_OCR_OUTMOD_Pos)
#define	BTx_OCR_OUTMOD_NEG	(0x1U << BTx_OCR_OUTMOD_Pos)

#define	BTx_OCR_OUTSEL_Pos	0
#define	BTx_OCR_OUTSEL_Msk	(0x7U << BTx_OCR_OUTSEL_Pos)
#define	BTx_OCR_OUTSEL_HIGH	(0x0U << BTx_OCR_OUTSEL_Pos)
#define	BTx_OCR_OUTSEL_LOW	(0x1U << BTx_OCR_OUTSEL_Pos)
#define	BTx_OCR_OUTSEL_GROUP1	(0x2U << BTx_OCR_OUTSEL_Pos)
#define	BTx_OCR_OUTSEL_GROUP2	(0x3U << BTx_OCR_OUTSEL_Pos)
#define	BTx_OCR_OUTSEL_PWM	(0x4U << BTx_OCR_OUTSEL_Pos)

#define	BTx_IER_CMPHIE_Pos	4	/* չʱλȽϷź (compare highend interrupt enable)
1 = жʹ
0 = жϽֹ */
#define	BTx_IER_CMPHIE_Msk	(0x1U << BTx_IER_CMPHIE_Pos)

#define	BTx_IER_CMPLIE_Pos	3	/* չʱλȽϷź (compare lowend interrupt enable)
1 = жʹ
0 = жϽֹ */
#define	BTx_IER_CMPLIE_Msk	(0x1U << BTx_IER_CMPLIE_Pos)

#define	BTx_IER_OVHIE_Pos	2	/* ʱλź (highend overflow interrupt enable)
1 = жʹ
0 = жϽֹ */
#define	BTx_IER_OVHIE_Msk	(0x1U << BTx_IER_OVHIE_Pos)

#define	BTx_IER_OVLIE_Pos	1	/* ʱλź (lowend overflow interrupt enable)
1 = жʹ
0 = жϽֹ */
#define	BTx_IER_OVLIE_Msk	(0x1U << BTx_IER_OVLIE_Pos)

#define	BTx_IER_CAPIE_Pos	0	/* ʱ׽ź (capture interrupt enable)
1 = жʹ
0 = жϽֹ */
#define	BTx_IER_CAPIE_Msk	(0x1U << BTx_IER_CAPIE_Pos)

#define	BTx_ISR_CMPHIF_Pos	4	/* ʱλȽϷź (compare highend interrupt flag)
1 = ǰֵڵڱȽϼĴֵźŽ¼µļؼĴֵĴ
0 = ǰֵСڱȽϼĴֵ */
#define	BTx_ISR_CMPHIF_Msk	(0x1U << BTx_ISR_CMPHIF_Pos)

#define	BTx_ISR_CMPLIF_Pos	3	/* ʱλȽϷź (compare lowend interrupt flag)
1 = ǰֵڵڱȽϼĴֵźŽ¼µļؼĴֵĴ
0 = ǰֵСڱȽϼĴֵ */
#define	BTx_ISR_CMPLIF_Msk	(0x1U << BTx_ISR_CMPLIF_Pos)

#define	BTx_ISR_OVHIF_Pos	2	/* ʱλź (highend overflow interrupt flag)
1 = 
0 = δ */
#define	BTx_ISR_OVHIF_Msk	(0x1U << BTx_ISR_OVHIF_Pos)

#define	BTx_ISR_OVLIF_Pos	1	/* ʱλź (lowend overflow interrupt flag)
1 = 
0 = δ */
#define	BTx_ISR_OVLIF_Msk	(0x1U << BTx_ISR_OVLIF_Pos)

#define	BTx_ISR_CAPIF_Pos	0	/* ʱ׽ź (capture interrupt flag)
1 = ׽ָ
0 = δ׽ָ */
#define	BTx_ISR_CAPIF_Msk	(0x1U << BTx_ISR_CAPIF_Pos)
//Macro_End

/* Exported functions --------------------------------------------------------*/ 
extern void BTx_Deinit(BT_Type* BTx);

/* 8λBT1HBT2H  غ */
extern void BTx_CR1_CHEN_Setable(BT_Type* BTx, FunState NewState);
extern FunState BTx_CR1_CHEN_Getable(BT_Type* BTx);

/* 8λBT1LBT2L
(Counter-Lowend enable)
18bitڼģʽʱԤֵͼֱֵͱȽϼĴ׽ģʽʱ㿪ʼɼ0xFFFFźȻ㿪ʼ¼׽ֻ16λģʽ16λĶʱ/Ͳ׽ģʽCHENΪƣCLENԶʧЧ
0ֹͣ8bit غ */
extern void BTx_CR1_CLEN_Setable(BT_Type* BTx, FunState NewState);
extern FunState BTx_CR1_CLEN_Getable(BT_Type* BTx);

/* ģʽѡ (work mode)
116λ׽ģʽ
08λʱ/ģʽλԴѡΪλźţʵ16λʱ/ģʽ غ */
extern void BTx_CR1_MODE_Set(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_CR1_MODE_Get(BT_Type* BTx);

/* ģʽµļغڲ׽ʱĲ׽ѡλ (edge select)
1ģʽԴ½أڲ׽ģʽʱز׽
0ģʽԴأڲ׽ģʽʱز׽
ע֧ϵͳʱӵ½ؼ׽ԴͼԴΪϵͳʱʱѡ½ؽЧ غ */
extern void BTx_CR1_EDGESEL_Set(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_CR1_EDGESEL_Get(BT_Type* BTx);

/* ׽ģʽƣֻڲ׽ģʽЧ(capture mode)
1Ȳ׽
0ڲ׽ غ */
extern void BTx_CR1_CAPMOD_Set(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_CR1_CAPMOD_Get(BT_Type* BTx);

/* 㲶׽ģʽ (capture clear)
1Ȼڲ׽£׽һغ󽫼жϣ׽ڶغ棨浽ߵλԤĴֵͬʱ
0׽㣬һֱɼ غ */
extern void BTx_CR1_CAPCLR_Setable(BT_Type* BTx, FunState NewState);
extern FunState BTx_CR1_CAPCLR_Getable(BT_Type* BTx);

/* β׽ (capture once)
1β׽Чڲ׽һȻںֹͣҪٴβ׽
0׽ غ */
extern void BTx_CR1_CAPONCE_Set(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_CR1_CAPONCE_Get(BT_Type* BTx);

/* PWMģʽ (pulse width modulation)
1PWMʹ
0PWM ʹ غ */
extern void BTx_CR1_PWM_Setable(BT_Type* BTx, FunState NewState);
extern FunState BTx_CR1_PWM_Getable(BT_Type* BTx);

/* ڲԴźѡ (signal group2 select)
1ڲԴźѡGroup2
0ڲԴźѡGroup1 غ */
extern void BTx_CR2_SIG2SEL_Set(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_CR2_SIG2SEL_Get(BT_Type* BTx);

/* ڲ׽Դźѡ (signal group1 select)
1ڲ׽ԴźѡGroup1
0ڲ׽ԴźѡGroup2 غ */
extern void BTx_CR2_SIG1SEL_Set(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_CR2_SIG1SEL_Get(BT_Type* BTx);

/* 8λԴѡ (Counter Highend source select)
00/11ѡET1ĵλźţλ16λ
01ѡڲ׽Դź
10ѡڲԴźŻⲿDIRź غ */
extern void BTx_CR2_CNTHSEL_Set(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_CR2_CNTHSEL_Get(BT_Type* BTx);

/* ⲿDIRʹܡͨʱͬʱһɸߵ͵ƽָʾķźDIR·ͨDIRźŵƽĸߵֱͣƸλ͵λʹܣʵ򡢷ĸּ (direction bit enable)
1ⲿDIRźЧʱߵλǷⲿDIRźſơ
0ⲿDIRźЧʱߵλǷڲźſơ غ */
extern void BTx_CR2_DIREN_Setable(BT_Type* BTx, FunState NewState);
extern FunState BTx_CR2_DIREN_Getable(BT_Type* BTx);

/* ڲDIRźţDIRENΪ0ⲿDIRЧʱɸźŴDIR룬ֱӿڲļҪⲿDIR룬DIRENΪ1ʱλӦΪ0 (set direction)
1ڲDIRźΪߵƽ8λ غ */
extern void BTx_CR2_STDIR_Setable(BT_Type* BTx, FunState NewState);
extern FunState BTx_CR2_STDIR_Getable(BT_Type* BTx);

/* λʹܿѡź (source select)
1λʹܶѡʹܡʱλDIRƣɽһ
0λʹܶѡɼĴSTDIRⲿEX_SIG2ơ غ */
extern void BTx_CR2_SRCSEL_Setable(BT_Type* BTx, FunState NewState);
extern FunState BTx_CR2_SRCSEL_Getable(BT_Type* BTx);

/* ź2ѡ (direction polarity)
1ⲿDIRźEX_SIG2
0ⲿDIRźEX_SIG2 غ */
extern void BTx_CR2_DIRPO_Set(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_CR2_DIRPO_Get(BT_Type* BTx);

/* RTCOUT2źѡ2 (RTCOUT2 source select)
00 = 32768HzXTLFʱ
01 = RTCSecRTCģź
10 = RTCMinRTCģķź
11 = RFU غ */
extern void BTx_CFGR1_RTCSEL2_Set(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_CFGR1_RTCSEL2_Get(BT_Type* BTx);

/* RTCOUT1źѡ1 (RTCOUT1 source select)
00 = 32768HzXTLFʱ
01 = RTCSecRTCģź
10 = RTCMinRTCģķź
11 = RFU غ */
extern void BTx_CFGR1_RTCSEL1_Set(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_CFGR1_RTCSEL1_Get(BT_Type* BTx);

/* Group2źѡ (Group2 source select)
00 = APBCLK
01 = RTCOUT2
10 = IN_SIG2ڲź2
11 = EX_SIG2ⲿź2
ע֧APBCLK½ز׽ͼ׽ԴͼԴΪAPBCLKʱѡ½ؽЧ׽ͼ غ */
extern void BTx_CFGR1_GRP2SEL_Set(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_CFGR1_GRP2SEL_Get(BT_Type* BTx);

/* Group1źѡƣΪ׽ģʽ²ʱѡͬʱΪźŲ׽Դ(Group1 source select)
00 = APBCLK
01 = RTCOUT1
10 = IN_SIG1ڲź1
11 = EX_SIG1ⲿź1
ע֧APBCLK½ز׽ͼ׽ԴͼԴΪAPBCLKʱѡ½ؽЧ׽ͼ غ */
extern void BTx_CFGR1_GRP1SEL_Set(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_CFGR1_GRP1SEL_Get(BT_Type* BTx);

/* ⲿźѡ2 (external source select2)
00 = BT1_IN0/BT2_IN0
01 = BT1_IN1/BT2_IN1
10 = BT1_IN2/BT2_IN2
11 = BT1_IN3/BT2_IN3 غ */
extern void BTx_CFGR2_EXSEL2_Set(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_CFGR2_EXSEL2_Get(BT_Type* BTx);

/* ⲿźѡ1 (external source select1)
00 = BT1_IN0/BT2_IN0
01 = BT1_IN1/BT2_IN1
10 = BT1_IN2/BT2_IN2
11 = BT1_IN3/BT2_IN3 غ */
extern void BTx_CFGR2_EXSEL1_Set(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_CFGR2_EXSEL1_Get(BT_Type* BTx);

/* ڲźѡ2 (internal source select 2)
00 = UART_RX3/UART_RX3
01 = UART_RX4/UART_RX4
10 = UART_RX5/UART_RX5
11 = RCLP/BT1_OUT غ */
extern void BTx_CFGR2_INSEL2_Set(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_CFGR2_INSEL2_Get(BT_Type* BTx);

/* ڲźѡ1 (internal source select 1)
00 = UART_RX0/UART_RX0
01 = UART_RX1/UART_RX1
10 = UART_RX2/UART_RX2
11 = RCLP/RCLP غ */
extern void BTx_CFGR2_INSEL1_Set(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_CFGR2_INSEL1_Get(BT_Type* BTx);

/* Group1ԤƵĴ (Group1 input signal prescaler)
Ƶ=X+100ʾ1ƵFFʾ256ƵԤƵźŶΪʽռձ1:X غ */
extern void BTx_PRES_Write(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_PRES_Read(BT_Type* BTx);

/* λؿ (Counter highend load enable)
д1ԤĴET1PRESETHͼؼĴET1LOADHֱصֵĴET1CNTHͱȽϼĴET1CMPHд0ЧλӲԶ016λĶʱ/LHENΪļؿƣLLENԶʧЧ غ */
extern void BTx_LOADCR_LHEN_Setable(BT_Type* BTx, FunState NewState);
extern FunState BTx_LOADCR_LHEN_Getable(BT_Type* BTx);

/* λؿ (Counter lowend load enable)
д1ԤĴPRESETLͼؼĴLOADLֱصֵĴET1CNTLͱȽϼĴET1CMPLд0ЧλӲԶ016λĶʱ/LHENΪļؿƣLLENԶʧЧ غ */
extern void BTx_LOADCR_LLEN_Setable(BT_Type* BTx, FunState NewState);
extern FunState BTx_LOADCR_LLEN_Getable(BT_Type* BTx);

/* λֵĴ (counter lowend)
LLENЧʱԤüĴ غ */
extern uint32_t BTx_CNTL_Read(BT_Type* BTx);

/* λֵĴ (counter highend)
LHENЧʱԤüĴ غ */
extern uint32_t BTx_CNTH_Read(BT_Type* BTx);

/* λԤĴ (preset highend)
ڱλֵ򱣴沶׽8bit غ */
extern void BTx_PRESET_PRESETH_Set(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_PRESET_PRESETH_Get(BT_Type* BTx);

/* λԤĴ (preset lowend)
ڱλֵ򱣴沶׽8bit غ */
extern void BTx_PRESET_PRESETL_Set(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_PRESET_PRESETL_Get(BT_Type* BTx);

/* λؼĴ (load lowend counter)
ڼƥִмʱؼĴֵȽϹĴ غ */
extern void BTx_LOADL_Write(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_LOADL_Read(BT_Type* BTx);

/* λؼĴ (load highend counter)
ڼƥִмʱؼĴֵȽϹĴ8λʱ/ģʽʱøλؼĴֵּ֧Ϊ0x00á غ */
extern void BTx_LOADH_Write(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_LOADH_Read(BT_Type* BTx);

/* λȽϼĴ (compare lowend )
ؼĴֵغдüĴüĴȽϣֵڵڸüĴֵƥźģ飬Ӧжϡ غ */
extern void BTx_CMPL_Write(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_CMPL_Read(BT_Type* BTx);

/* λȽϼĴ (compare highend)
ؼĴֵغдüĴüĴȽϣֵڵڸüĴֵƥźģ飬Ӧжϡ غ */
extern void BTx_CMPH_Write(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_CMPH_Read(BT_Type* BTx);

/* ȼ (output pulse width counter)
üĴڵȡʱΪ32768HzӦȷΧΪ30.5uS~125mS=(OUTCNT+1)/32768 غ */
extern void BTx_OUTCNT_Write(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_OUTCNT_Read(BT_Type* BTx);
extern void BTx_OCR_OUTCLR_Set(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_OCR_OUTCLR_Get(BT_Type* BTx);
extern void BTx_OCR_OUTINV_Set(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_OCR_OUTINV_Get(BT_Type* BTx);
extern void BTx_OCR_OUTMOD_Set(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_OCR_OUTMOD_Get(BT_Type* BTx);
extern void BTx_OCR_OUTSEL_Set(BT_Type* BTx, uint32_t SetValue);
extern uint32_t BTx_OCR_OUTSEL_Get(BT_Type* BTx);

/* չʱλȽϷź (compare highend interrupt enable)
1 = жʹ
0 = жϽֹ غ */
extern void BTx_IER_CMPHIE_Setable(BT_Type* BTx, FunState NewState);
extern FunState BTx_IER_CMPHIE_Getable(BT_Type* BTx);

/* չʱλȽϷź (compare lowend interrupt enable)
1 = жʹ
0 = жϽֹ غ */
extern void BTx_IER_CMPLIE_Setable(BT_Type* BTx, FunState NewState);
extern FunState BTx_IER_CMPLIE_Getable(BT_Type* BTx);

/* ʱλź (highend overflow interrupt enable)
1 = жʹ
0 = жϽֹ غ */
extern void BTx_IER_OVHIE_Setable(BT_Type* BTx, FunState NewState);
extern FunState BTx_IER_OVHIE_Getable(BT_Type* BTx);

/* ʱλź (lowend overflow interrupt enable)
1 = жʹ
0 = жϽֹ غ */
extern void BTx_IER_OVLIE_Setable(BT_Type* BTx, FunState NewState);
extern FunState BTx_IER_OVLIE_Getable(BT_Type* BTx);

/* ʱ׽ź (capture interrupt enable)
1 = жʹ
0 = жϽֹ غ */
extern void BTx_IER_CAPIE_Setable(BT_Type* BTx, FunState NewState);
extern FunState BTx_IER_CAPIE_Getable(BT_Type* BTx);

/* ʱλȽϷź (compare highend interrupt flag)
1 = ǰֵڵڱȽϼĴֵźŽ¼µļؼĴֵĴ
0 = ǰֵСڱȽϼĴֵ غ */
extern void BTx_ISR_CMPHIF_Clr(BT_Type* BTx);
extern FlagStatus BTx_ISR_CMPHIF_Chk(BT_Type* BTx);

/* ʱλȽϷź (compare lowend interrupt flag)
1 = ǰֵڵڱȽϼĴֵźŽ¼µļؼĴֵĴ
0 = ǰֵСڱȽϼĴֵ غ */
extern void BTx_ISR_CMPLIF_Clr(BT_Type* BTx);
extern FlagStatus BTx_ISR_CMPLIF_Chk(BT_Type* BTx);

/* ʱλź (highend overflow interrupt flag)
1 = 
0 = δ غ */
extern void BTx_ISR_OVHIF_Clr(BT_Type* BTx);
extern FlagStatus BTx_ISR_OVHIF_Chk(BT_Type* BTx);

/* ʱλź (lowend overflow interrupt flag)
1 = 
0 = δ غ */
extern void BTx_ISR_OVLIF_Clr(BT_Type* BTx);
extern FlagStatus BTx_ISR_OVLIF_Chk(BT_Type* BTx);

/* ʱ׽ź (capture interrupt flag)
1 = ׽ָ
0 = δ׽ָ غ */
extern void BTx_ISR_CAPIF_Clr(BT_Type* BTx);
extern FlagStatus BTx_ISR_CAPIF_Chk(BT_Type* BTx);
//Announce_End

#ifdef __cplusplus
}
#endif

#endif /*__FM33A0XXEV_BT_H */
