/**
  ******************************************************************************
  * @file    fm33a0xxev_comp.h
  * @author  FM33A0XXEV Application Team
  * @version V1.0.0
  * @date    16-April-2020
  * @brief   This file contains all the functions prototypes for the COMP firmware library.  
  ******************************************************************************
  */
  
/* Define to prevent recursive inclusion -------------------------------------*/

#ifndef __FM33A0XXEV_COMP_H
#define __FM33A0XXEV_COMP_H


#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/

#include "FM33A0XXEV.h" 
   
#define	COMP_CR1_DFLEN_Pos	19	/* Ƚ1˲üĴ˲DFLEN+1
000103APBCLK

1111132APBCLK */
#define	COMP_CR1_DFLEN_Msk	(0x1fU << COMP_CR1_DFLEN_Pos)
#define	COMP_CR1_DFLEN_X3	(0x2U << COMP_CR1_DFLEN_Pos)	/* 3APBCLK */
#define	COMP_CR1_DFLEN_X32	(0x1fU << COMP_CR1_DFLEN_Pos)	/* 32APBCLK */

#define	COMP_CR1_WINMODE_Pos	18	/* Ƚ1ģʽƼĴ
0ֹģʽ
1ʹܴģʽ */
#define	COMP_CR1_WINMODE_Msk	(0x1U << COMP_CR1_WINMODE_Pos)
	/* ֹģʽ */
	/* ʹܴģʽ */

#define	COMP_CR1_POLAR_Pos	17	/* Ƚ1Կ
0
1ȡ */
#define	COMP_CR1_POLAR_Msk	(0x1U << COMP_CR1_POLAR_Pos)
#define	COMP_CR1_POLAR_POS	(0x0U << COMP_CR1_POLAR_Pos)	/*  */
#define	COMP_CR1_POLAR_NEG	(0x1U << COMP_CR1_POLAR_Pos)	/* ȡ */

#define	COMP_CR1_DFEN_Pos	16	/* Ƚ1˲ʹ
0ֹ˲
1ʹ˲ */
#define	COMP_CR1_DFEN_Msk	(0x1U << COMP_CR1_DFEN_Pos)
	/* ֹ˲ */
	/* ʹ˲ */

#define	COMP_CR1_CMP1OR_Pos	9	/* Ƚ1˲ǰֻ */
#define	COMP_CR1_CMP1OR_Msk	(0x1U << COMP_CR1_CMP1OR_Pos)

#define	COMP_CR1_CMP1OF_Pos	8	/* Ƚ1˲󣩣ֻ */
#define	COMP_CR1_CMP1OF_Msk	(0x1U << COMP_CR1_CMP1OF_Pos)

#define	COMP_CR1_V1NSEL_Pos	4	/* Ƚ1ѡ
000COMP1_INN1
001COMP1_INN2
010VREF
0113/4 VREF
1001/2 VREF
1011/4 VREF
1101/8 VREF
111RFU */
#define	COMP_CR1_V1NSEL_Msk	(0x7U << COMP_CR1_V1NSEL_Pos)
#define	COMP_CR1_V1NSEL_COMP1_INN1	(0x0U << COMP_CR1_V1NSEL_Pos)	/* COMP1_INN1 */
#define	COMP_CR1_V1NSEL_COMP1_INN2	(0x1U << COMP_CR1_V1NSEL_Pos)	/* COMP1_INN2 */
#define	COMP_CR1_V1NSEL_VREF	(0x2U << COMP_CR1_V1NSEL_Pos)	/* VREF */
#define	COMP_CR1_V1NSEL_3_4_VREF	(0x3U << COMP_CR1_V1NSEL_Pos)	/* 3/4 VREF */
#define	COMP_CR1_V1NSEL_1_2_VREF	(0x4U << COMP_CR1_V1NSEL_Pos)	/* 1/2 VREF */
#define	COMP_CR1_V1NSEL_1_4_VREF	(0x5U << COMP_CR1_V1NSEL_Pos)	/* 1/4 VREF */
#define	COMP_CR1_V1NSEL_1_8_VREF	(0x6U << COMP_CR1_V1NSEL_Pos)	/* 1/8 VREF */

#define	COMP_CR1_V1PSEL_Pos	1	/* Ƚ1ѡ
00COMP1_INP1
01COMP1_INP2
10COMP1_INP3
11COMP1_INP4 */
#define	COMP_CR1_V1PSEL_Msk	(0x3U << COMP_CR1_V1PSEL_Pos)
#define	COMP_CR1_V1PSEL_COMP1_INP1	(0x0U << COMP_CR1_V1PSEL_Pos)	/* COMP1_INP1 */
#define	COMP_CR1_V1PSEL_COMP1_INP2	(0x1U << COMP_CR1_V1PSEL_Pos)	/* COMP1_INP2 */
#define	COMP_CR1_V1PSEL_COMP1_INP3	(0x2U << COMP_CR1_V1PSEL_Pos)	/* COMP1_INP3 */
#define	COMP_CR1_V1PSEL_COMP1_INP4	(0x3U << COMP_CR1_V1PSEL_Pos)	/* COMP1_INP4 */

#define	COMP_CR1_CMP1EN_Pos	0	/* Ƚ1ʹλ
0رձȽ1
1ʹܱȽ1 */
#define	COMP_CR1_CMP1EN_Msk	(0x1U << COMP_CR1_CMP1EN_Pos)
	/* رձȽ1 */
	/* ʹܱȽ1 */

#define	COMP_CR2_DFLEN_Pos	19	/* Ƚ1˲üĴ˲DFLEN+1
000103APBCLK

1111132APBCLK */
#define	COMP_CR2_DFLEN_Msk	(0x1fU << COMP_CR2_DFLEN_Pos)
#define	COMP_CR2_DFLEN_X3	(0x2U << COMP_CR2_DFLEN_Pos)	/* 3APBCLK */
#define	COMP_CR2_DFLEN_X32	(0x1fU << COMP_CR2_DFLEN_Pos)	/* 32APBCLK */

#define	COMP_CR2_WINMODE_Pos	18	/* Ƚ2ģʽƼĴ
0ֹģʽ
1ʹܴģʽ */
#define	COMP_CR2_WINMODE_Msk	(0x1U << COMP_CR2_WINMODE_Pos)
	/* ֹģʽ */
	/* ʹܴģʽ */

#define	COMP_CR2_POLAR_Pos	17	/* Ƚ2Կ
0
1ȡ */
#define	COMP_CR2_POLAR_Msk	(0x1U << COMP_CR2_POLAR_Pos)
#define	COMP_CR2_POLAR_POS	(0x0U << COMP_CR2_POLAR_Pos)	/*  */
#define	COMP_CR2_POLAR_NEG	(0x1U << COMP_CR2_POLAR_Pos)	/* ȡ */

#define	COMP_CR2_DFEN_Pos	16	/* Ƚ2˲ʹ
0ֹ˲
1ʹ˲ */
#define	COMP_CR2_DFEN_Msk	(0x1U << COMP_CR2_DFEN_Pos)
	/* ֹ˲ */
	/* ʹ˲ */

#define	COMP_CR2_CMP2OR_Pos	9	/* Ƚ2˲ǰֻ */
#define	COMP_CR2_CMP2OR_Msk	(0x1U << COMP_CR2_CMP2OR_Pos)

#define	COMP_CR2_CMP2OF_Pos	8	/* Ƚ2˲󣩣ֻ */
#define	COMP_CR2_CMP2OF_Msk	(0x1U << COMP_CR2_CMP2OF_Pos)

#define	COMP_CR2_V2NSEL_Pos	4	/* Ƚ2ѡ
000COMP2_INN1
001COMP2_INN2
010VREF
0113/4 VREF
1001/2 VREF
1011/4 VREF
1101/8 VREF
111RFU */
#define	COMP_CR2_V2NSEL_Msk	(0x7U << COMP_CR2_V2NSEL_Pos)
#define	COMP_CR2_V2NSEL_COMP2_INN1	(0x0U << COMP_CR2_V2NSEL_Pos)	/* COMP2_INN1 */
#define	COMP_CR2_V2NSEL_COMP2_INN2	(0x1U << COMP_CR2_V2NSEL_Pos)	/* COMP2_INN2 */
#define	COMP_CR2_V2NSEL_VREF	(0x2U << COMP_CR2_V2NSEL_Pos)	/* VREF */
#define	COMP_CR2_V2NSEL_3_4_VREF	(0x3U << COMP_CR2_V2NSEL_Pos)	/* 3/4 VREF */
#define	COMP_CR2_V2NSEL_1_2_VREF	(0x4U << COMP_CR2_V2NSEL_Pos)	/* 1/2 VREF */
#define	COMP_CR2_V2NSEL_1_4_VREF	(0x5U << COMP_CR2_V2NSEL_Pos)	/* 1/4 VREF */
#define	COMP_CR2_V2NSEL_1_8_VREF	(0x6U << COMP_CR2_V2NSEL_Pos)	/* 1/8 VREF */

#define	COMP_CR2_V2PSEL_Pos	1	/* Ƚ2ѡ
000COMP2_INP1
001COMP2_INP2
010COMP1_INP1
011COMP1_INP2
100AVREF
101VDD15
110, 111RFU */
#define	COMP_CR2_V2PSEL_Msk	(0x7U << COMP_CR2_V2PSEL_Pos)
#define	COMP_CR2_V2PSEL_COMP2_INP1	(0x0U << COMP_CR2_V2PSEL_Pos)	/* COMP2_INP1 */
#define	COMP_CR2_V2PSEL_COMP2_INP2	(0x1U << COMP_CR2_V2PSEL_Pos)	/* COMP2_INP2 */
#define	COMP_CR2_V2PSEL_COMP1_INP1	(0x2U << COMP_CR2_V2PSEL_Pos)	/* COMP1_INP1 */
#define	COMP_CR2_V2PSEL_COMP1_INP2	(0x3U << COMP_CR2_V2PSEL_Pos)	/* COMP1_INP2 */
#define	COMP_CR2_V2PSEL_AVREF	(0x4U << COMP_CR2_V2PSEL_Pos)	/* AVREF */
#define	COMP_CR2_V2PSEL_VDD15	(0x5U << COMP_CR2_V2PSEL_Pos)	/* VDD15 */
#define	COMP_CR2_V2PSEL_RFU		(0x7U << COMP_CR2_V2PSEL_Pos)	/* RFU */

#define	COMP_CR2_CMP2EN_Pos	0	/* Ƚ2ʹλ
0رձȽ2
1ʹܱȽ2 */
#define	COMP_CR2_CMP2EN_Msk	(0x1U << COMP_CR2_CMP2EN_Pos)
	/* رձȽ2 */
	/* ʹܱȽ2 */

#define	COMP_ICR_OOW_IE_Pos	9	/* Out-Of-Windowжʹ */
#define	COMP_ICR_OOW_IE_Msk	(0x1U << COMP_ICR_OOW_IE_Pos)

#define	COMP_ICR_WIN_IE_Pos	8	/* Windowжʹ */
#define	COMP_ICR_WIN_IE_Msk	(0x1U << COMP_ICR_WIN_IE_Pos)

#define	COMP_ICR_BUFBYP_Pos	7	/* ȽBuffer Bypass
0BypassȽBuffer
1BypassȽBuffer */
#define	COMP_ICR_BUFBYP_Msk	(0x1U << COMP_ICR_BUFBYP_Pos)

#define	COMP_ICR_BUF_OFF_Pos	6	/* ȽBufferʹ
0ʹܱȽBuffer
1ֹȽBuffer */
#define	COMP_ICR_BUF_OFF_Msk	(0x1U << COMP_ICR_BUF_OFF_Pos)

#define	COMP_ICR_CMP2SEL_Pos	4	/* Ƚ2жԴѡ
00/11Ƚ2½زж
01Ƚ2زж
10Ƚ2½زж */
#define	COMP_ICR_CMP2SEL_Msk	(0x3U << COMP_ICR_CMP2SEL_Pos)
#define	COMP_ICR_CMP2SEL_BOTH	(0x0U << COMP_ICR_CMP2SEL_Pos)
#define	COMP_ICR_CMP2SEL_RISING	(0x1U << COMP_ICR_CMP2SEL_Pos)
#define	COMP_ICR_CMP2SEL_FALLING	(0x2U << COMP_ICR_CMP2SEL_Pos)

#define	COMP_ICR_CMP1SEL_Pos	2	/* Ƚ1жԴѡ
00/11Ƚ1½زж
01Ƚ1زж
10Ƚ1½زж */
#define	COMP_ICR_CMP1SEL_Msk	(0x3U << COMP_ICR_CMP1SEL_Pos)
#define	COMP_ICR_CMP1SEL_BOTH	(0x0U << COMP_ICR_CMP1SEL_Pos)
#define	COMP_ICR_CMP1SEL_RISING	(0x1U << COMP_ICR_CMP1SEL_Pos)
#define	COMP_ICR_CMP1SEL_FALLING	(0x2U << COMP_ICR_CMP1SEL_Pos)

#define	COMP_ICR_CMP2IE_Pos	1	/* Ƚ2жʹ */
#define	COMP_ICR_CMP2IE_Msk	(0x1U << COMP_ICR_CMP2IE_Pos)

#define	COMP_ICR_CMP1IE_Pos	0	/* Ƚ1жʹ */
#define	COMP_ICR_CMP1IE_Msk	(0x1U << COMP_ICR_CMP1IE_Pos)

#define	COMP_ISR_OOW_IF_Pos	3	/* Out-of-Windowжϱ־Ӳλд1 */
#define	COMP_ISR_OOW_IF_Msk	(0x1U << COMP_ISR_OOW_IF_Pos)

#define	COMP_ISR_WIN_IF_Pos	2	/* Windowжϱ־Ӳλд1 */
#define	COMP_ISR_WIN_IF_Msk	(0x1U << COMP_ISR_WIN_IF_Pos)

#define	COMP_ISR_CMP2IF_Pos	1	/* Ƚ2жϱ־Ӳλд1 */
#define	COMP_ISR_CMP2IF_Msk	(0x1U << COMP_ISR_CMP2IF_Pos)

#define	COMP_ISR_CMP1IF_Pos	0	/* Ƚ1жϱ־Ӳλд1 */
#define	COMP_ISR_CMP1IF_Msk	(0x1U << COMP_ISR_CMP1IF_Pos)

#define	COMP_PCR_HSCMPBUF_EN_Pos	2	/* ȽBUFFERģʽ
0͹ģʽ
1ģʽ */
#define	COMP_PCR_HSCMPBUF_EN_Msk	(0x1U << COMP_PCR_HSCMPBUF_EN_Pos)
#define	COMP_PCR_HSCMPBUF_EN_SLOW	(0x0U << COMP_PCR_HSCMPBUF_EN_Pos)	/* ͹ģʽ */
#define	COMP_PCR_HSCMPBUF_EN_FAST	(0x1U << COMP_PCR_HSCMPBUF_EN_Pos)	/* ģʽ */

#define	COMP_PCR_HSCMP2_EN_Pos	1	/* Ƚ2ģʽ
0͹ģʽ
1ģʽ */
#define	COMP_PCR_HSCMP2_EN_Msk	(0x1U << COMP_PCR_HSCMP2_EN_Pos)
#define	COMP_PCR_HSCMP2_EN_SLOW	(0x0U << COMP_PCR_HSCMP2_EN_Pos)	/* ͹ģʽ */
#define	COMP_PCR_HSCMP2_EN_FAST	(0x1U << COMP_PCR_HSCMP2_EN_Pos)	/* ģʽ */

#define	COMP_PCR_HSCMP1_EN_Pos	0	/* Ƚ1ģʽ
0͹ģʽ
1ģʽ */
#define	COMP_PCR_HSCMP1_EN_Msk	(0x1U << COMP_PCR_HSCMP1_EN_Pos)
#define	COMP_PCR_HSCMP1_EN_SLOW	(0x0U << COMP_PCR_HSCMP1_EN_Pos)	/* ͹ģʽ */
#define	COMP_PCR_HSCMP1_EN_FAST	(0x1U << COMP_PCR_HSCMP1_EN_Pos)	/* ģʽ*/

//Macro_End

/* Exported functions --------------------------------------------------------*/ 
extern void COMP_Deinit(void);

/* Ƚ1˲üĴ˲DFLEN+1
000103APBCLK

1111132APBCLK غ */
extern void COMP_CR1_DFLEN_Set(uint32_t SetValue);
extern uint32_t COMP_CR1_DFLEN_Get(void);

/* Ƚ1ģʽƼĴ
0ֹģʽ
1ʹܴģʽ غ */
extern void COMP_CR1_WINMODE_Setable(FunState NewState);
extern FunState COMP_CR1_WINMODE_Getable(void);

/* Ƚ1Կ
0
1ȡ غ */
extern void COMP_CR1_POLAR_Set(uint32_t SetValue);
extern uint32_t COMP_CR1_POLAR_Get(void);

/* Ƚ1˲ʹ
0ֹ˲
1ʹ˲ غ */
extern void COMP_CR1_DFEN_Setable(FunState NewState);
extern FunState COMP_CR1_DFEN_Getable(void);

/* Ƚ1˲ǰֻ غ */
extern FlagStatus COMP_CR1_CMP1OR_Chk(void);

/* Ƚ1˲󣩣ֻ غ */
extern FlagStatus COMP_CR1_CMP1OF_Chk(void);

/* Ƚ1ѡ
000COMP1_INN1
001COMP1_INN2
010VREF
0113/4 VREF
1001/2 VREF
1011/4 VREF
1101/8 VREF
111RFU غ */
extern void COMP_CR1_V1NSEL_Set(uint32_t SetValue);
extern uint32_t COMP_CR1_V1NSEL_Get(void);

/* Ƚ1ѡ
00COMP1_INP1
01COMP1_INP2
10COMP1_INP3
11COMP1_INP4 غ */
extern void COMP_CR1_V1PSEL_Set(uint32_t SetValue);
extern uint32_t COMP_CR1_V1PSEL_Get(void);

/* Ƚ1ʹλ
0رձȽ1
1ʹܱȽ1 غ */
extern void COMP_CR1_CMP1EN_Setable(FunState NewState);
extern FunState COMP_CR1_CMP1EN_Getable(void);

/* Ƚ2˲üĴ˲DFLEN+1
000103APBCLK

1111132APBCLK غ */
extern void COMP_CR2_DFLEN_Set(uint32_t SetValue);
extern uint32_t COMP_CR2_DFLEN_Get(void);

/* Ƚ2ģʽƼĴ
0ֹģʽ
1ʹܴģʽ غ */
extern void COMP_CR2_WINMODE_Setable(FunState NewState);
extern FunState COMP_CR2_WINMODE_Getable(void);

/* Ƚ2Կ
0
1ȡ غ */
extern void COMP_CR2_POLAR_Set(uint32_t SetValue);
extern uint32_t COMP_CR2_POLAR_Get(void);

/* Ƚ2˲ʹ
0ֹ˲
1ʹ˲ غ */
extern void COMP_CR2_DFEN_Setable(FunState NewState);
extern FunState COMP_CR2_DFEN_Getable(void);

/* Ƚ2˲ǰֻ غ */
extern FlagStatus COMP_CR2_CMP2OR_Chk(void);

/* Ƚ2˲󣩣ֻ غ */
extern FlagStatus COMP_CR2_CMP2OF_Chk(void);

/* Ƚ2ѡ
000COMP2_INN1
001COMP2_INN2
010VREF
0113/4 VREF
1001/2 VREF
1011/4 VREF
1101/8 VREF
111RFU */
extern void COMP_CR2_V2NSEL_Set(uint32_t SetValue);
extern uint32_t COMP_CR2_V2NSEL_Get(void);

/* Ƚ2ѡ
000COMP2_INP1
001COMP2_INP2
010COMP1_INP1
011COMP1_INP2
100AVREF
101VDD15
110, 111RFU غ */
extern void COMP_CR2_V2PSEL_Set(uint32_t SetValue);
extern uint32_t COMP_CR2_V2PSEL_Get(void);

/* Ƚ2ʹλ
0رձȽ2
1ʹܱȽ2 غ */
extern void COMP_CR2_CMP2EN_Setable(FunState NewState);
extern FunState COMP_CR2_CMP2EN_Getable(void);

/* Out-Of-Windowжʹ غ */
extern void COMP_ICR_OOW_IE_Setable(FunState NewState);
extern FunState COMP_ICR_OOW_IE_Getable(void);

/* Windowжʹ غ */
extern void COMP_ICR_WIN_IE_Setable(FunState NewState);
extern FunState COMP_ICR_WIN_IE_Getable(void);

/* ȽBuffer Bypass
0BypassȽBuffer
1BypassȽBuffer غ */
extern void COMP_ICR_BUFBYP_Setable(FunState NewState);
extern FunState COMP_ICR_BUFBYP_Getable(void);

/* ȽBufferʹ
0ʹܱȽBuffer
1ֹȽBuffer غ */
extern void COMP_ICR_BUF_OFF_Setable(FunState NewState);
extern FunState COMP_ICR_BUF_OFF_Getable(void);

/* Ƚ2жԴѡ
00/11Ƚ2½زж
01Ƚ2زж
10Ƚ2½زж غ */
extern void COMP_ICR_CMP2SEL_Set(uint32_t SetValue);
extern uint32_t COMP_ICR_CMP2SEL_Get(void);

/* Ƚ1жԴѡ
00/11Ƚ1½زж
01Ƚ1زж
10Ƚ1½زж غ */
extern void COMP_ICR_CMP1SEL_Set(uint32_t SetValue);
extern uint32_t COMP_ICR_CMP1SEL_Get(void);

/* Ƚ2жʹ غ */
extern void COMP_ICR_CMP2IE_Setable(FunState NewState);
extern FunState COMP_ICR_CMP2IE_Getable(void);

/* Ƚ1жʹ غ */
extern void COMP_ICR_CMP1IE_Setable(FunState NewState);
extern FunState COMP_ICR_CMP1IE_Getable(void);

/* Out-of-Windowжϱ־Ӳλд1 غ */
extern void COMP_ISR_OOW_IF_Clr(void);
extern FlagStatus COMP_ISR_OOW_IF_Chk(void);

/* Windowжϱ־Ӳλд1 غ */
extern void COMP_ISR_WIN_IF_Clr(void);
extern FlagStatus COMP_ISR_WIN_IF_Chk(void);

/* Ƚ2жϱ־Ӳλд1 غ */
extern void COMP_ISR_CMP2IF_Clr(void);
extern FlagStatus COMP_ISR_CMP2IF_Chk(void);

/* Ƚ1жϱ־Ӳλд1 غ */
extern void COMP_ISR_CMP1IF_Clr(void);
extern FlagStatus COMP_ISR_CMP1IF_Chk(void);

/* ȽBUFFERģʽ
0͹ģʽ
1ģʽ غ */
extern void COMP_PCR_HSCMPBUF_EN_Set(uint32_t SetValue);
extern uint32_t COMP_PCR_HSCMPBUF_EN_Get(void);

/* Ƚ2ģʽ
0͹ģʽ
1ģʽ غ */
extern void COMP_PCR_HSCMP2_EN_Set(uint32_t SetValue);
extern uint32_t COMP_PCR_HSCMP2_EN_Get(void);

/* Ƚ1ģʽ
0͹ģʽ
1ģʽ غ */
extern void COMP_PCR_HSCMP1_EN_Set(uint32_t SetValue);
extern uint32_t COMP_PCR_HSCMP1_EN_Get(void);


//Announce_End
#ifdef __cplusplus
}
#endif

#endif /* __FM33A0XXEV_COMP_H */
