/**
  ******************************************************************************
  * @file    fm33a0xxev_dbg.h
  * @author  FM33A0XXEV Application Team
  * @version V1.0.0
  * @date    16-April-2020
  * @brief   This file contains all the functions prototypes for the DBG firmware library.  
  ******************************************************************************
  */
  
/* Define to prevent recursive inclusion -------------------------------------*/

#ifndef __FM33A0XXEV_DBG_H
#define __FM33A0XXEV_DBG_H


#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/

#include "FM33A0XXEV.h" 
   
#define	DBG_CR_DBG_LPT_STOP_Pos	15	/* Debug״̬ _32ʹܿλ
1DebugʱرLPT
0DebugʱLPTԭ״̬ */
#define	DBG_CR_DBG_LPT_STOP_Msk	(0x1U << DBG_CR_DBG_LPT_STOP_Pos)
	/* DebugʱرLPT */
	/* DebugʱLPTԭ״̬ */

#define	DBG_CR_DBG_BST_STOP_Pos	14	/* Debug״̬GPTIM2ʹܿλ
1DebugʱرBSTIM
0DebugʱBSTIMԭ״̬ */
#define	DBG_CR_DBG_BST_STOP_Msk	(0x1U << DBG_CR_DBG_BST_STOP_Pos)
	/* DebugʱرBSTIM */
	/* DebugʱBSTIMԭ״̬ */
  
#define	DBG_CR_DBG_ET4_STOP_Pos	13	/* Debug״̬GPTIM2ʹܿλ
1DebugʱرET4
0DebugʱET4ԭ״̬ */
#define	DBG_CR_DBG_ET4_STOP_Msk	(0x1U << DBG_CR_DBG_ET4_STOP_Pos)
	/* DebugʱرET4 */
	/* DebugʱET4ԭ״̬ */
   
#define	DBG_CR_DBG_ET3_STOP_Pos	12	/* Debug״̬GPTIM2ʹܿλ
1DebugʱرET3
0DebugʱET3ԭ״̬ */
#define	DBG_CR_DBG_ET3_STOP_Msk	(0x1U << DBG_CR_DBG_ET3_STOP_Pos)
	/* DebugʱرET3 */
	/* DebugʱET3ԭ״̬ */   
   
#define	DBG_CR_DBG_ET2_STOP_Pos	11	/* Debug״̬GPTIM2ʹܿλ
1DebugʱرET2
0DebugʱET2ԭ״̬ */
#define	DBG_CR_DBG_ET2_STOP_Msk	(0x1U << DBG_CR_DBG_ET2_STOP_Pos)
	/* DebugʱرET2 */
	/* DebugʱET2ԭ״̬ */

#define	DBG_CR_DBG_ET1_STOP_Pos	10	/* Debug״̬GPTIM1ʹܿλ
1DebugʱرET1
0DebugʱET1ԭ״̬ */
#define	DBG_CR_DBG_ET1_STOP_Msk	(0x1U << DBG_CR_DBG_ET1_STOP_Pos)
	/* DebugʱرET1 */
	/* DebugʱET1ԭ״̬ */

#define	DBG_CR_DBG_BT2_STOP_Pos	9	/* Debug״̬BSTIMʹܿλ
1DebugʱرBT2
0DebugʱBT2ԭ״̬ */
#define	DBG_CR_DBG_BT2_STOP_Msk	(0x1U << DBG_CR_DBG_BT2_STOP_Pos)
	/* DebugʱرBT2 */
	/* DebugʱBT2ԭ״̬ */
  
#define	DBG_CR_DBG_BT1_STOP_Pos	8	/* Debug״̬BSTIMʹܿλ
1DebugʱرBT1
0DebugʱBT1ԭ״̬ */
#define	DBG_CR_DBG_BT1_STOP_Msk	(0x1U << DBG_CR_DBG_BT1_STOP_Pos)
	/* DebugʱرBT1 */
	/* DebugʱBT1ԭ״̬ */

#define	DBG_CR_DBG_WWDT_STOP_Pos	1	/* Debug״̬WWDTʹܿλ
1DebugʱرWWDT
0DebugʱWWDTԭ״̬ */
#define	DBG_CR_DBG_WWDT_STOP_Msk	(0x1U << DBG_CR_DBG_WWDT_STOP_Pos)
	/* DebugʱرWWDT */
	/* DebugʱWWDTԭ״̬ */

#define	DBG_CR_DBG_IWDT_STOP_Pos	0	/* Debug״̬IWDTʹܿλ
1DebugʱرIWDT
0DebugʱIWDT */
#define	DBG_CR_DBG_IWDT_STOP_Msk	(0x1U << DBG_CR_DBG_IWDT_STOP_Pos)
	/* DebugʱرIWDT */
	/* DebugʱIWDT */

#define	DBG_HDFR_DABORT_ADDR_FLAG_Pos	6	/* ַǶʴ־д1
1ַǶʴ
0δеַǶ */
#define	DBG_HDFR_DABORT_ADDR_FLAG_Msk	(0x1U << DBG_HDFR_DABORT_ADDR_FLAG_Pos)

#define	DBG_HDFR_DABORT_RESP_FLAG_Pos	5	/* Ƿַʴ־д1
1ߴз˷ǷַHRESPΪ߲
0δʷǷַ */
#define	DBG_HDFR_DABORT_RESP_FLAG_Msk	(0x1U << DBG_HDFR_DABORT_RESP_FLAG_Pos)

#define	DBG_HDFR_SVCUNDEF_FLAG_Pos	4	/* SVC instructionsδ־д1
if the SVCall priority is lower than the currently activelevel, 
or if HardFault or NMI is active, 
or PRIMASK is set,
the core should treat SVC instructions as though theywere UNDEFINED */
#define	DBG_HDFR_SVCUNDEF_FLAG_Msk	(0x1U << DBG_HDFR_SVCUNDEF_FLAG_Pos)

#define	DBG_HDFR_BKPT_FLAG_Pos	3	/* ִBKPTָ־д1
1ִBKPTָ
0δִBKPTָ */
#define	DBG_HDFR_BKPT_FLAG_Msk	(0x1U << DBG_HDFR_BKPT_FLAG_Pos)

#define	DBG_HDFR_TBIT_FLAG_Pos	2	/* Thumb-State־д1
1лARM״̬
0Thumb-State */
#define	DBG_HDFR_TBIT_FLAG_Msk	(0x1U << DBG_HDFR_TBIT_FLAG_Pos)

#define	DBG_HDFR_SPECIAL_OP_FLAG_Pos	1	/* ָ־д1
1ִָ룬ͼXNȡָ
0ָ뱻ִ */
#define	DBG_HDFR_SPECIAL_OP_FLAG_Msk	(0x1U << DBG_HDFR_SPECIAL_OP_FLAG_Pos)

#define	DBG_HDFR_HDF_REQUEST_FLAG_Pos	0	/* hardfault־λκ͵hardfaultᵼ¸λλд1
1hardfault 
0hardfault */
#define	DBG_HDFR_HDF_REQUEST_FLAG_Msk	(0x1U << DBG_HDFR_HDF_REQUEST_FLAG_Pos)
//Macro_End

/* Exported functions --------------------------------------------------------*/ 
extern void DBG_Deinit(void);

/* Debug״̬LPTIMʹܿλ
1DebugʱرLPTIM
0DebugʱLPTIMԭ״̬ غ */
extern void DBG_CR_DBG_LPT_STOP_Setable(FunState NewState);
extern FunState DBG_CR_DBG_LPT_STOP_Getable(void);

/* Debug״̬BSTIMʹܿλ
1DebugʱرBSTIM
0DebugʱBSTIMԭ״̬ غ */
extern void DBG_CR_DBG_BST_STOP_Setable(FunState NewState);
extern FunState DBG_CR_DBG_BST_STOP_Getable(void);

/* Debug״̬ET4ʹܿλ
1DebugʱرET4
0DebugʱET4ԭ״̬ غ */
extern void DBG_CR_DBG_ET4_STOP_Setable(FunState NewState);
extern FunState DBG_CR_DBG_ET4_STOP_Getable(void);

/* Debug״̬ET3ʹܿλ
1DebugʱرET3
0DebugʱET3ԭ״̬ غ */
extern void DBG_CR_DBG_ET3_STOP_Setable(FunState NewState);
extern FunState DBG_CR_DBG_ET3_STOP_Getable(void);

/* Debug״̬ET2ʹܿλ
1DebugʱرET2
0DebugʱET2ԭ״̬ غ */
extern void DBG_CR_DBG_ET2_STOP_Setable(FunState NewState);
extern FunState DBG_CR_DBG_ET2_STOP_Getable(void);

/* Debug״̬ET1ʹܿλ
1DebugʱرET1
0DebugʱET1ԭ״̬ غ */
extern void DBG_CR_DBG_ET1_STOP_Setable(FunState NewState);
extern FunState DBG_CR_DBG_ET1_STOP_Getable(void);

/* Debug״̬BT2ʹܿλ
1DebugʱرBT2
0DebugʱBT2ԭ״̬ غ */
extern void DBG_CR_DBG_BT2_STOP_Setable(FunState NewState);
extern FunState DBG_CR_DBG_BT2_STOP_Getable(void);

/* Debug״̬BT1ʹܿλ
1DebugʱرBT1
0DebugʱET1ԭ״̬ غ */
extern void DBG_CR_DBG_BT1_STOP_Setable(FunState NewState);
extern FunState DBG_CR_DBG_BT1_STOP_Getable(void);

/* Debug״̬WWDTʹܿλ
1DebugʱرWWDT
0DebugʱWWDTԭ״̬ غ */
extern void DBG_CR_DBG_WWDT_STOP_Setable(FunState NewState);
extern FunState DBG_CR_DBG_WWDT_STOP_Getable(void);

/* Debug״̬IWDTʹܿλ
1DebugʱرIWDT
0DebugʱIWDT غ */
extern void DBG_CR_DBG_IWDT_STOP_Setable(FunState NewState);
extern FunState DBG_CR_DBG_IWDT_STOP_Getable(void);

/* ַǶʴ־д1
1ַǶʴ
0δеַǶ غ */
extern void DBG_HDFR_DABORT_ADDR_FLAG_Clr(void);
extern FlagStatus DBG_HDFR_DABORT_ADDR_FLAG_Chk(void);

/* Ƿַʴ־д1
1ߴз˷ǷַHRESPΪ߲
0δʷǷַ غ */
extern void DBG_HDFR_DABORT_RESP_FLAG_Clr(void);
extern FlagStatus DBG_HDFR_DABORT_RESP_FLAG_Chk(void);

/* SVC instructionsδ־д1
if the SVCall priority is lower than the currently activelevel, 
or if HardFault or NMI is active, 
or PRIMASK is set,
the core should treat SVC instructions as though theywere UNDEFINED غ */
extern void DBG_HDFR_SVCUNDEF_FLAG_Clr(void);
extern FlagStatus DBG_HDFR_SVCUNDEF_FLAG_Chk(void);

/* ִBKPTָ־д1
1ִBKPTָ
0δִBKPTָ غ */
extern void DBG_HDFR_BKPT_FLAG_Clr(void);
extern FlagStatus DBG_HDFR_BKPT_FLAG_Chk(void);

/* Thumb-State־д1
1лARM״̬
0Thumb-State غ */
extern void DBG_HDFR_TBIT_FLAG_Clr(void);
extern FlagStatus DBG_HDFR_TBIT_FLAG_Chk(void);

/* ָ־д1
1ִָ룬ͼXNȡָ
0ָ뱻ִ غ */
extern void DBG_HDFR_SPECIAL_OP_FLAG_Clr(void);
extern FlagStatus DBG_HDFR_SPECIAL_OP_FLAG_Chk(void);

/* hardfault־λκ͵hardfaultᵼ¸λλд1
1hardfault 
0hardfault غ */
extern void DBG_HDFR_HDF_REQUEST_FLAG_Clr(void);
extern FlagStatus DBG_HDFR_HDF_REQUEST_FLAG_Chk(void);
//Announce_End
#ifdef __cplusplus
}
#endif

#endif /* __FM33A0XXEV_DBG_H */
