/**
  ******************************************************************************
  * @file    fm33a0xxev_iwdt.h
  * @author  FM33A0XXEV Application Team
  * @version V1.0.0
  * @date    16-April-2020
  * @brief   This file contains all the functions prototypes for the IWDT firmware library.  
  ******************************************************************************
  */
  
/* Define to prevent recursive inclusion -------------------------------------*/

#ifndef __FM33A0XXEV_IWDT_H
#define __FM33A0XXEV_IWDT_H


#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/

#include "FM33A0XXEV.h" 
   
#define	IWDT_SERV_IWDTSERV_Pos	0	/* IWDT˵ַд0x1234_5A5Aʱ幷 */
#define	IWDT_SERV_IWDTSERV_Msk	(0xffffffffU << IWDT_SERV_IWDTSERV_Pos)

#define	IWDT_CFGR_IWDTOVP_Pos	0	/* IWDT
x00125ms
x01500ms
x102s
x118s
˵bit2Ϊ0ʱߺʹöڣbit2Ϊ1ʱߺԶʹ4096s״̬½֧125ms/500ms/2s/8sڡ */
#define	IWDT_CFGR_IWDTOVP_Msk	(0x7U << IWDT_CFGR_IWDTOVP_Pos)

#define	IWDT_CNTR_IWDTCNT_Pos	0	/* IWDTǰֵ */
#define	IWDT_CNTR_IWDTCNT_Msk	(0xfffffU << IWDT_CNTR_IWDTCNT_Pos)
//Macro_End

/* Exported functions --------------------------------------------------------*/ 
extern void IWDT_Deinit(void);

/* IWDT˵ַд0x1234_5A5Aʱ幷 غ */
extern void IWDT_SERV_IWDTSERV_Set(uint32_t SetValue);

/* IWDT
x00125ms
x01500ms
x102s
x118s
˵bit2Ϊ0ʱߺʹöڣbit2Ϊ1ʱߺԶʹ4096s״̬½֧125ms/500ms/2s/8sڡ غ */
extern void IWDT_CFGR_Write(uint32_t SetValue);
extern uint32_t IWDT_CFGR_Read(void);

/* IWDTǰֵ غ */
extern uint32_t IWDT_CNTR_IWDTCNT_Get(void);
//Announce_End
#ifdef __cplusplus
}
#endif

#endif /* __FM33A0XXEV_IWDT_H */
