/**
  ******************************************************************************
  * @file    fm33a0xxev_rng.h
  * @author  FM33A0XXEV Application Team
  * @version V1.0.0
  * @date    16-April-2020
  * @brief   This file contains all the functions prototypes for the RNG firmware library.  
  ******************************************************************************
  */
  
/* Define to prevent recursive inclusion -------------------------------------*/

#ifndef __FM33A0XXEV_RNG_H
#define __FM33A0XXEV_RNG_H


#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/

#include "FM33A0XXEV.h" 
   
#define	RNG_CR_EN_Pos	0	/* RNGʹܼĴд1 (RNG enable)
1RNG
0رRNG */
#define	RNG_CR_EN_Msk	(0x1U << RNG_CR_EN_Pos)
	/* RNG */
	/* رRNG */

#define	RNG_DOR_OUT_Pos	0	/* ɽCRCĴֻ
(RNG output) */
#define	RNG_DOR_OUT_Msk	(0xffffffffU << RNG_DOR_OUT_Pos)

#define	RNG_SR_LFSREN_Pos	1	/* LFSR״̬־ֻ (LFSR enable)
1LFSRУɽCRC֤
0LFSRУɽCRC֤
עĴģжϣѯ */
#define	RNG_SR_LFSREN_Msk	(0x1U << RNG_SR_LFSREN_Pos)
	/* LFSRУɽCRC֤ */
	/* LFSRУɽCRC֤ */
	/* Ĵģжϣѯ */

#define	RNG_SR_RNF_Pos	0	/* ʧܱ־д1 (Random Number Fail)
1δͨ
0ͨ */
#define	RNG_SR_RNF_Msk	(0x1U << RNG_SR_RNF_Pos)

#define	RNG_CRC_CR_CRCEN_Pos	0	/* CRCʹܿƼĴд1CRCɺӲԶ (CRC enable)
1CRCʹ
0CRCر */
#define	RNG_CRC_CR_CRCEN_Msk	(0x1U << RNG_CRC_CR_CRCEN_Pos)
	/* CRCʹ */
	/* CRCر */

#define	RNG_CRC_DIR_CRCIN_Pos	0	/* CRCĴ (CRC data input) */
#define	RNG_CRC_DIR_CRCIN_Msk	(0xffffffffU << RNG_CRC_DIR_CRCIN_Pos)

#define	RNG_CRC_SR_CRCDONE_Pos	0	/* CRCɱ־д0 (CRC calculation done)
1CRC
0CRCδ */
#define	RNG_CRC_SR_CRCDONE_Msk	(0x1U << RNG_CRC_SR_CRCDONE_Pos)
//Macro_End

/* Exported functions --------------------------------------------------------*/ 
extern void RNG_Deinit(void);

/* RNGʹܼĴд1 (RNG enable)
1RNG
0رRNG غ */
extern void RNG_CR_EN_Setable(FunState NewState);
extern FunState RNG_CR_EN_Getable(void);

/* ɽCRCĴֻ
(RNG output) غ */
extern uint32_t RNG_DOR_Read(void);

/* LFSR״̬־ֻ (LFSR enable)
1LFSRУɽCRC֤
0LFSRУɽCRC֤
עĴģжϣѯ غ */
extern FlagStatus RNG_SR_LFSREN_Chk(void);

/* ʧܱ־д1 (Random Number Fail)
1δͨ
0ͨ غ */
extern void RNG_SR_RNF_Clr(void);
extern FlagStatus RNG_SR_RNF_Chk(void);

/* CRCʹܿƼĴд1CRCɺӲԶ (CRC enable)
1CRCʹ
0CRCر غ */
extern void RNG_CRC_CR_CRCEN_Setable(FunState NewState);
extern FunState RNG_CRC_CR_CRCEN_Getable(void);

/* CRCĴ (CRC data input) غ */
extern void RNG_CRC_DIR_Write(uint32_t SetValue);
extern uint32_t RNG_CRC_DIR_Read(void);

/* CRCɱ־д0 (CRC calculation done)
1CRC
0CRCδ غ */
extern void RNG_CRC_SR_CRCDONE_Clr(void);
extern FlagStatus RNG_CRC_SR_CRCDONE_Chk(void);
//Announce_End
#ifdef __cplusplus
}
#endif

#endif /* __FM33A0XXEV_RNG_H */
