/**
  ******************************************************************************
  * @file    fm33a0xxev_u7816.h
  * @author  FM33A0XXEV Application Team
  * @version V1.0.0
  * @date    16-April-2020
  * @brief   This file contains all the functions prototypes for the U7816 firmware library.  
  ******************************************************************************
  */
  
/* Define to prevent recursive inclusion -------------------------------------*/

#ifndef __FM33A0XXEV_U7816_H
#define __FM33A0XXEV_U7816_H


#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/

#include "FM33A0XXEV.h" 
 
typedef struct
{
	FunState				TXEN;		//ʹ
	FunState				RXEN;		//ʹ
	FunState				CKOEN;		//U7816ʱCLKʹܿ
	FunState				HPUAT;		//U7816ͨݷǿԶЧ
	FunState				HPUEN;		//U7816ͨǿʹܿ
	
	uint32_t				ERSW;		//ERROR SIGNALѡ
	uint32_t				ERSGD;		//ERROR SIGNALGUARDTIMEѡ񣨽ڷʱЧ
	FunState				BGTEN;		//BGTblock guard time
	uint32_t				REP_T;		//ƽżУʱԶط
	uint32_t				PAR;		//żУѡ
	uint32_t				SFREN;		//Guard TimeȿλʱϸЭ2etu
  uint32_t				RFREN;    //Guard Timeȿλ
	FunState				TREPEN;		//żУĴʽѡ
	FunState				RREPEN;		//żУĴʽѡ
	FunState				DICONV;		//ʹ
	
	uint32_t				TXEGT;		//ʱEGTʱ䣨ETUΪλ
	uint32_t				CLKDIV;		//U7816ʱƵƼĴ
	uint32_t				PDIV;		//U7816ԤƵƼĴ7816ͨŷƵȣʣ
	
	FunState				RXIE;		//ݽжʹλӦRX_FLAGжϱ־λ
	FunState				TXIE;		//ݷжʹλӦTX_FLAGжϱ־λ
	FunState				LSIE;		//·״̬жʹλӦERROR_FLAGжϱ־λ
	
}U7816_InitTypeDef;


#define	U7816_CR_TXEN_Pos	5	/* U7816ͨʹܿλ (Transmit Enable)1ͨʹܣɷ0ͨͽֹɷݣض˿ڣSCLźתΪ͵ƽ */
#define	U7816_CR_TXEN_Msk	(0x1U << U7816_CR_TXEN_Pos)

#define	U7816_CR_RXEN_Pos	4	/* U7816ͨʹܿλ (Receive Enable)1ͨʹܣɽ0ͨսֹɽݣض˿ */
#define	U7816_CR_RXEN_Msk	(0x1U << U7816_CR_RXEN_Pos)

#define	U7816_CR_CKOEN_Pos	3	/* U7816ʱCLKʹܿλ (Clock output Enable)17816ʱʹ07816ʱֹ */
#define	U7816_CR_CKOEN_Msk	(0x1U << U7816_CR_CKOEN_Pos)

#define	U7816_CR_HPUAT_Pos	2	/* U7816ͨݷǿԶЧλ (High-Pullup Automatically)1ݷʱԶЧ̬Ч0ݷʱԶЧֹܽHPUENLPUEN */
#define	U7816_CR_HPUAT_Msk	(0x1U << U7816_CR_HPUAT_Pos)

#define	U7816_CR_HPUEN_Pos	1	/* U7816ͨǿʹܿλ (High-Pullup Enable)1ǿЧ0ǿЧ */
#define	U7816_CR_HPUEN_Msk	(0x1U << U7816_CR_HPUEN_Pos)

#define	U7816_FFR_SFREN_Pos	11	/* Guard Timeͳȿλ (Send long Frame Enable)1Guard timeΪ3 etu0Guard timeΪ2 etu */
#define	U7816_FFR_SFREN_Msk	(0x1U << U7816_FFR_SFREN_Pos)
#define	U7816_FFR_SFREN_3ETU	(0x1U << U7816_FFR_SFREN_Pos)
#define	U7816_FFR_SFREN_2ETU	(0x0U << U7816_FFR_SFREN_Pos)

#define	U7816_FFR_ERSW_Pos	9	/* ERROR SIGNALѡ (Error Signal Width)11ERROR SIGNALΪ1ETU;10ERROR SIGNALΪ1.5ETU;01ERROR SIGNALΪ2ETU;00ERROR SIGNALΪ2ETU; */
#define	U7816_FFR_ERSW_Msk	(0x3U << U7816_FFR_ERSW_Pos)
#define	U7816_FFR_ERSW_1ETU	(0x0U << U7816_FFR_ERSW_Pos)
#define	U7816_FFR_ERSW_1P5ETU	(0x1U << U7816_FFR_ERSW_Pos)
#define	U7816_FFR_ERSW_2ETU	(0x2U << U7816_FFR_ERSW_Pos)

#define	U7816_FFR_ERSGD_Pos	8	/* ERROR SIGNALGUARDTIMEѡ񣨽ڷʱЧ
(Error Signal Guard Time)1ERROR SIGNALGUARDTIMEΪ1~1.5ETU0ERROR SIGNALGUARDTIMEΪ2~2.5ETUERROR SIGNALΪETUʱGUARDTIMEΪ1.52.5ETUERROR SIGNALΪ1.5ETUʱGUARDTIMEΪ12ETU */
#define	U7816_FFR_ERSGD_Msk	(0x1U << U7816_FFR_ERSGD_Pos)
#define	U7816_FFR_ERSGD_1ETU	(0x1U << U7816_FFR_ERSGD_Pos)	/* ERROR SIGNALGUARDTIMEΪ1~1.5ETU0 */
#define	U7816_FFR_ERSGD_2ETU	(0x0U << U7816_FFR_ERSGD_Pos)

#define	U7816_FFR_BGTEN_Pos	7	/* BGTλƽ->֮ǷBGTBGTǽ->֮ҪСʱ䣨block guard time enable1BGTʹܣBlock guard time(12 etu);0BGTֹBlock guard time(12 etu); */
#define	U7816_FFR_BGTEN_Msk	(0x1U << U7816_FFR_BGTEN_Pos)

#define	U7816_FFR_REP_T_Pos	6	/* ƽżУʱԶط (Repeated Times)1301 */
#define	U7816_FFR_REP_T_Msk	(0x1U << U7816_FFR_REP_T_Pos)
#define	U7816_FFR_REP_T_1TIMES	(0x0U << U7816_FFR_REP_T_Pos)
#define	U7816_FFR_REP_T_3TIMES	(0x1U << U7816_FFR_REP_T_Pos)

#define	U7816_FFR_PAR_Pos	4	/* żУѡ (Parity)00Even01Odd10Always 111У飬 */
#define	U7816_FFR_PAR_Msk	(0x3U << U7816_FFR_PAR_Pos)
#define	U7816_FFR_PAR_EVEN	(0x0U << U7816_FFR_PAR_Pos)
#define	U7816_FFR_PAR_ODD	(0x1U << U7816_FFR_PAR_Pos)
#define	U7816_FFR_PAR_1ALAWAYS	(0x2U << U7816_FFR_PAR_Pos)
#define	U7816_FFR_PAR_NON	(0x3U << U7816_FFR_PAR_Pos)

#define	U7816_FFR_RFREN_Pos	3	/* Guard Timeճȿλ (Receive short Frame )1Guard timeΪ1 etu0Guard timeΪ2 etu */
#define	U7816_FFR_RFREN_Msk	(0x1U << U7816_FFR_RFREN_Pos)
#define	U7816_FFR_RFREN_1ETU	(0x1U << U7816_FFR_RFREN_Pos)
#define	U7816_FFR_RFREN_2ETU	(0x0U << U7816_FFR_RFREN_Pos)

#define	U7816_FFR_TREPEN_Pos	2	/* żУĴʽѡ (Transmit Repeat Enable)1յżУ־error signalT0ЭԶлطڵһbyteظʹREP_Ttx_parity_err־ж0յError signalʱԶطtx_parity_err־ֱж */
#define	U7816_FFR_TREPEN_Msk	(0x1U << U7816_FFR_TREPEN_Pos)

#define	U7816_FFR_RREPEN_Pos	1	/* żУĴʽѡ (Receive Repeat Enable)1żУT=0ЭԶطERROR SIGNALһBYTEմREP_TRX_PARITY_ERR־ж0żУԶERROR SIGNALRX_PARITY_ERR־ж */
#define	U7816_FFR_RREPEN_Msk	(0x1U << U7816_FFR_RREPEN_Pos)

#define	U7816_FFR_DICONV_Pos	0	/* 򣬱뷽ʽѡ (bit Direction Conversion)1룬շMSB(շ+Уλ)߼ƽ0룬շLSB  (շ+Уλ)߼ƽ */
#define	U7816_FFR_DICONV_Msk	(0x1U << U7816_FFR_DICONV_Pos)
#define	U7816_FFR_DICONV_FORWARD	(0x0U << U7816_FFR_DICONV_Pos)
#define	U7816_FFR_DICONV_REVERSE	(0x1U << U7816_FFR_DICONV_Pos)

#define	U7816_EGTR_TXEGT_Pos	0	/* ʱExtra Guard Timeʱ䣨ETUΪλ
(Transmit Extra Guard Time) */
#define	U7816_EGTR_TXEGT_Msk	(0xffU << U7816_EGTR_TXEGT_Pos)

#define	U7816_PSC_CLKDIV_Pos	0	/* U7816ʱƵƼĴ(Clock Divider)7816ʱӷƵU7816ʱAPBCLKķƵϵF7816=FAPBCLK/(CLKDIV+1)CLK_DIVó01ʱF7816=FAPBCLK/2ע7816Э涨ĹʱӷΧ1~5MHZ */
#define	U7816_PSC_CLKDIV_Msk	(0x1fU << U7816_PSC_CLKDIV_Pos)

#define	U7816_BGR_PDIV_Pos	0	/* U7816ԤƵƼĴ(Pre-Divider)7816ͨŷƵȣʣBaud  F7816/(PDIV  1)

ע⣺PDIVСֵ0x1Ӧýֹ0x0 */
#define	U7816_BGR_PDIV_Msk	(0xfffU << U7816_BGR_PDIV_Pos)

#define	U7816_RXBUF_RXBUF_Pos	0	/* U7816ݽջĴ (Receive Buffer) */
#define	U7816_RXBUF_RXBUF_Msk	(0xffU << U7816_RXBUF_RXBUF_Pos)

#define	U7816_TXBUF_TXBUF_Pos	0	/* U7816ݷͻĴ (Transmit Buffer) */
#define	U7816_TXBUF_TXBUF_Msk	(0xffU << U7816_TXBUF_TXBUF_Pos)

#define	U7816_IER_RXIE_Pos	2	/* ݽжʹλӦRXIFжϱ־λ (Receive Interrupt Enable)1RXIFĴλʱж0ֹж */
#define	U7816_IER_RXIE_Msk	(0x1U << U7816_IER_RXIE_Pos)

#define	U7816_IER_TXIE_Pos	1	/* ݷжʹλӦTXIFжϱ־λ(Transmit Interrupt Enable)1TXIFĴλʱж0ֹж */
#define	U7816_IER_TXIE_Msk	(0x1U << U7816_IER_TXIE_Pos)

#define	U7816_IER_LSIE_Pos	0	/* ·״̬жʹλӦERRIFжϱ־λ(Line Status Interrupt Enable)1ERRIFĴλʱ·ж0ֹ·ж */
#define	U7816_IER_LSIE_Msk	(0x1U << U7816_IER_LSIE_Pos)

#define	U7816_ISR_WAIT_RPT_Pos	18	/* U7816ӿڷ˴źţڵȴԷطݣ(Waiting for Repeat flag)״̬뷢ʹź״̬ʱλյʼλ߽뷢״̬ʱӲ㣻ֻ */
#define	U7816_ISR_WAIT_RPT_Msk	(0x1U << U7816_ISR_WAIT_RPT_Pos)

#define	U7816_ISR_TXBUSY_Pos	17	/* æ־ɺԶ㣩(Transmission busy flag)1ݷ״̬λĴڷݡʼʼλ1ֹͣλм㣩0ݷͿ */
#define	U7816_ISR_TXBUSY_Msk	(0x1U << U7816_ISR_TXBUSY_Pos)

#define	U7816_ISR_RXBUSY_Pos	16	/* æ־ɺԶ㣩(Receiving busy flag)1ݽ״̬λĴڽݡյʼλ1յֹͣλ㣬ݳططerror signalʱ㡣ݼУλ֮ǷҪطҪʱñ־0ݽտ */
#define	U7816_ISR_RXBUSY_Msk	(0x1U << U7816_ISR_RXBUSY_Pos)

#define	U7816_ISR_TPARERR_Pos	11	/* żУ־λӲλд1 (Transmit Parity Error,write 1 to clear) */
#define	U7816_ISR_TPARERR_Msk	(0x1U << U7816_ISR_TPARERR_Pos)

#define	U7816_ISR_RPARERR_Pos	10	/* żУ־λӲλд1 (Receive Parity Error flag,write 1 to clear) */
#define	U7816_ISR_RPARERR_Msk	(0x1U << U7816_ISR_RPARERR_Pos)

#define	U7816_ISR_FRERR_Pos	9	/* ֡ʽ־λӲλд1 (Frame Error flag,write 1 to clear)1֡ʽд󣬽յframeֽڳյframestopλ0ʱżУ */
#define	U7816_ISR_FRERR_Msk	(0x1U << U7816_ISR_FRERR_Pos)

#define	U7816_ISR_OVERR_Pos	8	/* ־λӲλд1 (Receive Overflow Error,write 1 to clear)1ջĴδֽյµݣ־ЧԭջĴݱ¸0 */
#define	U7816_ISR_OVERR_Msk	(0x1U << U7816_ISR_OVERR_Pos)

#define	U7816_ISR_RXIF_Pos	2	/* ɱ־(Receive interrupt flag)U7816ӿڿÿյ1byteݣݽյͨӦһжϡӲλݽջĴ1յ1byteݣݽջ0δյݣݽջ */
#define	U7816_ISR_RXIF_Msk	(0x1U << U7816_ISR_RXIF_Pos)

#define	U7816_ISR_TXIF_Pos	1	/* ͻձ־(Transmit interrupt flag)ϵ縴λ˱־Զλʾգдݡдݺ־ԶݴӷͻλĴ11ݷͻ0ݷͻݴ */
#define	U7816_ISR_TXIF_Msk	(0x1U << U7816_ISR_TXIF_Pos)

#define	U7816_ISR_ERRIF_Pos	0	/* ־(Error interrupt flag)ĴóгbitTPARERRRPARERRFRERROVERRĻͨϴ־Ĵbit */
#define	U7816_ISR_ERRIF_Msk	(0x1U << U7816_ISR_ERRIF_Pos)
//Macro_End

/* Exported functions --------------------------------------------------------*/ 
extern void U7816_Deinit(void);

/* U7816ͨʹܿλ (Transmit Enable)1ͨʹܣɷ0ͨͽֹɷݣض˿ڣSCLźתΪ͵ƽ غ */
extern void U7816_CR_TXEN_Setable(FunState NewState);
extern FunState U7816_CR_TXEN_Getable(void);

/* U7816ͨʹܿλ (Receive Enable)1ͨʹܣɽ0ͨսֹɽݣض˿ غ */
extern void U7816_CR_RXEN_Setable(FunState NewState);
extern FunState U7816_CR_RXEN_Getable(void);

/* U7816ʱCLKʹܿλ (Clock output Enable)17816ʱʹ07816ʱֹ غ */
extern void U7816_CR_CKOEN_Setable(FunState NewState);
extern FunState U7816_CR_CKOEN_Getable(void);

/* U7816ͨݷǿԶЧλ (High-Pullup Automatically)1ݷʱԶЧ̬Ч0ݷʱԶЧֹܽHPUENLPUEN غ */
extern void U7816_CR_HPUAT_Setable(FunState NewState);
extern FunState U7816_CR_HPUAT_Getable(void);

/* U7816ͨǿʹܿλ (High-Pullup Enable)1ǿЧ0ǿЧ غ */
extern void U7816_CR_HPUEN_Setable(FunState NewState);
extern FunState U7816_CR_HPUEN_Getable(void);

/* Guard Timeͳȿλ (Send long Frame Enable)1Guard timeΪ3 etu0Guard timeΪ2 etu غ */
extern void U7816_FFR_SFREN_Set(uint32_t SetValue);
extern uint32_t U7816_FFR_SFREN_Get(void);

/* ERROR SIGNALѡ (Error Signal Width)11ERROR SIGNALΪ1ETU;10ERROR SIGNALΪ1.5ETU;01ERROR SIGNALΪ2ETU;00ERROR SIGNALΪ2ETU; غ */
extern void U7816_FFR_ERSW_Set(uint32_t SetValue);
extern uint32_t U7816_FFR_ERSW_Get(void);

/* ERROR SIGNALGUARDTIMEѡ񣨽ڷʱЧ
(Error Signal Guard Time)1ERROR SIGNALGUARDTIMEΪ1~1.5ETU0ERROR SIGNALGUARDTIMEΪ2~2.5ETUERROR SIGNALΪETUʱGUARDTIMEΪ1.52.5ETUERROR SIGNALΪ1.5ETUʱGUARDTIMEΪ12ETU غ */
extern void U7816_FFR_ERSGD_Set(uint32_t SetValue);
extern uint32_t U7816_FFR_ERSGD_Get(void);

/* BGTλƽ->֮ǷBGTBGTǽ->֮ҪСʱ䣨block guard time enable1BGTʹܣBlock guard time(12 etu);0BGTֹBlock guard time(12 etu); غ */
extern void U7816_FFR_BGTEN_Setable(FunState NewState);
extern FunState U7816_FFR_BGTEN_Getable(void);

/* ƽżУʱԶط (Repeated Times)1301 غ */
extern void U7816_FFR_REP_T_Set(uint32_t SetValue);
extern uint32_t U7816_FFR_REP_T_Get(void);

/* żУѡ (Parity)00Even01Odd10Always 111У飬 غ */
extern void U7816_FFR_PAR_Set(uint32_t SetValue);
extern uint32_t U7816_FFR_PAR_Get(void);

/* Guard Timeճȿλ (Receive short Frame )1Guard timeΪ1 etu0Guard timeΪ2 etu غ */
extern void U7816_FFR_RFREN_Set(uint32_t SetValue);
extern uint32_t U7816_FFR_RFREN_Get(void);

/* żУĴʽѡ (Transmit Repeat Enable)1յżУ־error signalT0ЭԶлطڵһbyteظʹREP_Ttx_parity_err־ж0յError signalʱԶطtx_parity_err־ֱж غ */
extern void U7816_FFR_TREPEN_Setable(FunState NewState);
extern FunState U7816_FFR_TREPEN_Getable(void);

/* żУĴʽѡ (Receive Repeat Enable)1żУT=0ЭԶطERROR SIGNALһBYTEմREP_TRX_PARITY_ERR־ж0żУԶERROR SIGNALRX_PARITY_ERR־ж غ */
extern void U7816_FFR_RREPEN_Setable(FunState NewState);
extern FunState U7816_FFR_RREPEN_Getable(void);

/* 򣬱뷽ʽѡ (bit Direction Conversion)1룬շMSB(շ+Уλ)߼ƽ0룬շLSB  (շ+Уλ)߼ƽ غ */
extern void U7816_FFR_DICONV_Set(uint32_t SetValue);
extern uint32_t U7816_FFR_DICONV_Get(void);

/* ʱExtra Guard Timeʱ䣨ETUΪλ
(Transmit Extra Guard Time) غ */
extern void U7816_EGTR_Write(uint32_t SetValue);
extern uint32_t U7816_EGTR_Read(void);

/* U7816ʱƵƼĴ(Clock Divider)7816ʱӷƵU7816ʱAPBCLKķƵϵF7816=FAPBCLK/(CLKDIV+1)CLK_DIVó01ʱF7816=FAPBCLK/2ע7816Э涨ĹʱӷΧ1~5MHZ غ */
extern void U7816_PSC_Write(uint32_t SetValue);
extern uint32_t U7816_PSC_Read(void);

/* U7816ԤƵƼĴ(Pre-Divider)7816ͨŷƵȣʣBaud  F7816/(PDIV  1)

ע⣺PDIVСֵ0x1Ӧýֹ0x0 غ */
extern void U7816_BGR_Write(uint32_t SetValue);
extern uint32_t U7816_BGR_Read(void);

/* U7816ݽջĴ (Receive Buffer) غ */
extern uint32_t U7816_RXBUF_Read(void);

/* U7816ݷͻĴ (Transmit Buffer) غ */
extern void U7816_TXBUF_Write(uint32_t SetValue);

/* ݽжʹλӦRXIFжϱ־λ (Receive Interrupt Enable)1RXIFĴλʱж0ֹж غ */
extern void U7816_IER_RXIE_Setable(FunState NewState);
extern FunState U7816_IER_RXIE_Getable(void);

/* ݷжʹλӦTXIFжϱ־λ(Transmit Interrupt Enable)1TXIFĴλʱж0ֹж غ */
extern void U7816_IER_TXIE_Setable(FunState NewState);
extern FunState U7816_IER_TXIE_Getable(void);

/* ·״̬жʹλӦERRIFжϱ־λ(Line Status Interrupt Enable)1ERRIFĴλʱ·ж0ֹ·ж غ */
extern void U7816_IER_LSIE_Setable(FunState NewState);
extern FunState U7816_IER_LSIE_Getable(void);

/* U7816ӿڷ˴źţڵȴԷطݣ(Waiting for Repeat flag)״̬뷢ʹź״̬ʱλյʼλ߽뷢״̬ʱӲ㣻ֻ غ */
extern FlagStatus U7816_ISR_WAIT_RPT_Chk(void);

/* æ־ɺԶ㣩(Transmission busy flag)1ݷ״̬λĴڷݡʼʼλ1ֹͣλм㣩0ݷͿ غ */
extern FlagStatus U7816_ISR_TXBUSY_Chk(void);

/* æ־ɺԶ㣩(Receiving busy flag)1ݽ״̬λĴڽݡյʼλ1յֹͣλ㣬ݳططerror signalʱ㡣ݼУλ֮ǷҪطҪʱñ־0ݽտ غ */
extern FlagStatus U7816_ISR_RXBUSY_Chk(void);

/* żУ־λӲλд1 (Transmit Parity Error,write 1 to clear) غ */
extern void U7816_ISR_TPARERR_Clr(void);
extern FlagStatus U7816_ISR_TPARERR_Chk(void);

/* żУ־λӲλд1 (Receive Parity Error flag,write 1 to clear) غ */
extern void U7816_ISR_RPARERR_Clr(void);
extern FlagStatus U7816_ISR_RPARERR_Chk(void);

/* ֡ʽ־λӲλд1 (Frame Error flag,write 1 to clear)1֡ʽд󣬽յframeֽڳյframestopλ0ʱżУ غ */
extern void U7816_ISR_FRERR_Clr(void);
extern FlagStatus U7816_ISR_FRERR_Chk(void);

/* ־λӲλд1 (Receive Overflow Error,write 1 to clear)1ջĴδֽյµݣ־ЧԭջĴݱ¸0 غ */
extern void U7816_ISR_OVERR_Clr(void);
extern FlagStatus U7816_ISR_OVERR_Chk(void);

/* ɱ־(Receive interrupt flag)U7816ӿڿÿյ1byteݣݽյͨӦһжϡӲλݽջĴ1յ1byteݣݽջ0δյݣݽջ غ */
extern FlagStatus U7816_ISR_RXIF_Chk(void);

/* ͻձ־(Transmit interrupt flag)ϵ縴λ˱־Զλʾգдݡдݺ־ԶݴӷͻλĴ11ݷͻ0ݷͻݴ غ */
extern FlagStatus U7816_ISR_TXIF_Chk(void);

/* ־(Error interrupt flag)ĴóгbitTPARERRRPARERRFRERROVERRĻͨϴ־Ĵbit غ */
extern FlagStatus U7816_ISR_ERRIF_Chk(void);

/* U7816ʼ */
void U7816_Init( U7816_InitTypeDef* para);



//Announce_End
#ifdef __cplusplus
}
#endif

#endif /* __FM33A0XXEV_U7816_H */
