/**
  ******************************************************************************
  * @file    fm33a0xxev_vrtc.h
  * @author  FM33A0XXEV Application Team
  * @version V1.0.0
  * @date    16-April-2020
  * @brief   This file contains all the functions prototypes for the VRTC firmware library.  
  ******************************************************************************
  */
  
/* Define to prevent recursive inclusion -------------------------------------*/

#ifndef __FM33A0XXEV_VRTC_H
#define __FM33A0XXEV_VRTC_H


#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/

#include "FM33A0XXEV.h" 

#define HXVAR(object, addr)   (*((object *) (addr)))
#define const_rcmf_Trim 	HXVAR( uint32_t, 0x1FFFFB44 )	//RCMF 2MHzУֵ
   
#define	VRTC_PDRCR_CFG_Pos	0	/*  VRTCԴPDR*/
#define	VRTC_PDRCR_CFG_Msk	(0x1U << VRTC_PDRCR_CFG_Pos) 
      
/*0رRCMF
1ʹRCMF
עʹRTCԶ²RCMFӲ͹ر */
#define	VRTC_RCMFCR_EN_Msk	(0x1U << VRTC_RCMFCR_EN_Pos)
	/* رRCMF */
	/* ʹRCMF */
   
#define	VRTC_RCMFCR_EN_Pos	7	/* RCMFʹܼĴ
0رRCMF
1ʹRCMF
עʹRTCԶ²RCMFӲ͹ر */
#define	VRTC_RCMFCR_EN_Msk	(0x1U << VRTC_RCMFCR_EN_Pos)
	/* رRCMF */
	/* ʹRCMF */

#define	VRTC_RCMFCR_TRIM_Pos	0	/* RCMFƵʵУĴ */
#define	VRTC_RCMFCR_TRIM_Msk	(0x3fU << VRTC_RCMFCR_TRIM_Pos)

#define	VRTC_RCLPCR_CHOPEN_Pos	1	/* Chopperʹ */
#define	VRTC_RCLPCR_CHOPEN_Msk	(0x1U << VRTC_RCLPCR_CHOPEN_Pos)

#define	VRTC_RCLPCR_RCLP_OFF_Pos	0	/* RCLPʹź
0ʹRCLP 
1رRCLP
עXTLF쳣ͣʱԶʹRCLP */
#define	VRTC_RCLPCR_RCLP_OFF_Msk	(0x1U << VRTC_RCLPCR_RCLP_OFF_Pos)
	/* ʹRCLP  */
	/* رRCLP */

#define	VRTC_RCLPTR_RCLP_TRIM_Pos	0	/* RCLPУֵĴ
0000 0000Ƶ
1111 1111Ƶ */
#define	VRTC_RCLPTR_RCLP_TRIM_Msk	(0xffU << VRTC_RCLPTR_RCLP_TRIM_Pos)

#define	VRTC_XTLFCR_XTLFIPW_Pos	0
#define	VRTC_XTLFCR_XTLFIPW_Msk	(0xfU << VRTC_XTLFCR_XTLFIPW_Pos)
#define	VRTC_XTLFCR_XTLFIPW_850NA	(0x0U << VRTC_XTLFCR_XTLFIPW_Pos)
#define	VRTC_XTLFCR_XTLFIPW_800NA	(0x1U << VRTC_XTLFCR_XTLFIPW_Pos)
#define	VRTC_XTLFCR_XTLFIPW_750NA	(0x2U << VRTC_XTLFCR_XTLFIPW_Pos)
#define	VRTC_XTLFCR_XTLFIPW_700NA	(0x3U << VRTC_XTLFCR_XTLFIPW_Pos)
#define	VRTC_XTLFCR_XTLFIPW_650NA	(0x4U << VRTC_XTLFCR_XTLFIPW_Pos)
#define	VRTC_XTLFCR_XTLFIPW_600NA	(0x5U << VRTC_XTLFCR_XTLFIPW_Pos)
#define	VRTC_XTLFCR_XTLFIPW_550NA	(0x6U << VRTC_XTLFCR_XTLFIPW_Pos)
#define	VRTC_XTLFCR_XTLFIPW_500NA	(0x7U << VRTC_XTLFCR_XTLFIPW_Pos)
#define	VRTC_XTLFCR_XTLFIPW_450NA	(0x8U << VRTC_XTLFCR_XTLFIPW_Pos)
#define	VRTC_XTLFCR_XTLFIPW_400NA	(0x9U << VRTC_XTLFCR_XTLFIPW_Pos)
#define	VRTC_XTLFCR_XTLFIPW_350NA	(0xaU << VRTC_XTLFCR_XTLFIPW_Pos)
#define	VRTC_XTLFCR_XTLFIPW_300NA	(0xbU << VRTC_XTLFCR_XTLFIPW_Pos)
#define	VRTC_XTLFCR_XTLFIPW_250NA	(0xcU << VRTC_XTLFCR_XTLFIPW_Pos)
#define	VRTC_XTLFCR_XTLFIPW_200NA	(0xdU << VRTC_XTLFCR_XTLFIPW_Pos)
#define	VRTC_XTLFCR_XTLFIPW_150NA	(0xeU << VRTC_XTLFCR_XTLFIPW_Pos)
#define	VRTC_XTLFCR_XTLFIPW_100NA	(0xfU << VRTC_XTLFCR_XTLFIPW_Pos)

#define	VRTC_ADCCR_CKS_Pos	1	/* ADCʱѡĴ
000RCMF
001RCMF/2
010RCMF/4
011RCMF/8
100RCMF/16
101RCMF/32
110RCLP
111XTLF */
#define	VRTC_ADCCR_CKS_Msk	(0x7U << VRTC_ADCCR_CKS_Pos)
#define	VRTC_ADCCR_CKS_RCMF	(0x0U << VRTC_ADCCR_CKS_Pos)	/* RCMF */
#define	VRTC_ADCCR_CKS_RCMF_2	(0x1U << VRTC_ADCCR_CKS_Pos)	/* RCMF/2 */
#define	VRTC_ADCCR_CKS_RCMF_4	(0x2U << VRTC_ADCCR_CKS_Pos)	/* RCMF/4 */
#define	VRTC_ADCCR_CKS_RCMF_8	(0x3U << VRTC_ADCCR_CKS_Pos)	/* RCMF/8 */
#define	VRTC_ADCCR_CKS_RCMF_16	(0x4U << VRTC_ADCCR_CKS_Pos)	/* RCMF/16 */
#define	VRTC_ADCCR_CKS_RCMF_32	(0x5U << VRTC_ADCCR_CKS_Pos)	/* RCMF/32 */
#define	VRTC_ADCCR_CKS_RCLP	(0x6U << VRTC_ADCCR_CKS_Pos)	/* RCLP */
#define	VRTC_ADCCR_CKS_XTLF	(0x7U << VRTC_ADCCR_CKS_Pos)	/* XTLF */

#define	VRTC_ADCCR_CKE_Pos	0	/* ADCʱʹ
0رADCʱ
1ʹADCʱ */
#define	VRTC_ADCCR_CKE_Msk	(0x1U << VRTC_ADCCR_CKE_Pos)
	/* رADCʱ */
	/* ʹADCʱ */

#define	VRTC_LFDIER_LFDET_IE_Pos	0	/* XTLFƵⱨжʹܣ1Ч */
#define	VRTC_LFDIER_LFDET_IE_Msk	(0x1U << VRTC_LFDIER_LFDET_IE_Pos)

#define	VRTC_LFDISR_LFDETO_Pos	1	/* Ƶͣ״̬
1XTLF
0XTLFͣ */
#define	VRTC_LFDISR_LFDETO_Msk	(0x1U << VRTC_LFDISR_LFDETO_Pos)

#define	VRTC_LFDISR_LFDET_IF_Pos	0	/* Ƶͣжϱ־ĴXTLFͣʱӲ첽λд1㣻ֻLFDETOΪ0²ܹ˼Ĵ */
#define	VRTC_LFDISR_LFDET_IF_Msk	(0x1U << VRTC_LFDISR_LFDET_IF_Pos)
//Macro_End

/* Exported functions --------------------------------------------------------*/ 
extern void VRTC_Deinit(void);

/* RCMFʹܼĴ
0رRCMF
1ʹRCMF
עʹRTCԶ²RCMFӲ͹ر غ */
extern void VRTC_RCMFCR_EN_Setable(FunState NewState);
extern FunState VRTC_RCMFCR_EN_Getable(void);

/* RCMFƵʵУĴ غ */
extern void VRTC_RCMFCR_TRIM_Set(uint32_t SetValue);
extern uint32_t VRTC_RCMFCR_TRIM_Get(void);

/* Chopperʹ غ */
extern void VRTC_RCLPCR_CHOPEN_Setable(FunState NewState);
extern FunState VRTC_RCLPCR_CHOPEN_Getable(void);

/* RCLPʹź
0ʹRCLP 
1رRCLP
עXTLF쳣ͣʱԶʹRCLP غ */
extern void VRTC_RCLPCR_RCLP_OFF_Setable(FunState NewState);
extern FunState VRTC_RCLPCR_RCLP_OFF_Getable(void);

/* RCLPУֵĴ
0000 0000Ƶ
1111 1111Ƶ غ */
extern void VRTC_RCLPTR_Write(uint32_t SetValue);
extern uint32_t VRTC_RCLPTR_Read(void);
extern void VRTC_XTLFCR_XTLFIPW_Set(uint32_t SetValue);
extern uint32_t VRTC_XTLFCR_XTLFIPW_Get(void);

/* ADCʱѡĴ
000RCMF
001RCMF/2
010RCMF/4
011RCMF/8
100RCMF/16
101RCMF/32
110RCLP
111XTLF غ */
extern void VRTC_ADCCR_CKS_Set(uint32_t SetValue);
extern uint32_t VRTC_ADCCR_CKS_Get(void);

/* ADCʱʹ
0رADCʱ
1ʹADCʱ غ */
extern void VRTC_ADCCR_CKE_Setable(FunState NewState);
extern FunState VRTC_ADCCR_CKE_Getable(void);

/* XTLFƵⱨжʹܣ1Ч غ */
extern void VRTC_LFDIER_LFDET_IE_Setable(FunState NewState);
extern FunState VRTC_LFDIER_LFDET_IE_Getable(void);

/* Ƶͣ״̬
1XTLF
0XTLFͣ غ */
extern FlagStatus VRTC_LFDISR_LFDETO_Chk(void);

/* Ƶͣжϱ־ĴXTLFͣʱӲ첽λд1㣻ֻLFDETOΪ0²ܹ˼Ĵ غ */
extern void VRTC_LFDISR_LFDET_IF_Clr(void);
extern FlagStatus VRTC_LFDISR_LFDET_IF_Chk(void);

extern void VRTC_Init_RCMF_Trim(void);
//Announce_End
#ifdef __cplusplus
}
#endif

#endif /* __FM33A0XXEV_VRTC_H */
