/**
  ******************************************************************************
  * @file    fm33a0xxev_wwdt.h
  * @author  FM33A0XXEV Application Team
  * @version V1.0.0
  * @date    16-April-2020
  * @brief   This file contains all the functions prototypes for the WWDT firmware library.  
  ******************************************************************************
  */
  
/* Define to prevent recursive inclusion -------------------------------------*/

#ifndef __FM33A0XXEV_WWDT_H
#define __FM33A0XXEV_WWDT_H


#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/

#include "FM33A0XXEV.h" 
   
#define	WWDT_CR_CON_Pos	0	/* CPU˵ַд0x5AʱWWDTʱ (WWDT Control,write only)
WWDT󣬵CPU˵ַд0xACʱ */
#define	WWDT_CR_CON_Msk	(0xffU << WWDT_CR_CON_Pos)

#define	WWDT_CFGR_CFG_Pos	0	/* WWDTŹʱ䣬λֵ011ϵϵͳʱĬΪ8MhzĬڴԼ32ms (WWDT Config)
000TPCLK * 4096 * 1
001TPCLK * 4096 * 4
010TPCLK * 4096 * 16
011TPCLK * 4096 * 64
100TPCLK * 4096 * 128
101TPCLK * 4096 * 256
110TPCLK * 4096 * 512
111TPCLK * 4096 * 1024 */
#define	WWDT_CFGR_CFG_Msk	(0x7U << WWDT_CFGR_CFG_Pos)

#define	WWDT_CNTR_CNT_Pos	0	/* WWDTĴֵͨѯ˼Ĵ˽WWDTʱ (WWDT Counter value,read only) */
#define	WWDT_CNTR_CNT_Msk	(0x3ffU << WWDT_CNTR_CNT_Pos)

#define	WWDT_IER_IE_Pos	0	/* WWDTжʹ (WWDT Interrupt Enable)
0жʹֹܽ
1жʹܴ */
#define	WWDT_IER_IE_Msk	(0x1U << WWDT_IER_IE_Pos)
	/* жʹֹܽ */
	/* жʹܴ */

#define	WWDT_ISR_NOVF_Pos	0	/* WWDT 75%ʱжϱ־д1 (Near Overflow Flag,write 1 to clear)
0жϲ
1жϱ־λ
IE=1˼Ĵλж */
#define	WWDT_ISR_NOVF_Msk	(0x1U << WWDT_ISR_NOVF_Pos)

#define	WWDT_PSCR_DIV_CNT_Pos	0	/* WWDT4096ԤƵǰֵֻ (WWDT prescaler Divider Counte,read only) */
#define	WWDT_PSCR_DIV_CNT_Msk	(0xfffU << WWDT_PSCR_DIV_CNT_Pos)
//Macro_End

/* Exported functions --------------------------------------------------------*/ 
extern void WWDT_Deinit(void);

/* CPU˵ַд0x5AʱWWDTʱ (WWDT Control,write only)
WWDT󣬵CPU˵ַд0xACʱ غ */
extern void WWDT_CR_Write(uint32_t SetValue);

/* WWDTŹʱ䣬λֵ011ϵϵͳʱĬΪ8MhzĬڴԼ32ms (WWDT Config)
000TPCLK * 4096 * 1
001TPCLK * 4096 * 4
010TPCLK * 4096 * 16
011TPCLK * 4096 * 64
100TPCLK * 4096 * 128
101TPCLK * 4096 * 256
110TPCLK * 4096 * 512
111TPCLK * 4096 * 1024 غ */
extern void WWDT_CFGR_Write(uint32_t SetValue);
extern uint32_t WWDT_CFGR_Read(void);

/* WWDTĴֵͨѯ˼Ĵ˽WWDTʱ (WWDT Counter value,read only) غ */
extern uint32_t WWDT_CNTR_Read(void);

/* WWDTжʹ (WWDT Interrupt Enable)
0жʹֹܽ
1жʹܴ غ */
extern void WWDT_IER_IE_Setable(FunState NewState);
extern FunState WWDT_IER_IE_Getable(void);

/* WWDT 75%ʱжϱ־д1 (Near Overflow Flag,write 1 to clear)
0жϲ
1жϱ־λ
IE=1˼Ĵλж غ */
extern void WWDT_ISR_NOVF_Clr(void);
extern FlagStatus WWDT_ISR_NOVF_Chk(void);

/* WWDT4096ԤƵǰֵֻ (WWDT prescaler Divider Counte,read only) غ */
extern uint32_t WWDT_PSCR_Read(void);
//Announce_End
#ifdef __cplusplus
}
#endif

#endif /* __FM33A0XXEV_WWDT_H */
