/**
  ******************************************************************************
  * @file    fm33a0xxev_comp.c
  * @author  FM33A0XXEV Application Team
  * @version V1.0.0
  * @date    16-April-2020
  * @brief   This file provides firmware functions to manage the following 
  *          functionalities of....:
  *
*/

/* Includes ------------------------------------------------------------------*/

#include "fm33a0xxev_comp.h"

/** @addtogroup fm33a0xxev_StdPeriph_Driver
  * @{
  */

/** @defgroup COMP 
  * @brief COMP driver modules
  * @{
  */ 

/* Ƚ1˲üĴ˲DFLEN+1
000103APBCLK

1111132APBCLK غ */
void COMP_CR1_DFLEN_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = COMP->CR1;
	tmpreg &= ~(COMP_CR1_DFLEN_Msk);
	tmpreg |= (SetValue & COMP_CR1_DFLEN_Msk);
	COMP->CR1 = tmpreg;
}

uint32_t COMP_CR1_DFLEN_Get(void)
{
	return (COMP->CR1 & COMP_CR1_DFLEN_Msk);
}

/* Ƚ1ģʽƼĴ
0ֹģʽ
1ʹܴģʽ غ */
void COMP_CR1_WINMODE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		COMP->CR1 |= (COMP_CR1_WINMODE_Msk);
	}
	else
	{
		COMP->CR1 &= ~(COMP_CR1_WINMODE_Msk);
	}
}

FunState COMP_CR1_WINMODE_Getable(void)
{
	if (COMP->CR1 & (COMP_CR1_WINMODE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* Ƚ1Կ
0
1ȡ غ */
void COMP_CR1_POLAR_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = COMP->CR1;
	tmpreg &= ~(COMP_CR1_POLAR_Msk);
	tmpreg |= (SetValue & COMP_CR1_POLAR_Msk);
	COMP->CR1 = tmpreg;
}

uint32_t COMP_CR1_POLAR_Get(void)
{
	return (COMP->CR1 & COMP_CR1_POLAR_Msk);
}

/* Ƚ1˲ʹ
0ֹ˲
1ʹ˲ غ */
void COMP_CR1_DFEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		COMP->CR1 |= (COMP_CR1_DFEN_Msk);
	}
	else
	{
		COMP->CR1 &= ~(COMP_CR1_DFEN_Msk);
	}
}

FunState COMP_CR1_DFEN_Getable(void)
{
	if (COMP->CR1 & (COMP_CR1_DFEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* Ƚ1˲ǰֻ غ */
FlagStatus COMP_CR1_CMP1OR_Chk(void)
{
	if (COMP->CR1 & COMP_CR1_CMP1OR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* Ƚ1˲󣩣ֻ غ */
FlagStatus COMP_CR1_CMP1OF_Chk(void)
{
	if (COMP->CR1 & COMP_CR1_CMP1OF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* Ƚ1ѡ
000COMP1_INN1
001COMP1_INN2
010VREF
0113/4 VREF
1001/2 VREF
1011/4 VREF
1101/8 VREF
111RFU غ */
void COMP_CR1_V1NSEL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = COMP->CR1;
	tmpreg &= ~(COMP_CR1_V1NSEL_Msk);
	tmpreg |= (SetValue & COMP_CR1_V1NSEL_Msk);
	COMP->CR1 = tmpreg;
}

uint32_t COMP_CR1_V1NSEL_Get(void)
{
	return (COMP->CR1 & COMP_CR1_V1NSEL_Msk);
}

/* Ƚ1ѡ
00COMP1_INP1
01COMP1_INP2
10COMP1_INP3
11COMP1_INP4 غ */
void COMP_CR1_V1PSEL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = COMP->CR1;
	tmpreg &= ~(COMP_CR1_V1PSEL_Msk);
	tmpreg |= (SetValue & COMP_CR1_V1PSEL_Msk);
	COMP->CR1 = tmpreg;
}

uint32_t COMP_CR1_V1PSEL_Get(void)
{
	return (COMP->CR1 & COMP_CR1_V1PSEL_Msk);
}

/* Ƚ1ʹλ
0رձȽ1
1ʹܱȽ1 غ */
void COMP_CR1_CMP1EN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		COMP->CR1 |= (COMP_CR1_CMP1EN_Msk);
	}
	else
	{
		COMP->CR1 &= ~(COMP_CR1_CMP1EN_Msk);
	}
}

FunState COMP_CR1_CMP1EN_Getable(void)
{
	if (COMP->CR1 & (COMP_CR1_CMP1EN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* Ƚ2˲üĴ˲DFLEN+1
000103APBCLK

1111132APBCLK غ */
void COMP_CR2_DFLEN_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = COMP->CR2;
	tmpreg &= ~(COMP_CR2_DFLEN_Msk);
	tmpreg |= (SetValue & COMP_CR2_DFLEN_Msk);
	COMP->CR2 = tmpreg;
}

uint32_t COMP_CR2_DFLEN_Get(void)
{
	return (COMP->CR2 & COMP_CR2_DFLEN_Msk);
}

/* Ƚ2˲ʹ
0ֹ˲
1ʹ˲ غ */
void COMP_CR2_DFEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		COMP->CR2 |= (COMP_CR2_DFEN_Msk);
	}
	else
	{
		COMP->CR2 &= ~(COMP_CR2_DFEN_Msk);
	}
}

FunState COMP_CR2_DFEN_Getable(void)
{
	if (COMP->CR2 & (COMP_CR2_DFEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}


/* Ƚ2ģʽƼĴ
0ֹģʽ
1ʹܴģʽ غ */
void COMP_CR2_WINMODE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		COMP->CR2 |= (COMP_CR2_WINMODE_Msk);
	}
	else
	{
		COMP->CR2 &= ~(COMP_CR2_WINMODE_Msk);
	}
}

FunState COMP_CR2_WINMODE_Getable(void)
{
	if (COMP->CR2 & (COMP_CR2_WINMODE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* Ƚ2Կ
0
1ȡ غ */
void COMP_CR2_POLAR_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = COMP->CR2;
	tmpreg &= ~(COMP_CR2_POLAR_Msk);
	tmpreg |= (SetValue & COMP_CR2_POLAR_Msk);
	COMP->CR2 = tmpreg;
}

uint32_t COMP_CR2_POLAR_Get(void)
{
	return (COMP->CR2 & COMP_CR2_POLAR_Msk);
}


/* Ƚ1˲ǰֻ غ */
FlagStatus COMP_CR2_CMP2OR_Chk(void)
{
	if (COMP->CR2 & COMP_CR2_CMP2OR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* Ƚ1˲󣩣ֻ غ */
FlagStatus COMP_CR2_CMP2OF_Chk(void)
{
	if (COMP->CR2 & COMP_CR2_CMP2OF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}


/* Ƚ2˲ǰֻ غ */
/* Ƚ2˲󣩣ֻ غ */
/* Ƚ2ѡ
000COMP2_INN1
001COMP2_INN2
010VREF
0113/4 VREF
1001/2 VREF
1011/4 VREF
1101/8 VREF
111RFU */
void COMP_CR2_V2NSEL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = COMP->CR2;
	tmpreg &= ~(COMP_CR2_V2NSEL_Msk);
	tmpreg |= (SetValue & COMP_CR2_V2NSEL_Msk);
	COMP->CR2 = tmpreg;
}

uint32_t COMP_CR2_V2NSEL_Get(void)
{
	return (COMP->CR2 & COMP_CR2_V2NSEL_Msk);
}

/* Ƚ2ѡ
000COMP2_INP1
001COMP2_INP2
010COMP1_INP1
011COMP1_INP2
100AVREF
101VDD15
110, 111RFU غ */
void COMP_CR2_V2PSEL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = COMP->CR2;
	tmpreg &= ~(COMP_CR2_V2PSEL_Msk);
	tmpreg |= (SetValue & COMP_CR2_V2PSEL_Msk);
	COMP->CR2 = tmpreg;
}

uint32_t COMP_CR2_V2PSEL_Get(void)
{
	return (COMP->CR2 & COMP_CR2_V2PSEL_Msk);
}

/* Ƚ2ʹλ
0رձȽ2
1ʹܱȽ2 غ */
void COMP_CR2_CMP2EN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		COMP->CR2 |= (COMP_CR2_CMP2EN_Msk);
	}
	else
	{
		COMP->CR2 &= ~(COMP_CR2_CMP2EN_Msk);
	}
}

FunState COMP_CR2_CMP2EN_Getable(void)
{
	if (COMP->CR2 & (COMP_CR2_CMP2EN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* Out-Of-Windowжʹ غ */
void COMP_ICR_OOW_IE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		COMP->ICR |= (COMP_ICR_OOW_IE_Msk);
	}
	else
	{
		COMP->ICR &= ~(COMP_ICR_OOW_IE_Msk);
	}
}

FunState COMP_ICR_OOW_IE_Getable(void)
{
	if (COMP->ICR & (COMP_ICR_OOW_IE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* Windowжʹ غ */
void COMP_ICR_WIN_IE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		COMP->ICR |= (COMP_ICR_WIN_IE_Msk);
	}
	else
	{
		COMP->ICR &= ~(COMP_ICR_WIN_IE_Msk);
	}
}

FunState COMP_ICR_WIN_IE_Getable(void)
{
	if (COMP->ICR & (COMP_ICR_WIN_IE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* ȽBuffer Bypass
0BypassȽBuffer
1BypassȽBuffer غ */
void COMP_ICR_BUFBYP_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		COMP->ICR |= (COMP_ICR_BUFBYP_Msk);
	}
	else
	{
		COMP->ICR &= ~(COMP_ICR_BUFBYP_Msk);
	}
}

FunState COMP_ICR_BUFBYP_Getable(void)
{
	if (COMP->ICR & (COMP_ICR_BUFBYP_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* ȽBufferʹ
0ʹܱȽBuffer
1ֹȽBuffer غ */
void COMP_ICR_BUF_OFF_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		COMP->ICR |= (COMP_ICR_BUF_OFF_Msk);
	}
	else
	{
		COMP->ICR &= ~(COMP_ICR_BUF_OFF_Msk);
	}
}

FunState COMP_ICR_BUF_OFF_Getable(void)
{
	if (COMP->ICR & (COMP_ICR_BUF_OFF_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* Ƚ2жԴѡ
00/11Ƚ2½زж
01Ƚ2زж
10Ƚ2½زж غ */
void COMP_ICR_CMP2SEL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = COMP->ICR;
	tmpreg &= ~(COMP_ICR_CMP2SEL_Msk);
	tmpreg |= (SetValue & COMP_ICR_CMP2SEL_Msk);
	COMP->ICR = tmpreg;
}

uint32_t COMP_ICR_CMP2SEL_Get(void)
{
	return (COMP->ICR & COMP_ICR_CMP2SEL_Msk);
}

/* Ƚ1жԴѡ
00/11Ƚ1½زж
01Ƚ1زж
10Ƚ1½زж غ */
void COMP_ICR_CMP1SEL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = COMP->ICR;
	tmpreg &= ~(COMP_ICR_CMP1SEL_Msk);
	tmpreg |= (SetValue & COMP_ICR_CMP1SEL_Msk);
	COMP->ICR = tmpreg;
}

uint32_t COMP_ICR_CMP1SEL_Get(void)
{
	return (COMP->ICR & COMP_ICR_CMP1SEL_Msk);
}

/* Ƚ2жʹ غ */
void COMP_ICR_CMP2IE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		COMP->ICR |= (COMP_ICR_CMP2IE_Msk);
	}
	else
	{
		COMP->ICR &= ~(COMP_ICR_CMP2IE_Msk);
	}
}

FunState COMP_ICR_CMP2IE_Getable(void)
{
	if (COMP->ICR & (COMP_ICR_CMP2IE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* Ƚ1жʹ غ */
void COMP_ICR_CMP1IE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		COMP->ICR |= (COMP_ICR_CMP1IE_Msk);
	}
	else
	{
		COMP->ICR &= ~(COMP_ICR_CMP1IE_Msk);
	}
}

FunState COMP_ICR_CMP1IE_Getable(void)
{
	if (COMP->ICR & (COMP_ICR_CMP1IE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* Out-of-Windowжϱ־Ӳλд1 غ */
void COMP_ISR_OOW_IF_Clr(void)
{
	COMP->ISR = COMP_ISR_OOW_IF_Msk;
}

FlagStatus COMP_ISR_OOW_IF_Chk(void)
{
	if (COMP->ISR & COMP_ISR_OOW_IF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* Windowжϱ־Ӳλд1 غ */
void COMP_ISR_WIN_IF_Clr(void)
{
	COMP->ISR = COMP_ISR_WIN_IF_Msk;
}

FlagStatus COMP_ISR_WIN_IF_Chk(void)
{
	if (COMP->ISR & COMP_ISR_WIN_IF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* Ƚ2жϱ־Ӳλд1 غ */
void COMP_ISR_CMP2IF_Clr(void)
{
	COMP->ISR = COMP_ISR_CMP2IF_Msk;
}

FlagStatus COMP_ISR_CMP2IF_Chk(void)
{
	if (COMP->ISR & COMP_ISR_CMP2IF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* Ƚ1жϱ־Ӳλд1 غ */
void COMP_ISR_CMP1IF_Clr(void)
{
	COMP->ISR = COMP_ISR_CMP1IF_Msk;
}

FlagStatus COMP_ISR_CMP1IF_Chk(void)
{
	if (COMP->ISR & COMP_ISR_CMP1IF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* ȽBUFFERģʽ
0͹ģʽ
1ģʽ غ */
void COMP_PCR_HSCMPBUF_EN_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = COMP->PCR;
	tmpreg &= ~(COMP_PCR_HSCMPBUF_EN_Msk);
	tmpreg |= (SetValue & COMP_PCR_HSCMPBUF_EN_Msk);
	COMP->PCR = tmpreg;
}

uint32_t COMP_PCR_HSCMPBUF_EN_Get(void)
{
	return (COMP->PCR & COMP_PCR_HSCMPBUF_EN_Msk);
}


/* Ƚ2ģʽ
0͹ģʽ
1ģʽ غ */
void COMP_PCR_HSCMP2_EN_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = COMP->PCR;
	tmpreg &= ~(COMP_PCR_HSCMP2_EN_Msk);
	tmpreg |= (SetValue & COMP_PCR_HSCMP2_EN_Msk);
	COMP->PCR = tmpreg;
}

uint32_t COMP_PCR_HSCMP2_EN_Get(void)
{
	return (COMP->PCR & COMP_PCR_HSCMP2_EN_Msk);
}

/* Ƚ1ģʽ
0͹ģʽ
1ģʽ غ */
void COMP_PCR_HSCMP1_EN_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = COMP->PCR;
	tmpreg &= ~(COMP_PCR_HSCMP1_EN_Msk);
	tmpreg |= (SetValue & COMP_PCR_HSCMP1_EN_Msk);
	COMP->PCR = tmpreg;
}

uint32_t COMP_PCR_HSCMP1_EN_Get(void)
{
	return (COMP->PCR & COMP_PCR_HSCMP1_EN_Msk);
}

void COMP_Deinit(void)
{
	//COMP->CR1 = 0x00000000;
	//COMP->CR2 = 0x00000000;
	//COMP->ICR = ;
	//COMP->ISR = 0x00000000;
}
/******END OF FILE****/
