/**
  ******************************************************************************
  * @file    fm33a0xxev_dbg.c
  * @author  FM33A0XXEV Application Team
  * @version V1.0.0
  * @date    16-April-2020
  * @brief   This file provides firmware functions to manage the following 
  *          functionalities of....:
  *
*/

/* Includes ------------------------------------------------------------------*/

#include "fm33a0xxev_dbg.h"

/** @addtogroup fm33a0xxev_StdPeriph_Driver
  * @{
  */

/** @defgroup DBG 
  * @brief DBG driver modules
  * @{
  */ 
  
/* Debug״̬LPTIMʹܿλ
1DebugʱرLPTIM
0DebugʱLPTIMԭ״̬ غ */
void DBG_CR_DBG_LPT_STOP_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		DBG->CR |= (DBG_CR_DBG_LPT_STOP_Msk);
	}
	else
	{
		DBG->CR &= ~(DBG_CR_DBG_LPT_STOP_Msk);
	}
}

FunState DBG_CR_DBG_LPT_STOP_Getable(void)
{
	if (DBG->CR & (DBG_CR_DBG_LPT_STOP_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* Debug״̬BSTIMʹܿλ
1DebugʱرBSTIM
0DebugʱBSTIMԭ״̬ غ */
void DBG_CR_DBG_BST_STOP_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		DBG->CR |= (DBG_CR_DBG_BST_STOP_Msk);
	}
	else
	{
		DBG->CR &= ~(DBG_CR_DBG_BST_STOP_Msk);
	}
}

FunState DBG_CR_DBG_BST_STOP_Getable(void)
{
	if (DBG->CR & (DBG_CR_DBG_BST_STOP_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* Debug״̬ET4ʹܿλ
1DebugʱرET4
0DebugʱET4ԭ״̬ غ */
void DBG_CR_DBG_ET4_STOP_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		DBG->CR |= (DBG_CR_DBG_ET4_STOP_Msk);
	}
	else
	{
		DBG->CR &= ~(DBG_CR_DBG_ET4_STOP_Msk);
	}
}

FunState DBG_CR_DBG_ET4_STOP_Getable(void)
{
	if (DBG->CR & (DBG_CR_DBG_ET4_STOP_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* Debug״̬ET3ʹܿλ
1DebugʱرET3
0DebugʱET3ԭ״̬ غ */
void DBG_CR_DBG_ET3_STOP_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		DBG->CR |= (DBG_CR_DBG_ET3_STOP_Msk);
	}
	else
	{
		DBG->CR &= ~(DBG_CR_DBG_ET3_STOP_Msk);
	}
}

FunState DBG_CR_DBG_ET3_STOP_Getable(void)
{
	if (DBG->CR & (DBG_CR_DBG_ET3_STOP_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* Debug״̬ET2ʹܿλ
1DebugʱرET2
0DebugʱET2ԭ״̬ غ */
void DBG_CR_DBG_ET2_STOP_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		DBG->CR |= (DBG_CR_DBG_ET2_STOP_Msk);
	}
	else
	{
		DBG->CR &= ~(DBG_CR_DBG_ET2_STOP_Msk);
	}
}

FunState DBG_CR_DBG_ET2_STOP_Getable(void)
{
	if (DBG->CR & (DBG_CR_DBG_ET2_STOP_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* Debug״̬ET1ʹܿλ
1DebugʱرET1
0DebugʱET1ԭ״̬ غ */
void DBG_CR_DBG_ET1_STOP_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		DBG->CR |= (DBG_CR_DBG_ET1_STOP_Msk);
	}
	else
	{
		DBG->CR &= ~(DBG_CR_DBG_ET1_STOP_Msk);
	}
}

FunState DBG_CR_DBG_ET1_STOP_Getable(void)
{
	if (DBG->CR & (DBG_CR_DBG_ET1_STOP_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* Debug״̬BT2ʹܿλ
1DebugʱرBT2
0DebugʱBT2ԭ״̬ غ */
void DBG_CR_DBG_BT2_STOP_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		DBG->CR |= (DBG_CR_DBG_BT2_STOP_Msk);
	}
	else
	{
		DBG->CR &= ~(DBG_CR_DBG_BT2_STOP_Msk);
	}
}

FunState DBG_CR_DBG_BT2_STOP_Getable(void)
{
	if (DBG->CR & (DBG_CR_DBG_BT2_STOP_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* Debug״̬BT1ʹܿλ
1DebugʱرBT1
0DebugʱBT1ԭ״̬ غ */
void DBG_CR_DBG_BT1_STOP_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		DBG->CR |= (DBG_CR_DBG_BT1_STOP_Msk);
	}
	else
	{
		DBG->CR &= ~(DBG_CR_DBG_BT1_STOP_Msk);
	}
}

FunState DBG_CR_DBG_BT1_STOP_Getable(void)
{
	if (DBG->CR & (DBG_CR_DBG_BT1_STOP_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* Debug״̬WWDTʹܿλ
1DebugʱرWWDT
0DebugʱWWDTԭ״̬ غ */
void DBG_CR_DBG_WWDT_STOP_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		DBG->CR |= (DBG_CR_DBG_WWDT_STOP_Msk);
	}
	else
	{
		DBG->CR &= ~(DBG_CR_DBG_WWDT_STOP_Msk);
	}
}

FunState DBG_CR_DBG_WWDT_STOP_Getable(void)
{
	if (DBG->CR & (DBG_CR_DBG_WWDT_STOP_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* Debug״̬IWDTʹܿλ
1DebugʱرIWDT
0DebugʱIWDT غ */
void DBG_CR_DBG_IWDT_STOP_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		DBG->CR |= (DBG_CR_DBG_IWDT_STOP_Msk);
	}
	else
	{
		DBG->CR &= ~(DBG_CR_DBG_IWDT_STOP_Msk);
	}
}

FunState DBG_CR_DBG_IWDT_STOP_Getable(void)
{
	if (DBG->CR & (DBG_CR_DBG_IWDT_STOP_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* ַǶʴ־д1
1ַǶʴ
0δеַǶ غ */
void DBG_HDFR_DABORT_ADDR_FLAG_Clr(void)
{
	DBG->HDFR = DBG_HDFR_DABORT_ADDR_FLAG_Msk;
}

FlagStatus DBG_HDFR_DABORT_ADDR_FLAG_Chk(void)
{
	if (DBG->HDFR & DBG_HDFR_DABORT_ADDR_FLAG_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* Ƿַʴ־д1
1ߴз˷ǷַHRESPΪ߲
0δʷǷַ غ */
void DBG_HDFR_DABORT_RESP_FLAG_Clr(void)
{
	DBG->HDFR = DBG_HDFR_DABORT_RESP_FLAG_Msk;
}

FlagStatus DBG_HDFR_DABORT_RESP_FLAG_Chk(void)
{
	if (DBG->HDFR & DBG_HDFR_DABORT_RESP_FLAG_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* SVC instructionsδ־д1
if the SVCall priority is lower than the currently activelevel, 
or if HardFault or NMI is active, 
or PRIMASK is set,
the core should treat SVC instructions as though theywere UNDEFINED غ */
void DBG_HDFR_SVCUNDEF_FLAG_Clr(void)
{
	DBG->HDFR = DBG_HDFR_SVCUNDEF_FLAG_Msk;
}

FlagStatus DBG_HDFR_SVCUNDEF_FLAG_Chk(void)
{
	if (DBG->HDFR & DBG_HDFR_SVCUNDEF_FLAG_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* ִBKPTָ־д1
1ִBKPTָ
0δִBKPTָ غ */
void DBG_HDFR_BKPT_FLAG_Clr(void)
{
	DBG->HDFR = DBG_HDFR_BKPT_FLAG_Msk;
}

FlagStatus DBG_HDFR_BKPT_FLAG_Chk(void)
{
	if (DBG->HDFR & DBG_HDFR_BKPT_FLAG_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* Thumb-State־д1
1лARM״̬
0Thumb-State غ */
void DBG_HDFR_TBIT_FLAG_Clr(void)
{
	DBG->HDFR = DBG_HDFR_TBIT_FLAG_Msk;
}

FlagStatus DBG_HDFR_TBIT_FLAG_Chk(void)
{
	if (DBG->HDFR & DBG_HDFR_TBIT_FLAG_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* ָ־д1
1ִָ룬ͼXNȡָ
0ָ뱻ִ غ */
void DBG_HDFR_SPECIAL_OP_FLAG_Clr(void)
{
	DBG->HDFR = DBG_HDFR_SPECIAL_OP_FLAG_Msk;
}

FlagStatus DBG_HDFR_SPECIAL_OP_FLAG_Chk(void)
{
	if (DBG->HDFR & DBG_HDFR_SPECIAL_OP_FLAG_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* hardfault־λκ͵hardfaultᵼ¸λλд1
1hardfault 
0hardfault غ */
void DBG_HDFR_HDF_REQUEST_FLAG_Clr(void)
{
	DBG->HDFR = DBG_HDFR_HDF_REQUEST_FLAG_Msk;
}

FlagStatus DBG_HDFR_HDF_REQUEST_FLAG_Chk(void)
{
	if (DBG->HDFR & DBG_HDFR_HDF_REQUEST_FLAG_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}


void DBG_Deinit(void)
{
	//DBG->CR = 0x00003d03;
	//DBG->HDFR = 0x00000000;
}

/******END OF FILE****/
