/**
  ******************************************************************************
  * @file    fm33a0xxev_iwdt.c
  * @author  FM33A0XXEV Application Team
  * @version V1.0.0
  * @date    16-April-2020
  * @brief   This file provides firmware functions to manage the following 
  *          functionalities of....:
  *
*/

/* Includes ------------------------------------------------------------------*/

#include "fm33a0xxev_iwdt.h"

/** @addtogroup fm33a0xxev_StdPeriph_Driver
  * @{
  */

/** @defgroup IWDT 
  * @brief IWDT driver modules
  * @{
  */ 
 
/* IWDT˵ַд0x1234_5A5Aʱ幷 غ */
void IWDT_SERV_IWDTSERV_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = IWDT->SERV;
	tmpreg &= ~(IWDT_SERV_IWDTSERV_Msk);
	tmpreg |= (SetValue & IWDT_SERV_IWDTSERV_Msk);
	IWDT->SERV = tmpreg;
}

/* IWDT
x00125ms
x01500ms
x102s
x118s
˵bit2Ϊ0ʱߺʹöڣbit2Ϊ1ʱߺԶʹ4096s״̬½֧125ms/500ms/2s/8sڡ غ */
void IWDT_CFGR_Write(uint32_t SetValue)
{
	IWDT->CFGR = (SetValue & IWDT_CFGR_IWDTOVP_Msk);
}

uint32_t IWDT_CFGR_Read(void)
{
	return (IWDT->CFGR & IWDT_CFGR_IWDTOVP_Msk);
}

/* IWDTǰֵ غ */
uint32_t IWDT_CNTR_IWDTCNT_Get(void)
{
	return (IWDT->CNTR & IWDT_CNTR_IWDTCNT_Msk);
}


void IWDT_Deinit(void)
{
	//IWDT->SERV = 0x00000000;
	//IWDT->CFGR = 0x00000001;
	//IWDT->CNTR = ;
}

/******END OF FILE****/
