/**
  ******************************************************************************
  * @file    fm33a0xxev_rmu.c
  * @author  FM33A0XXEV Application Team
  * @version V1.0.0
  * @date    16-April-2020
  * @brief   This file provides firmware functions to manage the following 
  *          functionalities of....:
  *
*/

/* Includes ------------------------------------------------------------------*/

#include "fm33a0xxev_rmu.h"

/** @addtogroup fm33a0xxev_StdPeriph_Driver
  * @{
  */

/** @defgroup RMU 
  * @brief RMU driver modules
  * @{
  */ 

/* µ縴λѹ001.5V011.25Vֹʹã101.35V111.4VĬϣ غ */
void RMU_PDRCR_PDRCFG_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = RMU->PDRCR;
	tmpreg &= ~(RMU_PDRCR_PDRCFG_Msk);
	tmpreg |= (SetValue & RMU_PDRCR_PDRCFG_Msk);
	RMU->PDRCR = tmpreg;
}

uint32_t RMU_PDRCR_PDRCFG_Get(void)
{
	return (RMU->PDRCR & RMU_PDRCR_PDRCFG_Msk);
}

/* µ縴λʹ0رµ縴λ1ʹµ縴λ غ */
void RMU_PDRCR_PDREN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->PDRCR |= (RMU_PDRCR_PDREN_Msk);
	}
	else
	{
		RMU->PDRCR &= ~(RMU_PDRCR_PDREN_Msk);
	}
}

FunState RMU_PDRCR_PDREN_Getable(void)
{
	if (RMU->PDRCR & (RMU_PDRCR_PDREN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* µ縴λѹ001.7V011.6VĬϣ101.65V111.75V غ */
void RMU_BORCR_BOR_PDRCFG_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = RMU->BORCR;
	tmpreg &= ~(RMU_BORCR_BOR_PDRCFG_Msk);
	tmpreg |= (SetValue & RMU_BORCR_BOR_PDRCFG_Msk);
	RMU->BORCR = tmpreg;
}

uint32_t RMU_BORCR_BOR_PDRCFG_Get(void)
{
	return (RMU->BORCR & RMU_BORCR_BOR_PDRCFG_Msk);
}

/* BORʹܿƼĴ0ʹBOR1رBOR غ */
void RMU_BORCR_OFF_BOR_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
    RMU->BORCR |= (RMU_BORCR_OFF_BOR_Msk);
	}
	else
	{
		RMU->BORCR &= ~(RMU_BORCR_OFF_BOR_Msk);
	}
}

FunState RMU_BORCR_OFF_BOR_Getable(void)
{
	if (RMU->BORCR & (RMU_BORCR_OFF_BOR_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* LOCKUPλʹ1ʹSC000 LOCKUPλ0SC000 LOCKUPλ غ */
void RMU_RSTCFGR_LKUPRST_EN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->RSTCFGR |= (RMU_RSTCFGR_LKUPRST_EN_Msk);
	}
	else
	{
		RMU->RSTCFGR &= ~(RMU_RSTCFGR_LKUPRST_EN_Msk);
	}
}

FunState RMU_RSTCFGR_LKUPRST_EN_Getable(void)
{
	if (RMU->RSTCFGR & (RMU_RSTCFGR_LKUPRST_EN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* д0x5C5C_AABBȫָλ غ */
void RMU_SOFTRST_Write(uint32_t SetValue)
{
	RMU->SOFTRST = (SetValue);
}

/* NRSTŸλ־Ч غ */
void RMU_RSR_NRSTN_FLAG_Clr(void)
{
	RMU->RSR = RMU_RSR_NRSTN_FLAG_Msk;
}

FlagStatus RMU_RSR_NRSTN_FLAG_Chk(void)
{
	if (RMU->RSR & RMU_RSR_NRSTN_FLAG_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* TESTNŸλ־Ч غ */
void RMU_RSR_TESTN_FLAG_Clr(void)
{
	RMU->RSR = RMU_RSR_TESTN_FLAG_Msk;
}

FlagStatus RMU_RSR_TESTN_FLAG_Chk(void)
{
	if (RMU->RSR & RMU_RSR_TESTN_FLAG_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* ϵ縴λ־Ч غ */
void RMU_RSR_PORN_FLAG_Clr(void)
{
	RMU->RSR = RMU_RSR_PORN_FLAG_Msk;
}

FlagStatus RMU_RSR_PORN_FLAG_Chk(void)
{
	if (RMU->RSR & RMU_RSR_PORN_FLAG_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* µ縴λ־Ч غ */
void RMU_RSR_PDRN_FLAG_Clr(void)
{
	RMU->RSR = RMU_RSR_PDRN_FLAG_Msk;
}

FlagStatus RMU_RSR_PDRN_FLAG_Chk(void)
{
	if (RMU->RSR & RMU_RSR_PDRN_FLAG_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* λ־Ч غ */
void RMU_RSR_SOFTN_FLAG_Clr(void)
{
	RMU->RSR = RMU_RSR_SOFTN_FLAG_Msk;
}

FlagStatus RMU_RSR_SOFTN_FLAG_Chk(void)
{
	if (RMU->RSR & RMU_RSR_SOFTN_FLAG_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* IWDTλ־Ч غ */
void RMU_RSR_IWDTN_FLAG_Clr(void)
{
	RMU->RSR = RMU_RSR_IWDTN_FLAG_Msk;
}

FlagStatus RMU_RSR_IWDTN_FLAG_Chk(void)
{
	if (RMU->RSR & RMU_RSR_IWDTN_FLAG_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* WWDTλ־Ч غ */
void RMU_RSR_WWDTN_FLAG_Clr(void)
{
	RMU->RSR = RMU_RSR_WWDTN_FLAG_Msk;
}

FlagStatus RMU_RSR_WWDTN_FLAG_Chk(void)
{
	if (RMU->RSR & RMU_RSR_WWDTN_FLAG_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* LOOKUPλ־Ч غ */
void RMU_RSR_LKUPN_FLAG_Clr(void)
{
	RMU->RSR = RMU_RSR_LKUPN_FLAG_Msk;
}

FlagStatus RMU_RSR_LKUPN_FLAG_Chk(void)
{
	if (RMU->RSR & RMU_RSR_LKUPN_FLAG_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* NVICλ־Ч غ */
void RMU_RSR_NVICN_FLAG_Clr(void)
{
	RMU->RSR = RMU_RSR_NVICN_FLAG_Msk;
}

FlagStatus RMU_RSR_NVICN_FLAG_Chk(void)
{
	if (RMU->RSR & RMU_RSR_NVICN_FLAG_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* ģ鸴λʹܣ32bitĴֻдԴ˵ַд0x1357_9BDFʹ踴λܣ˺ͨģ鸴λĴλģԴ˵ַдݣر踴λ غ */
void RMU_PRSTEN_Write(uint32_t SetValue)
{
	RMU->PRSTEN = (SetValue);
}

/* HASHģ鸴λд1λд0λ0λ1λ غ */
void RMU_AHBRST_HASHRST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->AHBRST |= (RMU_AHBRST_HASHRST_Msk);
	}
	else
	{
		RMU->AHBRST &= ~(RMU_AHBRST_HASHRST_Msk);
	}
}

FunState RMU_AHBRST_HASHRST_Getable(void)
{
	if (RMU->AHBRST & (RMU_AHBRST_HASHRST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* PAEģ鸴λд1λд0λ0λ1λ غ */
void RMU_AHBRST_PAERST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->AHBRST |= (RMU_AHBRST_PAERST_Msk);
	}
	else
	{
		RMU->AHBRST &= ~(RMU_AHBRST_PAERST_Msk);
	}
}

FunState RMU_AHBRST_PAERST_Getable(void)
{
	if (RMU->AHBRST & (RMU_AHBRST_PAERST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* DMAģ鸴λд1λд0λ0λ1λ غ */
void RMU_AHBRST_DMARST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->AHBRST |= (RMU_AHBRST_DMARST_Msk);
	}
	else
	{
		RMU->AHBRST &= ~(RMU_AHBRST_DMARST_Msk);
	}
}

FunState RMU_AHBRST_DMARST_Getable(void)
{
	if (RMU->AHBRST & (RMU_AHBRST_DMARST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* UART5ģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST1_UART5RST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST1 |= (RMU_APBRST1_UART5RST_Msk);
	}
	else
	{
		RMU->APBRST1 &= ~(RMU_APBRST1_UART5RST_Msk);
	}
}

FunState RMU_APBRST1_UART5RST_Getable(void)
{
	if (RMU->APBRST1 & (RMU_APBRST1_UART5RST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* UART4ģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST1_UART4RST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST1 |= (RMU_APBRST1_UART4RST_Msk);
	}
	else
	{
		RMU->APBRST1 &= ~(RMU_APBRST1_UART4RST_Msk);
	}
}

FunState RMU_APBRST1_UART4RST_Getable(void)
{
	if (RMU->APBRST1 & (RMU_APBRST1_UART4RST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* UART3ģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST1_UART3RST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST1 |= (RMU_APBRST1_UART3RST_Msk);
	}
	else
	{
		RMU->APBRST1 &= ~(RMU_APBRST1_UART3RST_Msk);
	}
}

FunState RMU_APBRST1_UART3RST_Getable(void)
{
	if (RMU->APBRST1 & (RMU_APBRST1_UART3RST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* UART2ģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST1_UART2RST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST1 |= (RMU_APBRST1_UART2RST_Msk);
	}
	else
	{
		RMU->APBRST1 &= ~(RMU_APBRST1_UART2RST_Msk);
	}
}

FunState RMU_APBRST1_UART2RST_Getable(void)
{
	if (RMU->APBRST1 & (RMU_APBRST1_UART2RST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* Timer arrayλд1λд0λ0λ1λ غ */
void RMU_APBRST1_TIMARST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST1 |= (RMU_APBRST1_TIMARST_Msk);
	}
	else
	{
		RMU->APBRST1 &= ~(RMU_APBRST1_TIMARST_Msk);
	}
}

FunState RMU_APBRST1_TIMARST_Getable(void)
{
	if (RMU->APBRST1 & (RMU_APBRST1_TIMARST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* LCDģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST1_LCDRST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST1 |= (RMU_APBRST1_LCDRST_Msk);
	}
	else
	{
		RMU->APBRST1 &= ~(RMU_APBRST1_LCDRST_Msk);
	}
}

FunState RMU_APBRST1_LCDRST_Getable(void)
{
	if (RMU->APBRST1 & (RMU_APBRST1_LCDRST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* U7816ģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST1_U7816RST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST1 |= (RMU_APBRST1_U7816RST_Msk);
	}
	else
	{
		RMU->APBRST1 &= ~(RMU_APBRST1_U7816RST_Msk);
	}
}

FunState RMU_APBRST1_U7816RST_Getable(void)
{
	if (RMU->APBRST1 & (RMU_APBRST1_U7816RST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* SPI3ģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST1_SPI4RST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST1 |= (RMU_APBRST1_SPI4RST_Msk);
	}
	else
	{
		RMU->APBRST1 &= ~(RMU_APBRST1_SPI4RST_Msk);
	}
}

FunState RMU_APBRST1_SPI4RST_Getable(void)
{
	if (RMU->APBRST1 & (RMU_APBRST1_SPI4RST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* SPI2ģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST1_SPI3RST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST1 |= (RMU_APBRST1_SPI3RST_Msk);
	}
	else
	{
		RMU->APBRST1 &= ~(RMU_APBRST1_SPI3RST_Msk);
	}
}

FunState RMU_APBRST1_SPI3RST_Getable(void)
{
	if (RMU->APBRST1 & (RMU_APBRST1_SPI3RST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* SPI2ģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST1_SPI2RST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST1 |= (RMU_APBRST1_SPI2RST_Msk);
	}
	else
	{
		RMU->APBRST1 &= ~(RMU_APBRST1_SPI2RST_Msk);
	}
}

FunState RMU_APBRST1_SPI2RST_Getable(void)
{
	if (RMU->APBRST1 & (RMU_APBRST1_SPI2RST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* EUART0ģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST1_LPUART0RST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST1 |= (RMU_APBRST1_LPUART0RST_Msk);
	}
	else
	{
		RMU->APBRST1 &= ~(RMU_APBRST1_LPUART0RST_Msk);
	}
}

FunState RMU_APBRST1_LPUART0RST_Getable(void)
{
	if (RMU->APBRST1 & (RMU_APBRST1_LPUART0RST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* I2C1ģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST1_I2C1RST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST1 |= (RMU_APBRST1_I2C1RST_Msk);
	}
	else
	{
		RMU->APBRST1 &= ~(RMU_APBRST1_I2C1RST_Msk);
	}
}

FunState RMU_APBRST1_I2C1RST_Getable(void)
{
	if (RMU->APBRST1 & (RMU_APBRST1_I2C1RST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*  _32ģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST1_LPTRST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST1 |= (RMU_APBRST1_LPTRST_Msk);
	}
	else
	{
		RMU->APBRST1 &= ~(RMU_APBRST1_LPTRST_Msk);
	}
}

FunState RMU_APBRST1_LPTRST_Getable(void)
{
	if (RMU->APBRST1 & (RMU_APBRST1_LPTRST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* UART1ģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST2_UART1RST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST2 |= (RMU_APBRST2_UART1RST_Msk);
	}
	else
	{
		RMU->APBRST2 &= ~(RMU_APBRST2_UART1RST_Msk);
	}
}

FunState RMU_APBRST2_UART1RST_Getable(void)
{
	if (RMU->APBRST2 & (RMU_APBRST2_UART1RST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* UART0ģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST2_UART0RST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST2 |= (RMU_APBRST2_UART0RST_Msk);
	}
	else
	{
		RMU->APBRST2 &= ~(RMU_APBRST2_UART0RST_Msk);
	}
}

FunState RMU_APBRST2_UART0RST_Getable(void)
{
	if (RMU->APBRST2 & (RMU_APBRST2_UART0RST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* UARTģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST2_UARTIRRST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST2 |= (RMU_APBRST2_UARTIRRST_Msk);
	}
	else
	{
		RMU->APBRST2 &= ~(RMU_APBRST2_UARTIRRST_Msk);
	}
}

FunState RMU_APBRST2_UARTIRRST_Getable(void)
{
	if (RMU->APBRST2 & (RMU_APBRST2_UARTIRRST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* BSTIMģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST2_BSTRST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST2 |= (RMU_APBRST2_BSTRST_Msk);
	}
	else
	{
		RMU->APBRST2 &= ~(RMU_APBRST2_BSTRST_Msk);
	}
}

FunState RMU_APBRST2_BSTRST_Getable(void)
{
	if (RMU->APBRST2 & (RMU_APBRST2_BSTRST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* CIC˲ģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST2_CICRST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST2 |= (RMU_APBRST2_CICRST_Msk);
	}
	else
	{
		RMU->APBRST2 &= ~(RMU_APBRST2_CICRST_Msk);
	}
}

FunState RMU_APBRST2_CICRST_Getable(void)
{
	if (RMU->APBRST2 & (RMU_APBRST2_CICRST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* ADCģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST2_ADCRST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST2 |= (RMU_APBRST2_ADCRST_Msk);
	}
	else
	{
		RMU->APBRST2 &= ~(RMU_APBRST2_ADCRST_Msk);
	}
}

FunState RMU_APBRST2_ADCRST_Getable(void)
{
	if (RMU->APBRST2 & (RMU_APBRST2_ADCRST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* AESģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST2_AESRST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST2 |= (RMU_APBRST2_AESRST_Msk);
	}
	else
	{
		RMU->APBRST2 &= ~(RMU_APBRST2_AESRST_Msk);
	}
}

FunState RMU_APBRST2_AESRST_Getable(void)
{
	if (RMU->APBRST2 & (RMU_APBRST2_AESRST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* CRCģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST2_CRCRST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST2 |= (RMU_APBRST2_CRCRST_Msk);
	}
	else
	{
		RMU->APBRST2 &= ~(RMU_APBRST2_CRCRST_Msk);
	}
}

FunState RMU_APBRST2_CRCRST_Getable(void)
{
	if (RMU->APBRST2 & (RMU_APBRST2_CRCRST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* RNGģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST2_RNGRST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST2 |= (RMU_APBRST2_RNGRST_Msk);
	}
	else
	{
		RMU->APBRST2 &= ~(RMU_APBRST2_RNGRST_Msk);
	}
}

FunState RMU_APBRST2_RNGRST_Getable(void)
{
	if (RMU->APBRST2 & (RMU_APBRST2_RNGRST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* SPI1ģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST2_SPI1RST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST2 |= (RMU_APBRST2_SPI1RST_Msk);
	}
	else
	{
		RMU->APBRST2 &= ~(RMU_APBRST2_SPI1RST_Msk);
	}
}

FunState RMU_APBRST2_SPI1RST_Getable(void)
{
	if (RMU->APBRST2 & (RMU_APBRST2_SPI1RST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* SPI0ģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST2_SPI0RST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST2 |= (RMU_APBRST2_SPI0RST_Msk);
	}
	else
	{
		RMU->APBRST2 &= ~(RMU_APBRST2_SPI0RST_Msk);
	}
}

FunState RMU_APBRST2_SPI0RST_Getable(void)
{
	if (RMU->APBRST2 & (RMU_APBRST2_SPI0RST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* EUART1ģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST2_LPUART1RST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST2 |= (RMU_APBRST2_LPUART1RST_Msk);
	}
	else
	{
		RMU->APBRST2 &= ~(RMU_APBRST2_LPUART1RST_Msk);
	}
}

FunState RMU_APBRST2_LPUART1RST_Getable(void)
{
	if (RMU->APBRST2 & (RMU_APBRST2_LPUART1RST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* I2C0ģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST2_I2C0RST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST2 |= (RMU_APBRST2_I2C0RST_Msk);
	}
	else
	{
		RMU->APBRST2 &= ~(RMU_APBRST2_I2C0RST_Msk);
	}
}

FunState RMU_APBRST2_I2C0RST_Getable(void)
{
	if (RMU->APBRST2 & (RMU_APBRST2_I2C0RST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* SVDģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST2_SVDRST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST2 |= (RMU_APBRST2_SVDRST_Msk);
	}
	else
	{
		RMU->APBRST2 &= ~(RMU_APBRST2_SVDRST_Msk);
	}
}

FunState RMU_APBRST2_SVDRST_Getable(void)
{
	if (RMU->APBRST2 & (RMU_APBRST2_SVDRST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* Ƚģ鸴λд1λд0λ0λ1λ غ */
void RMU_APBRST2_COMPRST_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RMU->APBRST2 |= (RMU_APBRST2_COMPRST_Msk);
	}
	else
	{
		RMU->APBRST2 &= ~(RMU_APBRST2_COMPRST_Msk);
	}
}

FunState RMU_APBRST2_COMPRST_Getable(void)
{
	if (RMU->APBRST2 & (RMU_APBRST2_COMPRST_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}


void RMU_Deinit(void)
{
	//RMU->PDRCR = 0x00000007;
	//RMU->BORCR = 0x00000002;
	//RMU->RSTCFGR = 0x00000000;
	//RMU->SOFTRST = 0x00000000;
	//RMU->RSR = 0x00000000;
	//RMU->PRSTEN = 0x00000000;
	//RMU->AHBRST = 0x00000000;
	//RMU->APBRST1 = 0x00000000;
	//RMU->APBRST2 = 0x00000000;
}

/******END OF FILE****/
