/**
  ******************************************************************************
  * @file    fm33a0xxev_u7816.c
  * @author  FM33A0XXEV Application Team
  * @version V1.0.0
  * @date    16-April-2020
  * @brief   This file provides firmware functions to manage the following 
  *          functionalities of....:
  *
*/

/* Includes ------------------------------------------------------------------*/

#include "fm33a0xxev_u7816.h"

/** @addtogroup fm33a0xxev_StdPeriph_Driver
  * @{
  */

/** @defgroup U7816 
  * @brief U7816 driver modules
  * @{
  */ 

/* U7816ͨʹܿλ (Transmit Enable)1ͨʹܣɷ0ͨͽֹɷݣض˿ڣSCLźתΪ͵ƽ غ */
void U7816_CR_TXEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816->CR |= (U7816_CR_TXEN_Msk);
	}
	else
	{
		U7816->CR &= ~(U7816_CR_TXEN_Msk);
	}
}

FunState U7816_CR_TXEN_Getable(void)
{
	if (U7816->CR & (U7816_CR_TXEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* U7816ͨʹܿλ (Receive Enable)1ͨʹܣɽ0ͨսֹɽݣض˿ غ */
void U7816_CR_RXEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816->CR |= (U7816_CR_RXEN_Msk);
	}
	else
	{
		U7816->CR &= ~(U7816_CR_RXEN_Msk);
	}
}

FunState U7816_CR_RXEN_Getable(void)
{
	if (U7816->CR & (U7816_CR_RXEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* U7816ʱCLKʹܿλ (Clock output Enable)17816ʱʹ07816ʱֹ غ */
void U7816_CR_CKOEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816->CR |= (U7816_CR_CKOEN_Msk);
	}
	else
	{
		U7816->CR &= ~(U7816_CR_CKOEN_Msk);
	}
}

FunState U7816_CR_CKOEN_Getable(void)
{
	if (U7816->CR & (U7816_CR_CKOEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* U7816ͨݷǿԶЧλ (High-Pullup Automatically)1ݷʱԶЧ̬Ч0ݷʱԶЧֹܽHPUENLPUEN غ */
void U7816_CR_HPUAT_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816->CR |= (U7816_CR_HPUAT_Msk);
	}
	else
	{
		U7816->CR &= ~(U7816_CR_HPUAT_Msk);
	}
}

FunState U7816_CR_HPUAT_Getable(void)
{
	if (U7816->CR & (U7816_CR_HPUAT_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* U7816ͨǿʹܿλ (High-Pullup Enable)1ǿЧ0ǿЧ غ */
void U7816_CR_HPUEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816->CR |= (U7816_CR_HPUEN_Msk);
	}
	else
	{
		U7816->CR &= ~(U7816_CR_HPUEN_Msk);
	}
}

FunState U7816_CR_HPUEN_Getable(void)
{
	if (U7816->CR & (U7816_CR_HPUEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* Guard Timeͳȿλ (Send long Frame Enable)1Guard timeΪ3 etu0Guard timeΪ2 etu غ */
void U7816_FFR_SFREN_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = U7816->FFR;
	tmpreg &= ~(U7816_FFR_SFREN_Msk);
	tmpreg |= (SetValue & U7816_FFR_SFREN_Msk);
	U7816->FFR = tmpreg;
}

uint32_t U7816_FFR_SFREN_Get(void)
{
	return (U7816->FFR & U7816_FFR_SFREN_Msk);
}

/* ERROR SIGNALѡ (Error Signal Width)11ERROR SIGNALΪ1ETU;10ERROR SIGNALΪ1.5ETU;01ERROR SIGNALΪ2ETU;00ERROR SIGNALΪ2ETU; غ */
void U7816_FFR_ERSW_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = U7816->FFR;
	tmpreg &= ~(U7816_FFR_ERSW_Msk);
	tmpreg |= (SetValue & U7816_FFR_ERSW_Msk);
	U7816->FFR = tmpreg;
}

uint32_t U7816_FFR_ERSW_Get(void)
{
	return (U7816->FFR & U7816_FFR_ERSW_Msk);
}

/* ERROR SIGNALGUARDTIMEѡ񣨽ڷʱЧ
(Error Signal Guard Time)1ERROR SIGNALGUARDTIMEΪ1~1.5ETU0ERROR SIGNALGUARDTIMEΪ2~2.5ETUERROR SIGNALΪETUʱGUARDTIMEΪ1.52.5ETUERROR SIGNALΪ1.5ETUʱGUARDTIMEΪ12ETU غ */
void U7816_FFR_ERSGD_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = U7816->FFR;
	tmpreg &= ~(U7816_FFR_ERSGD_Msk);
	tmpreg |= (SetValue & U7816_FFR_ERSGD_Msk);
	U7816->FFR = tmpreg;
}

uint32_t U7816_FFR_ERSGD_Get(void)
{
	return (U7816->FFR & U7816_FFR_ERSGD_Msk);
}

/* BGTλƽ->֮ǷBGTBGTǽ->֮ҪСʱ䣨block guard time enable1BGTʹܣBlock guard time(12 etu);0BGTֹBlock guard time(12 etu); غ */
void U7816_FFR_BGTEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816->FFR |= (U7816_FFR_BGTEN_Msk);
	}
	else
	{
		U7816->FFR &= ~(U7816_FFR_BGTEN_Msk);
	}
}

FunState U7816_FFR_BGTEN_Getable(void)
{
	if (U7816->FFR & (U7816_FFR_BGTEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* ƽżУʱԶط (Repeated Times)1301 غ */
void U7816_FFR_REP_T_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = U7816->FFR;
	tmpreg &= ~(U7816_FFR_REP_T_Msk);
	tmpreg |= (SetValue & U7816_FFR_REP_T_Msk);
	U7816->FFR = tmpreg;
}

uint32_t U7816_FFR_REP_T_Get(void)
{
	return (U7816->FFR & U7816_FFR_REP_T_Msk);
}

/* żУѡ (Parity)00Even01Odd10Always 111У飬 غ */
void U7816_FFR_PAR_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = U7816->FFR;
	tmpreg &= ~(U7816_FFR_PAR_Msk);
	tmpreg |= (SetValue & U7816_FFR_PAR_Msk);
	U7816->FFR = tmpreg;
}

uint32_t U7816_FFR_PAR_Get(void)
{
	return (U7816->FFR & U7816_FFR_PAR_Msk);
}

/* Guard Timeճȿλ (Receive short Frame )1Guard timeΪ1 etu0Guard timeΪ2 etu غ */
void U7816_FFR_RFREN_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = U7816->FFR;
	tmpreg &= ~(U7816_FFR_RFREN_Msk);
	tmpreg |= (SetValue & U7816_FFR_RFREN_Msk);
	U7816->FFR = tmpreg;
}

uint32_t U7816_FFR_RFREN_Get(void)
{
	return (U7816->FFR & U7816_FFR_RFREN_Msk);
}

/* żУĴʽѡ (Transmit Repeat Enable)1յżУ־error signalT0ЭԶлطڵһbyteظʹREP_Ttx_parity_err־ж0յError signalʱԶطtx_parity_err־ֱж غ */
void U7816_FFR_TREPEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816->FFR |= (U7816_FFR_TREPEN_Msk);
	}
	else
	{
		U7816->FFR &= ~(U7816_FFR_TREPEN_Msk);
	}
}

FunState U7816_FFR_TREPEN_Getable(void)
{
	if (U7816->FFR & (U7816_FFR_TREPEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* żУĴʽѡ (Receive Repeat Enable)1żУT=0ЭԶطERROR SIGNALһBYTEմREP_TRX_PARITY_ERR־ж0żУԶERROR SIGNALRX_PARITY_ERR־ж غ */
void U7816_FFR_RREPEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816->FFR |= (U7816_FFR_RREPEN_Msk);
	}
	else
	{
		U7816->FFR &= ~(U7816_FFR_RREPEN_Msk);
	}
}

FunState U7816_FFR_RREPEN_Getable(void)
{
	if (U7816->FFR & (U7816_FFR_RREPEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* 򣬱뷽ʽѡ (bit Direction Conversion)1룬շMSB(շ+Уλ)߼ƽ0룬շLSB  (շ+Уλ)߼ƽ غ */
void U7816_FFR_DICONV_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = U7816->FFR;
	tmpreg &= ~(U7816_FFR_DICONV_Msk);
	tmpreg |= (SetValue & U7816_FFR_DICONV_Msk);
	U7816->FFR = tmpreg;
}

uint32_t U7816_FFR_DICONV_Get(void)
{
	return (U7816->FFR & U7816_FFR_DICONV_Msk);
}

/* ʱExtra Guard Timeʱ䣨ETUΪλ
(Transmit Extra Guard Time) غ */
void U7816_EGTR_Write(uint32_t SetValue)
{
	U7816->EGTR = (SetValue & U7816_EGTR_TXEGT_Msk);
}

uint32_t U7816_EGTR_Read(void)
{
	return (U7816->EGTR & U7816_EGTR_TXEGT_Msk);
}

/* U7816ʱƵƼĴ(Clock Divider)7816ʱӷƵU7816ʱAPBCLKķƵϵF7816=FAPBCLK/(CLKDIV+1)CLK_DIVó01ʱF7816=FAPBCLK/2ע7816Э涨ĹʱӷΧ1~5MHZ غ */
void U7816_PSC_Write(uint32_t SetValue)
{
	U7816->PSC = (SetValue & U7816_PSC_CLKDIV_Msk);
}

uint32_t U7816_PSC_Read(void)
{
	return (U7816->PSC & U7816_PSC_CLKDIV_Msk);
}

/* U7816ԤƵƼĴ(Pre-Divider)7816ͨŷƵȣʣBaud  F7816/(PDIV  1)

ע⣺PDIVСֵ0x1Ӧýֹ0x0 غ */
void U7816_BGR_Write(uint32_t SetValue)
{
	U7816->BGR = (SetValue & U7816_BGR_PDIV_Msk);
}

uint32_t U7816_BGR_Read(void)
{
	return (U7816->BGR & U7816_BGR_PDIV_Msk);
}

/* U7816ݽջĴ (Receive Buffer) غ */
uint32_t U7816_RXBUF_Read(void)
{
	return (U7816->RXBUF & U7816_RXBUF_RXBUF_Msk);
}

/* U7816ݷͻĴ (Transmit Buffer) غ */
void U7816_TXBUF_Write(uint32_t SetValue)
{
	U7816->TXBUF = (SetValue & U7816_TXBUF_TXBUF_Msk);
}

/* ݽжʹλӦRXIFжϱ־λ (Receive Interrupt Enable)1RXIFĴλʱж0ֹж غ */
void U7816_IER_RXIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816->IER |= (U7816_IER_RXIE_Msk);
	}
	else
	{
		U7816->IER &= ~(U7816_IER_RXIE_Msk);
	}
}

FunState U7816_IER_RXIE_Getable(void)
{
	if (U7816->IER & (U7816_IER_RXIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* ݷжʹλӦTXIFжϱ־λ(Transmit Interrupt Enable)1TXIFĴλʱж0ֹж غ */
void U7816_IER_TXIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816->IER |= (U7816_IER_TXIE_Msk);
	}
	else
	{
		U7816->IER &= ~(U7816_IER_TXIE_Msk);
	}
}

FunState U7816_IER_TXIE_Getable(void)
{
	if (U7816->IER & (U7816_IER_TXIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* ·״̬жʹλӦERRIFжϱ־λ(Line Status Interrupt Enable)1ERRIFĴλʱ·ж0ֹ·ж غ */
void U7816_IER_LSIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816->IER |= (U7816_IER_LSIE_Msk);
	}
	else
	{
		U7816->IER &= ~(U7816_IER_LSIE_Msk);
	}
}

FunState U7816_IER_LSIE_Getable(void)
{
	if (U7816->IER & (U7816_IER_LSIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* U7816ӿڷ˴źţڵȴԷطݣ(Waiting for Repeat flag)״̬뷢ʹź״̬ʱλյʼλ߽뷢״̬ʱӲ㣻ֻ غ */
FlagStatus U7816_ISR_WAIT_RPT_Chk(void)
{
	if (U7816->ISR & U7816_ISR_WAIT_RPT_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* æ־ɺԶ㣩(Transmission busy flag)1ݷ״̬λĴڷݡʼʼλ1ֹͣλм㣩0ݷͿ غ */
FlagStatus U7816_ISR_TXBUSY_Chk(void)
{
	if (U7816->ISR & U7816_ISR_TXBUSY_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* æ־ɺԶ㣩(Receiving busy flag)1ݽ״̬λĴڽݡյʼλ1յֹͣλ㣬ݳططerror signalʱ㡣ݼУλ֮ǷҪطҪʱñ־0ݽտ غ */
FlagStatus U7816_ISR_RXBUSY_Chk(void)
{
	if (U7816->ISR & U7816_ISR_RXBUSY_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* żУ־λӲλд1 (Transmit Parity Error,write 1 to clear) غ */
void U7816_ISR_TPARERR_Clr(void)
{
	U7816->ISR = U7816_ISR_TPARERR_Msk;
}

FlagStatus U7816_ISR_TPARERR_Chk(void)
{
	if (U7816->ISR & U7816_ISR_TPARERR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* żУ־λӲλд1 (Receive Parity Error flag,write 1 to clear) غ */
void U7816_ISR_RPARERR_Clr(void)
{
	U7816->ISR = U7816_ISR_RPARERR_Msk;
}

FlagStatus U7816_ISR_RPARERR_Chk(void)
{
	if (U7816->ISR & U7816_ISR_RPARERR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* ֡ʽ־λӲλд1 (Frame Error flag,write 1 to clear)1֡ʽд󣬽յframeֽڳյframestopλ0ʱżУ غ */
void U7816_ISR_FRERR_Clr(void)
{
	U7816->ISR = U7816_ISR_FRERR_Msk;
}

FlagStatus U7816_ISR_FRERR_Chk(void)
{
	if (U7816->ISR & U7816_ISR_FRERR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* ־λӲλд1 (Receive Overflow Error,write 1 to clear)1ջĴδֽյµݣ־ЧԭջĴݱ¸0 غ */
void U7816_ISR_OVERR_Clr(void)
{
	U7816->ISR = U7816_ISR_OVERR_Msk;
}

FlagStatus U7816_ISR_OVERR_Chk(void)
{
	if (U7816->ISR & U7816_ISR_OVERR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* ɱ־(Receive interrupt flag)U7816ӿڿÿյ1byteݣݽյͨӦһжϡӲλݽջĴ1յ1byteݣݽջ0δյݣݽջ غ */
FlagStatus U7816_ISR_RXIF_Chk(void)
{
	if (U7816->ISR & U7816_ISR_RXIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* ͻձ־(Transmit interrupt flag)ϵ縴λ˱־Զλʾգдݡдݺ־ԶݴӷͻλĴ11ݷͻ0ݷͻݴ غ */
FlagStatus U7816_ISR_TXIF_Chk(void)
{
	if (U7816->ISR & U7816_ISR_TXIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* ־(Error interrupt flag)ĴóгbitTPARERRRPARERRFRERROVERRĻͨϴ־Ĵbit غ */
FlagStatus U7816_ISR_ERRIF_Chk(void)
{
	if (U7816->ISR & U7816_ISR_ERRIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}


void U7816_Deinit(void)
{
	U7816->CR = 0x00000000;
	U7816->FFR = 0x00000006;
	//U7816->EGTR = 0x00000000;
	//U7816->PSC = 0x00000000;
	//U7816->BGR = 0x00000100;
	//U7816->RXBUF = 0x00000000;
	//U7816->TXBUF = 0x00000000;
	//U7816->IER = 0x00000000;
	//U7816->ISR = 0x00000002;
}


/* U7816ʼ */
/*******************************************
U7816_Init
: U7816ʼ
U7816xU78160U78161
          paraU7816_InitTypeDef
: 
*******************************************/
void U7816_Init(U7816_InitTypeDef* para)
{
	
	U7816_CR_TXEN_Setable(para->TXEN);		//ʹ
	U7816_CR_RXEN_Setable(para->RXEN);		//ʹ
	U7816_CR_CKOEN_Setable(para->CKOEN);		//U7816ʱCLKʹܿ
	U7816_CR_HPUAT_Setable(para->HPUAT);		//U7816ͨݷǿԶЧ
	U7816_CR_HPUEN_Setable(para->HPUEN);		//U7816ͨǿʹܿ
		
	U7816_FFR_ERSW_Set(para->ERSW);		//ERROR SIGNALѡ
	U7816_FFR_ERSGD_Set(para->ERSGD);		//ERROR SIGNALGUARDTIMEѡ񣨽ڷʱЧ
	U7816_FFR_BGTEN_Setable(para->BGTEN);		//BGTblock guard time
	U7816_FFR_REP_T_Set(para->REP_T);		//ƽżУʱԶط
	U7816_FFR_PAR_Set(para->PAR);		//żУѡ
	U7816_FFR_SFREN_Set(para->SFREN);		//Guard TimeȿλʱϸЭ2etu 
  U7816_FFR_RFREN_Set(para->RFREN);   //Guard Timeȿλ
	U7816_FFR_TREPEN_Setable(para->TREPEN);		//żУĴʽѡ
	U7816_FFR_RREPEN_Setable(para->RREPEN);		//żУĴʽѡ
	U7816_FFR_DICONV_Set(para->DICONV);		//ʹ
	
	U7816_EGTR_Write(para->TXEGT);		//ʱEGTʱ䣨ETUΪλ
	U7816_PSC_Write(para->CLKDIV);		//U7816ʱƵƼĴ
	U7816_BGR_Write(para->PDIV);		//U7816ԤƵƼĴ7816ͨŷƵȣʣ
	
	U7816_IER_RXIE_Setable(para->RXIE);		//ݽжʹλӦRX_FLAGжϱ־λ
	U7816_IER_TXIE_Setable(para->TXIE);		//ݷжʹλӦTX_FLAGжϱ־λ
	U7816_IER_LSIE_Setable(para->LSIE);		//·״̬жʹλӦERROR_FLAGжϱ־λ
	
}

/******END OF FILE****/
