/**
  ******************************************************************************
  * @file    fm33a0xxev_vrtc.c
  * @author  FM33A0XXEV Application Team
  * @version V1.0.0
  * @date    16-April-2020
  * @brief   This file provides firmware functions to manage the following 
  *          functionalities of....:
  *
*/

/* Includes ------------------------------------------------------------------*/

#include "fm33a0xxev_vrtc.h"

/** @addtogroup fm33a0xxev_StdPeriph_Driver
  * @{
  */

/** @defgroup VRTC 
  * @brief VRTC driver modules
  * @{
  */ 

/* RCMFʹܼĴ
0رRCMF
1ʹRCMF
עʹRTCԶ²RCMFӲ͹ر غ */
void VRTC_RCMFCR_EN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		VRTC->RCMFCR |= (VRTC_RCMFCR_EN_Msk);
	}
	else
	{
		VRTC->RCMFCR &= ~(VRTC_RCMFCR_EN_Msk);
	}
}

FunState VRTC_RCMFCR_EN_Getable(void)
{
	if (VRTC->RCMFCR & (VRTC_RCMFCR_EN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* RCMFƵʵУĴ غ */
void VRTC_RCMFCR_TRIM_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = VRTC->RCMFCR;
	tmpreg &= ~(VRTC_RCMFCR_TRIM_Msk);
	tmpreg |= (SetValue & VRTC_RCMFCR_TRIM_Msk);
	VRTC->RCMFCR = tmpreg;
}

uint32_t VRTC_RCMFCR_TRIM_Get(void)
{
	return (VRTC->RCMFCR & VRTC_RCMFCR_TRIM_Msk);
}

/* Chopperʹ غ */
void VRTC_RCLPCR_CHOPEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		VRTC->RCLPCR |= (VRTC_RCLPCR_CHOPEN_Msk);
	}
	else
	{
		VRTC->RCLPCR &= ~(VRTC_RCLPCR_CHOPEN_Msk);
	}
}

FunState VRTC_RCLPCR_CHOPEN_Getable(void)
{
	if (VRTC->RCLPCR & (VRTC_RCLPCR_CHOPEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* RCLPʹź
0ʹRCLP 
1رRCLP
עXTLF쳣ͣʱԶʹRCLP غ */
void VRTC_RCLPCR_RCLP_OFF_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
    VRTC->RCLPCR |= (VRTC_RCLPCR_RCLP_OFF_Msk);
	}
	else
	{
		VRTC->RCLPCR &= ~(VRTC_RCLPCR_RCLP_OFF_Msk);
	}
}

FunState VRTC_RCLPCR_RCLP_OFF_Getable(void)
{
	if (VRTC->RCLPCR & (VRTC_RCLPCR_RCLP_OFF_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* RCLPУֵĴ
0000 0000Ƶ
1111 1111Ƶ غ */
void VRTC_RCLPTR_Write(uint32_t SetValue)
{
	VRTC->RCLPTR = (SetValue & VRTC_RCLPTR_RCLP_TRIM_Msk);
}

uint32_t VRTC_RCLPTR_Read(void)
{
	return (VRTC->RCLPTR & VRTC_RCLPTR_RCLP_TRIM_Msk);
}

void VRTC_XTLFCR_XTLFIPW_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = VRTC->XTLFCR;
	tmpreg &= ~(VRTC_XTLFCR_XTLFIPW_Msk);
	tmpreg |= (SetValue & VRTC_XTLFCR_XTLFIPW_Msk);
	VRTC->XTLFCR = tmpreg;
}

uint32_t VRTC_XTLFCR_XTLFIPW_Get(void)
{
	return (VRTC->XTLFCR & VRTC_XTLFCR_XTLFIPW_Msk);
}

/* ADCʱѡĴ
000RCMF
001RCMF/2
010RCMF/4
011RCMF/8
100RCMF/16
101RCMF/32
110RCLP
111XTLF غ */
void VRTC_ADCCR_CKS_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = VRTC->ADCCR;
	tmpreg &= ~(VRTC_ADCCR_CKS_Msk);
	tmpreg |= (SetValue & VRTC_ADCCR_CKS_Msk);
	VRTC->ADCCR = tmpreg;
}

uint32_t VRTC_ADCCR_CKS_Get(void)
{
	return (VRTC->ADCCR & VRTC_ADCCR_CKS_Msk);
}

/* ADCʱʹ
0رADCʱ
1ʹADCʱ غ */
void VRTC_ADCCR_CKE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		VRTC->ADCCR |= (VRTC_ADCCR_CKE_Msk);
	}
	else
	{
		VRTC->ADCCR &= ~(VRTC_ADCCR_CKE_Msk);
	}
}

FunState VRTC_ADCCR_CKE_Getable(void)
{
	if (VRTC->ADCCR & (VRTC_ADCCR_CKE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* XTLFƵⱨжʹܣ1Ч غ */
void VRTC_LFDIER_LFDET_IE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		VRTC->LFDIER |= (VRTC_LFDIER_LFDET_IE_Msk);
	}
	else
	{
		VRTC->LFDIER &= ~(VRTC_LFDIER_LFDET_IE_Msk);
	}
}

FunState VRTC_LFDIER_LFDET_IE_Getable(void)
{
	if (VRTC->LFDIER & (VRTC_LFDIER_LFDET_IE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* Ƶͣ״̬
1XTLF
0XTLFͣ غ */
FlagStatus VRTC_LFDISR_LFDETO_Chk(void)
{
	if (VRTC->LFDISR & VRTC_LFDISR_LFDETO_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* Ƶͣжϱ־ĴXTLFͣʱӲ첽λд1㣻ֻLFDETOΪ0²ܹ˼Ĵ غ */
void VRTC_LFDISR_LFDET_IF_Clr(void)
{
	VRTC->LFDISR = VRTC_LFDISR_LFDET_IF_Msk;
}

FlagStatus VRTC_LFDISR_LFDET_IF_Chk(void)
{
	if (VRTC->LFDISR & VRTC_LFDISR_LFDET_IF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*
rcmfУ׼ֵ뺯
:rcmfУ׼ֵ
룺ҪõRCMFƵ
*/
void VRTC_Init_RCMF_Trim(void)
{
	uint32_t Temp32;
	
	Temp32 = const_rcmf_Trim;
	
	if( ((Temp32>>16)&0x0000FFFF) == ((~Temp32)&0x0000FFFF) )	//Уж
	{
		VRTC_RCMFCR_TRIM_Set(Temp32&0x000000FF);
	}	
	else
	{
		VRTC_RCMFCR_TRIM_Set(0x0000001F);
	}
}

void VRTC_Deinit(void)
{
	//VRTC->RCMFCR = 0x00000040;
	//VRTC->RCLPCR = 0x00000000;
	//VRTC->RCLPTR = 0x00000000;
	//VRTC->XTLFCR = ;
	//VRTC->ADCCR = 0x00000004;
	//VRTC->LFDIER = 0x00000000;
	//VRTC->LFDISR = 0x00000000;
}

/******END OF FILE****/
